2005-05-03  Release Manager

	* GCC 3.3.6 Released.

2005-05-01  Roger Sayle  <roger@eyesopen.com>

	PR rtl-optimization/19579
	Backport from mainline
	2005-01-26  Jakub Jelinek  <jakub@redhat.com>
	* ifcvt.c (noce_try_cmove_arith): If emitting instructions to set up
	both A and B, see if they don't clobber registers the other expr uses.

2005-04-30  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR 14884
	* Apply:
	2004-03-25  Joseph S. Myers  <jsm@polyomino.org.uk>

	* fixinc/inclhack.def (rpc_xdr_lvalue_cast_a,
	rpc_xdr_lvalue_cast_b): New fixes.
	* fixinc/tests/base/rpc/xdr.h: Add new tests.

2005-04-30  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* Apply:
	2004-10-21  Aldy Hernandez  <aldyh@redhat.com>

	PR target/18004.
	* expmed.c (store_bit_field): Pass original 'value' before
	recursing.

2005-04-22  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/invoke.texi (SPARC options): Document that -mapp-regs
	is turned off by default on Solaris.

2005-04-06  James E. Wilson  <wilson@specifixinc.com>

	PR target/20670
	* unwind-ia64.c (uw_intall_context): Add missing load of r27.

2005-04-04  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/18644
	* doc/invoke.texi (-Wsynth): Remove documentation.

2005-03-28  James E Wilson  <wilson@specifixinc.com>

	PR target/20286.
	* config/ia64/ia64.c (ia64_encode_section_info): Only abort if encoding
	or symbol_str[1] is 's'.

2005-02-23  Michael Beach  <michaelb@ieee.org>

	PR target/20159
	* config/sparc/t-elf (startup files): Assemble with CPP.

2005-02-11  John David Anglin  <dave.anglin@nrc-crnc.gc.ca>

        PR middle-end/19697
	2005-01-30  Roger Sayle  <roger@eyesopen.com>
        * config/pa/pa.md (anddi3, iordi3): On HPPA64, disallow an integer
        constant as the second operand and a register as the third.

2005-01-29  Alan Modra  <amodra@bigpond.net.au>

	* unwind-dw2.c (execute_stack_op): Add missing cases for
	DW_OP_shl, DW_OP_shr, DW_OP_shra, DW_OP_xor.

2005-01-28  Stephane Carrez  <stcarrez@nerim.fr>

	PR target/15384
	* config/m68hc11/t-m68hc11-gas (dp-bit.c): Fix typo causing a
	configuration part of dp-bit.c to be lost.

2005-01-27  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/17771
	Backport from mainline:
	* config/s390/s390.md ("reload_outti"): Remove predicate for
	output operand.  Abort if operand is not a MEM.
	("reload_outdi", "reload_outdf"): Likewise.

2005-01-22  Roger Sayle  <roger@eyesopen.com>

	PR target/18402
	Backport from mainline
	2003-02-05  Jakub Jelinek  <jakub@redhat.com>
 
 	PR optimization/8555
 	* config/i386/i386.md (sse_mov?fcc split): Handle op2 == op3 case
 	instead of aborting.

2005-01-21  Giovanni Bajo  <giovannibajo@gcc.gnu.org>

	* gccbug.in: Update optimization -> tree-optimization/rtl-optimization.

2005-01-21  Giovanni Bajo  <giovannibajo@gcc.gnu.org>

	PR c++/17115
	* tree-inline.c (expand_call_inline): Do not warn for functions
	marked with attribute noinline.

2005-01-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/19296
	* combine.c (simplify_comparison): Rewrite the condition under
	which a non-paradoxical SUBREG of a PLUS can be lifted when
	compared against a constant.

2004-01-14  David Mosberger  <davidm@hpl.hp.com>
	    James E Wilson  <wilson@specifixinc.com>

	PR target/18987
	* config/ia64/ia64.c (process_set): For alloc insn, only call
	process_epilogue is !frame_pointer_needed.

	PR target/13158
	* config/ia64/ia64.c (ia64_expand_epilogue): Set RTX_FRAME_RELATED_P on
	sibcall alloc instruction.
	(process_set): Handle sibcall alloc instruction.

2005-01-13  David O'Brien  <obrien@FreeBSD.org>

	Backport from mainline:
	* config/freebsd-spec.h:  Use KSE pthread lib for -pthread.

2005-01-08  Sergey M. Samoylov  <ssamoylov@dev.rtsoft.ru>

	Backport:
	2004-02-12  Richard Sandiford  <rsandifo@redhat.com>
	PR bootstrap/13617
	* config/mips/mips-protos.h (mips_output_aligned_decl_common): Declare.
	(mips_declare_object): Make variadic.
	* config/mips/mips.h (ASM_OUTPUT_ALIGNED_DECL_COMMON): Use
	mips_output_aligned_decl_common.
	* config/mips/mips.c (mips_output_aligned_decl_common): New function.
	(mips_declare_object): Make variadic.

2005-01-08  Richard Sandiford  <rsandifo@redhat.com>

	PR target/17565
	* config/mips/mips.md (define_asm_attributes): Set can_delay to no.

2004-12-27 John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* vax.c (vax_address_cost, vax_rtx_cost): Correct casts.
	(vax_rtx_cost): Handle small offsets for both PLUS and MINUS.

2004-12-27  Steven Bosscher  <stevenb@suse.de>
	    John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	rtl-optimization/12863
        * config/vax/vax.h (CASE_DROPS_THROUGH): Don't define.
        * config/vax/vax.md (casesi): Emit a test-and-branch to make sure
        that the case is in range, to make sure the casesi insn is always
        in range and never falls through.
        (casesi1): Add comment to explain why casesi never falls through.
        Remove the unnamed special case casesi pattern.

2004-12-26  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/17643
	* config/pa/pa32-linux.h (FUNCTION_OK_FOR_SIBCALL): Return false when
	TARGET_PORTABLE_RUNTIME is true.

2004-12-25  Alan Modra  <amodra@bigpond.net.au>

	PR target/19147
	* config/rs6000/rs6000.md (andsi3_internal7, andsi3_internal8): Delete.

2004-12-21  Joseph S. Myers  <jsm@polyomino.org.uk>

	PR c/14765
	* c-parse.in (compstmt_primary_start): Set last_expr_type to
	NULL_TREE.

2004-12-19  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/19068
	* expr.c (expand_expr_real_1) <MAX_EXPR>: Ensure that target, op0
	and op1 are all registers (or constants) before expanding the RTL
	comparison sequence [to avoid reg_overlap_mentioned (target, op1)].

2004-12-16  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/18882
	* function.c (assign_stack_local_1): Use BITS_PER_UNIT alignment
	when passed -2 as 'align'.
	(put_var_into_stack): Adjust calls to put_reg_into_stack.
	When passed a CONCAT, instruct put_reg_into_stack to use
	a consecutive stack slot for the second part.
	(put_reg_into_stack): Remove 'promoted_mode' parameter, add
	'consecutive_p' parameter.  Retrieve the register mode from 'reg'.
	When consecutive_p is true, instruct assign_stack_local_1 to use
	BITS_PER_UNIT alignment.
	(put_addressof_into_stack): Adjust call to put_reg_into_stack.

2004-12-16  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/18590
	* function.c (fixup_var_refs_insns_with_hash): Do not invoke
	fixup_var_refs_insn on insns marked as deleted.

2004-12-15  Richard Henderson  <rth@redhat.com>

        PR target/19005
        * config/i386/i386.md (swaphi_1): Swap with swaphi_2, allow with
        optimize_size.
        (swapqi_1): Rename from swapqi.  Enable only for no partial reg
        stall and optimize_size.
        (swapqi_2): New.
        (swaphi_1, swaphi_2, swapqi_1): Add athlon_decode.
        (swapsi, swaphi_1, swaphi_2, swapqi_1, swapdi): Remove modrm override.

2004-12-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/18730
	* emit-rtl.c (get_first_nonnote_insn, get_last_nonnote_insn): When
	the first/last insn is a sequence, return the first/last insn of the
	sequence.

2004-12-12  Richard Henderson  <rth@redhat.com>

        PR target/18932
        * config/i386/i386.md (all splits and peepholes): Use flags_reg_operand
        and compare_operator to propagate the input CC mode to the output.
        * config/i386/i386.c (flags_reg_operand, compare_operator): New.
        * config/i386/i386.h (PREDICATE_CODES): Add them.
        * config/i386/i386-protos.h: Update.

2004-12-10  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR rtl-optimization/16536
	Backport from mainline:
	2004-06-25  Mark Mitchell  <mark@codesourcery.com>
	* alias.c (get_alias_set): Adjust setting of
	DECL_POINTER_ALIAS_SET for pointers to aggregates.

2004-12-09  Richard Henderson  <rth@redhat.com>

	PR target/17025
	* config/i386/i386.md (testqi_1_maybe_si, andqi_2_maybe_si): New.
	(test_qi_1, andqi_2): Do not promote to simode.

2004-12-07  David Mosberger  <davidm@hpl.hp.com>

	PR target/18443
	* config/ia64/ia64.c (ia64_assemble_integer): Add support for
	emitting unaligned pointer-sized integers.

2004-12-05  Richard Henderson  <rth@redhat.com>

	PR target/18841
	* config/alpha/alpha.md (UNSPECV_SETJMPR_ER): New.
	(builtin_setjmp_receiver_er_sl_1): Use it.
	(builtin_setjmp_receiver_er_1): Likewise.
	(builtin_setjmp_receiver_er, exception_receiver_er): Remove.
	(builtin_setjmp_receiver): Don't split for explicit relocs until
	after reload.
	(exception_receiver): Likewise.

2004-12-03  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	2003-10-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>
	Backport from mainline
	* aclocal.m4 (gcc_AC_FUNC_MMAP_BLACKLIST): Blacklist ultrix*.
	* configure: Rebuilt.

2004-12-03  Richard Henderson  <rth@redhat.com>

	2004-09-24  Richard Henderson  <rth@redhat.com>
	PR rtl-opt/17503
	* regclass.c (subregs_of_mode): Turn into an htab.  Make static.
	(som_hash, som_eq): New.
	(init_subregs_of_mode, record_subregs_of_mode): New.
	(cannot_change_mode_set_regs): Rewrite for htab implementation.
	(invalid_mode_change_p): Likewise.
	* combine.c (gen_lowpart_for_combine): Use record_subregs_of_mode.
	* flow.c (mark_used_regs): Likewise.
	(life_analysis): Use init_subregs_of_mode.
	* regs.h (subregs_of_mode): Remove.
	* rtl.h (init_subregs_of_mode, record_subregs_of_mode): Declare.

2004-12-03  Roger Sayle  <roger@eyesopen.com>

	PR target/9908
	* config/i386/i386.md (*call_value_1): Correct Intel assembler
	syntax by using %A1 instead of %*%1.

2004-12-01  Alan Modra  <amodra@bigpond.net.au>

	PR target/12817
	* config/rs6000/rs6000.c (rs6000_emit_prologue): Use r0 for vrsave.

2004-11-29  Roger Sayle  <roger@eyesopen.com>

	PR rtl-optimization/9771
	* regclass.c (CALL_REALLY_USED_REGNO_P): New macro to eliminate
	conditional compilation in init_reg_sets_1.
	(init_reg_sets_1): Let global_regs[i] take priority over the frame
	(but not stack) pointer exceptions to regs_invalidated_by_call.
	(globalize_reg): Globalizing a fixed register may need to update
	regs_invalidated_by_call.

2004-11-27  Falk Hueffner  <falk@debian.org>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/18577
	* unroll.c (unroll_loop): Test both REGNO_LAST_UID and
	REGNO_LAST_NOTE_UID to decide whether a pseudo is local
	to the loop.

2004-11-27  Alan Modra  <amodra@bigpond.net.au>

	PR target/12769
	* config/rs6000/rs6000.c (init_cumulative_args): Set call_cookie
	from rs6000_default_long_calls for libcalls.

2004-11-25  Richard Henderson  <rth@redhat.com>

	PR c++/6764
	* reload1.c (set_initial_eh_label_offset): New.
	(set_initial_label_offsets): Use it.

2004-11-22  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR rtl-optimization/14838
	* emit-rtl.c (get_first_nonnote_insn): Don't assume first insn is a
	note.
	(get_last_nonnote_insn): Don't assume last insn is a note.

2004-10-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/install.texi (*-*-solaris2*): Update with info about kernel
	patches to solve spurious testsuite failures.

2004-10-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/14454
	* config/sparc/sparc.c (TARGET_ASM_CAN_OUTPUT_MI_THUNK): Set to
	sparc_can_output_mi_thunk.
	(sparc_output_mi_thunk): Simplify handling of delta offset.  Add
	handling of vcall offset.
	(sparc_can_output_mi_thunk): New predicate.
	* doc/tm.texi (TARGET_ASM_OUTPUT_MI_THUNK): Document VCALL_OFFSET.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Delete.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): New target hook.

	* config/sparc/sparc.md (movdi): Remove redundant test.

2004-10-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (*-*-solaris2*): Fix marker for URL.

2004-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/16007
	* doc/install.texi (*-*-solaris2*): Mention potential problem
	with Sun assembler + GNU linker and C++ programs.
	Document status of binutils 2.15 release.

2004-09-30  Richard Henderson  <rth@redhat.com>
 
	* config/alpha/qrnnd.asm: Mark for noexecstack.
 
2004-09-30  Richard Henderson  <rth@redhat.com>
  
	* unwind-dw2.c (_Unwind_GetGR): Honor DWARF_ZERO_REG.
	* doc/tm.texi (DWARF_ZERO_REG): New.
  
	* config/alpha/alpha.c (alpha_sa_mask, alpha_expand_prologue,
	alpha_expand_epilogue): Revert 2003-09-30 change to store zero.
	* config/alpha/alpha.h (DWARF_ZERO_REG): New.

2004-09-30  Release Manager

	* GCC 3.3.5 Released.

2004-09-20  Roger Sayle  <roger@eyesopen.com>

	PR rtl-optimization/17363
	Backport from mainline
	2003-07-19  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

		PR bootstrap/11593
		* sched-rgn.c (find_rgns): Initialize current_edge correctly.

2004-09-17  James E Wilson  <wilson@specifixinc.com>

	PR target/17455
	* config/ia64/ia64.c (ia64_function_ok_for_sibcall): Return false
	if current_function_decl is a sibcall.

2004-09-13  Richard Henderson  <rth@redhat.com>

	PR inline-asm/6806
	* cselib.c (cselib_invalidate_rtx): Export.  Remove unused args.
	(cselib_invalidate_rtx_note_stores): New.
	(cselib_record_sets, cselib_process_insn): Update to match.
	* cselib.h (cselib_invalidate_rtx): Declare.
	* reload1.c (reload_cse_simplify): Invalidate asm clobbers.

2004-08-29  Jonathan Wakely  <redi@gcc.gnu.org>

	* doc/trouble.texi (C++ misunderstandings): Fix example code.

2004-08-26  Richard Henderson  <rth@redhat.com>

	PR target/15718
	* config/alpha/alpha.h (HARD_REGNO_MODE_OK): Allow complex float
	modes.

2004-08-26  Matthias Klose  <doko@debian.org>

	* doc/invoke.texi: Remove duplicate -fbranch-probabilities entry.

2004-08-14  Roger Sayle  <roger@eyesopen.com>

	* fixinc/tests/base/obstack.h: Backport from mainline.

2004-08-14  Roger Sayle  <roger@eyesopen.com>
	    David Billinghurst  <David.Billinghurst@riotinto.com>

	PR libgfortran/15930
	* fixinc/inclhack.def (irix___generic1, irix___generic2): New.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/internal/math_core.h: New file

2004-08-08  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/16790
	* fold-const.c (expand_muldiv_1) <NOP_EXPR>: Disallow local
	truncations, not just global truncations.

2004-08-02  Ulrich Weigand  <uweigand@de.ibm.com>

	Backport from mainline:
	2003-07-11  Jakub Jelinek  <jakub@redhat.com>
	* optabs.c (prepare_cmp_insn): Try cmpmemM first if it exists,
	then fall back to cmpstrM.
	* builtins.c (expand_builtin_memcmp): Likewise.
	* config/s390/s390-protos.h (s390_expand_cmpstr): Rename to...
	(s390_expand_cmpmem): ... this.
	* config/s390/s390.md (cmpmemdi, cmpmemsi, cmpmem_short_64,
	cmpmem_short_31, cmpmem_long_64, cmpmem_long_31): Renamed
	from cmpstr* patterns.  Rename call to s390_expand_cmpstr
	to s390_expand_cmpmem.
	* config/s390/s390.c (s390_expand_cmpstr): Rename to...
	(s390_expand_cmpstr): ... this.  Rename cmpstr* instructions
	to cmpmem*.
	* config/i370/i370.md (cmpmemsi, cmpmemsi_1): Renamed from
	cmpstr* patterns.
	* doc/md.texi (cmpstrM): Describe as String compare insn, not
	Block compare insn.
	(cmpmemM): Add.

2004-07-25  Andreas Jaeger  <aj@suse.de>

	Backport from mainline:
	* libgcc-std.ver: Add __unorddf2 and __unordsf2 with version 3.3.4.

2004-07-25  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/13250
	Backport from mainline:
	* config/sh/sh.md (rotlsi3): Use emit_move_insn.

	PR target/15647
	Backport from mainline:
	* config/sh/t-linux (SHLIB_MAPFILES): Use sh specific
	libgcc-std.ver.
	* config/sh/libgcc-std.ver: New file.

2004-07-25  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/15202
	* pa.md (movdi, movsi, movhi, movqi): Support move from shift amount
	register to general register for DI, SI, HI and QI modes.  Remove
	move to shift amount register in DF mode.

	PR rtl-optimization/14782
	* pa.c (emit_move_sequence): Use SFmode for 4-byte modes when doing
	the address checks for secondary reloads for loads from and stores
	to floating-point registers.
	* pa.h (EXTRA_CONSTRAINT, case T): Use SFmode for 4-byte modes
	in the address check.  Move work around for ELF32 targets to
	GO_IF_LEGITIMATE_ADDRESS.
	(GO_IF_LEGITIMATE_ADDRESS): Require constant offsets to be
	correctly aligned for DImode loads and stores.  Don't allow long
	SFmode displacements on ELF32.

2004-07-25  Matthias Klose  <doko@debian.org>

	Backport:
	PR rtl-optimization/14700

	2004-06-24  Eric Christopher  <echristo@redhat.com>

 	* combine.c (distribute_notes): Don't delete sets to
 	global register variables.
 
	2004-06-29  Zack Weinberg  <zack@codesourcery.com>
 
 	* combine.c (distribute_notes): Don't look at global_regs for
 	pseudos.

2004-07-23  James E Wilson  <wilson@specifixinc.com>

	PR target/16559
	* ia64.c (ia64_expand_load_address): For CONST, replace
	gen_load_symptr call with recursive call.

2004-07-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:
	2004-07-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/13926
	* config/sparc/sparc-protos.h (output_ubranch): New prototype.
	* config/sparc/sparc.c (output_ubranch): New function.
	* config/sparc/sparc.md (jump pattern): Use it.

2004-07-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/16494
	* config/sparc/sparc.c (output_cbranch): Properly guard
	the code handling far branches with TARGET_V9.
	* config/sparc/sparc.md (length attribute): Document the
	side-effect of having a length greater or equal to 3.

2004-07-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Lloyd Parkes  <lloyd@must-have-coffee.gen.nz>

	PR target/15186
	* config/sparc/sol2-bi.h (LINK_ARCH64_SPEC_BASE): Pass
	/usr/ucblib/sparcv9 as -R path when -compat-bsd is specified.

2004-07-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Martin Sebor  <sebor@roguewave.com>

	PR target/12602
	* doc/invoke.texi (SPARC options): Document -threads
	and -pthreads on Solaris.

2004-07-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sol2-bi.h: Handle TARGET_CPU_ultrasparc3.
	(CPP_CPU_SPEC): Handle -mcpu=ultrasparc3.
	(ASM_CPU_SPEC): Likewise
	* config/sparc/sol2.h: Handle TARGET_CPU_ultrasparc3.
	(ASM_CPU_SPEC): Handle -mcpu=ultrasparc3.

2004-07-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (output_indirect_call): Only use %r2 as the link register in
	indirect calls with the long PA 2.0 pc-relative branch.

	PR target/16459
	* pa.c (output_indirect_call): Use %r2 as the link register when
	calling $$dyncall with a pc-relative branch.

2004-07-07  Andreas Schwab  <schwab@suse.de>

	* config/ia64/ia64.md: Define new attribute "empty".
	(prologue_use, nop_x, insn_group_barrier): Set it.

	* config/ia64/ia64.c (ia64_reorg): When looking for trailing call
	skip over "empty" insns.

2004-07-04  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/contrib.texi (Contributors): Adjust link for GNU Classpath.

2004-06-30  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (emit_move_sequence): Fix loading of non 14-bit CONST operands
	when generating PIC code.

2004-06-28  Josef Zlomek  <zlomekj@suse.cz>

	PR c/15549
	Backport from mainline
	2003-08-19  Mark Mitchell  <mark@codesourcery.com>

		PR c++/11946
		* convert.c (convert_to_integer): Use CONVERT_EXPR (instead of
		NOP_EXPR) when necessary.

2004-06-17  Ian Lance Taylor  <ian@wasabisystems.com>

	PR middle-end/16038
	Backport from mainline:
	Fri Apr  4 17:43:52 2003  Olivier Hainque <hainque@act-europe.fr>

	* emit-rtl.c (get_mem_attrs): Adjust alignment tests determining
	use of default attributes to agree MEM_ALIGN macro.

2004-05-31  Release Manager

	* GCC 3.3.4 Released.

2004-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/15693
	* config/sparc/sparc.c (compare_operand): New predicate.
	* config/sparc/sparc.h (PREDICATE_CODES): Add it.
	* config/sparc/sparc.md (cmpsi expander): Use it.  If the first
	operand is a ZERO_EXTRACT and the second operand is not zero,
	force the former to a register.
	(cmpdi expander): Likewise.

2004-05-29  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13653
	* loop.c (loop_givs_rescan): When reducing a non-replaceable giv,
	clear the RTX_UNCHANGING_P flag.

2004-05-28  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR bootstrap/14671
	* alias.c (init_alias_analysis): Allocate alias_invariant array with
	ggc_alloc_cleared instead of xrealloc.
	(end_alias_analysis): Don't free alias_invariant.

2004-05-27  Richard Henderson  <rth@redhat.com>

	Backport from mainline:
	2004-01-19  Richard Henderson  <rth@redhat.com>
	* alpha.md (UNSPEC_NT_LDA): Renumber.
	(UNSPEC_CVTLQ, cvtlq): New.
	(extendsidi2_1): Rename from extendsidi2_nofix; remove f/f.
	(extendsidi2_fix): Remove.
	(extendsidi2 splitter): Use cvtlq.
	(extendsidi2 fp peepholes): Remove.
	(cvtql): Use SFmode instead of SImode.
	(fix_trunc?fsi): Update to match.
	(floatsisf2_ieee, floatsisf2, floatsidf2_ieee, floatsidf2): New.
	(movsi): Rename from movsi_nofix, remove f alternatives.
	(movsi_nt_vms): Similarly.
	(movsi_fix, movsi_nt_vms_fix): Remove.

2004-05-26  Hans-Peter Nilsson  <hp@axis.com>

	PR optimization/15296
	* reorg.c (fill_simple_delay_slots): Use next_real_insn when
	getting last consecutive label at a branch.
	(relax_delay_slots): Similar, near top of loop.

2004-05-17  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from mainline

	PR target/15301
	PR target/15302
	2004-05-17  Jan Hubicka  <jh@suse.cz>

	* i386.c (construct_container): Do not produce BLKmode registers.
	(classify_argument): Properly compute alignment of complex types.

2004-05-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11841
	* loop.h (REGNO_LAST_NOTE_LUID): New macro.
	* unroll.c (unroll_loop): Take into account notes when deciding
	whether a pseudo is local to the loop.

2004-05-16  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport from mainline
	2004-05-01  Ulrich Weigand  <uweigand@de.ibm.com>
	PR middle-end/15054
	* expr.c (expand_expr_real): Do not call preserve_temp_slots 
	on a TARGET_EXPR temp.
	* function.c (assign_stack_temp_for_type): Set 'keep' flag for
	TARGET_EXPR temp slots.

2004-05-13  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/15130
	* config/sh/sh-protos.h (sh_expand_epilogue): Change prototype.
	* config/sh/sh.c (output_stack_adjust): Generate a special
	push/pop sequence when failing to get a temporary register for
	non SHmedia epilogue.
	(sh_expand_epilogue): Add an argument to show whether it's for
	sibcall or not.  Take the sibcall epilogue into account.
	(sh_need_epilogue): Call sh_expand_epilogue with 0.
	* config/sh/sh.md (sibcall_epilogue): Call sh_expand_epilogue
	with 1.
	(epilogue): Call sh_expand_epilogue with 0.

2004-05-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alias.c (set_reg_known_value, set_reg_known_equiv_p):
	Prototype.
	(get_reg_known_value, set_reg_known_value,
	get_reg_known_equiv_p, set_reg_known_equiv_p): Use traditional
	style function definitions.
	(set_reg_known_equiv_p): Change parameter from bool to int.
	
	Backport:
	
	2003-06-13  Matt Kraai  <kraai@alumni.cmu.edu>

	* unwind-c.c: Define NO_SIZE_OF_ENCODED_VALUE.
	* unwind-pe.h (size_of_encoded_value): Do not define if
	NO_SIZE_OF_ENCODED_VALUE is defined.

	2003-10-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
	
	* unwind-dw2.c (NO_SIZE_OF_ENCODED_VALUE): Define when
	appropriate.

	2003-05-07  Richard Henderson  <rth@redhat.com>
	
	* unwind-dw2.c (_Unwind_GetCFA): Cast pointer to _Unwind_Ptr,
	not _Unwind_Word.

2004-05-08  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (sparc-sun-solaris2*): Document bootstrap
	problems with earlier versions of the GNU compiler.

2004-05-07  Steven Bosscher  <stevenb@suse.de>

	PR opt/14749
	* expr.c (do_jump): If TREE_CONSTANT_OVERFLOW is set, don't
	trust integer_zerop.  Just expand both branches.

2004-04-29  Matthias Klose  <doko@debian.org>

	Backport:

	2004-03-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/14235
	* expr.c (convert_move): Copy the source to a new pseudo
	when converting from a sub-word source to a larger-than-word
	register which conflicts with the source.

2004-04-29  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.h (FLOATDITF2_LIBCALL, FIX_TRUNCTFDI2_LIBCALL,
	FIXUNS_TRUNCTFDI2_LIBCALL): Define.
	(INIT_TARGET_OPTABS): If DITF_CONVERSION_LIBFUNCS, initialize
	DI <-> TF libfuncs for TARGET_ARCH32.
	(DITF_CONVERSION_LIBFUNCS): Define to 0.
	* config/sparc/linux.h (DITF_CONVERSION_LIBFUNCS): Redefine to 1.
	* config/sparc/linux64.h (DITF_CONVERSION_LIBFUNCS): Redefine to 1.
	* config.gcc (sparc-*-linux*): Revert 2004-03-25 change.
	* config/sparc/t-linux64 (TARGET_LIBGCC2_CFLAGS): Likewise.
	* config/sparc/t-linux: Removed.

2004-04-28  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/15084
	* config/i386/i386.md (*movsi_insv_1_rex64): Changed to DImode
	and renamed to movdi_insv_1_rex64.
	(insv): Support SImode for 32bit and DImode for 64bit.

2004-04-24  Richard Henderson  <rth@redhat.com>

	PR bootstrap/14671
	* alias.c (alias_invariant, alias_invariant_size): Mark GTY.
	(reg_known_value, reg_known_value_size): Likewise; make static.
	(reg_known_equiv_p): Make static.
	(clear_reg_alias_info): Update for new indexing.
	(get_reg_known_value, set_reg_known_value): New.
	(get_reg_known_equiv_p, set_reg_known_equiv_p): New.
	(canon_rtx): Use them. 
	(init_alias_analysis): Likewise.  Allocate reg_known_value with gc.
	Don't play queer offsetting games with reg_known_value and
	reg_known_equiv_p.
	(end_alias_analysis): Don't free reg_known_value.
	* rtl.h (get_reg_known_value, get_reg_known_equiv_p): Declare.
	* sched-deps.c (reg_known_equiv_p, reg_known_value): Remove.
	(deps_may_trap_p, sched_analyze_1, sched_analyze_2): Use the new
	functions instead.

2004-04-21  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa64-hpux.h (LIB_SPEC): Fix library specification used with GNU ld.

	* pa64-regs.h (DBX_REGISTER_NUMBER): Simplify and correct mapping of
	SAR register.  Fix comment.
	(ADDITIONAL_REGISTER_NAMES): Correct register number of SAR register
	(%cr11).

2004-04-14  Zack Weinberg  <zack@codesourcery.com>

	PR 14936
	Backport from mainline:
	2004-03-12  Matt Austern  <austern@apple.com>

	* varasm.c (make_decl_one_only): Don't use DECL_COMMON if
	we're compiling for a SUPPORTS_ONE_ONLY target.

2004-04-13  H.J. Lu  <hongjiu.lu@intel.com>

	PR debug/14919

	From gcc-3_2-rhl8-branch:
	2003-02-04  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (dwarf2out_finish): Add AT_comp_dir attribute
	even if input file name is absolute, but one of the includes
	is relative.

2004-04-06  Devang Patel  <dpatel@apple.com>

	PR 14467
	* config/darwin.h (LINK_COMMAND_SPEC): Use c++filt instead of c++filt3.

2004-03-25  Ulrich Weigand  <uweigand@de.ibm.com>

	* expr.c (store_constructor): Use gen_int_mode to correctly
	sign-extend CONST_INT value.

2004-04-01  Alan Modra  <amodra@bigpond.net.au>
	    Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (init_gcc_specs): If HAVE_LD_AS_NEEDED, link with
	-lgcc --as-needed -lgcc_s --no-as-needed by default.
	* configure.in (HAVE_LD_AS_NEEDED): Check for ld --as-needed.
	* configure: Rebuilt.
	* config.in: Rebuilt.
	* Makefile.in (stage1-start): Copy also libgcc_s*$(SHLIB_EXT).
	(stage2-start, stage3-start, stage4-start): Likewise.
	(stageprofile-start, stagefeedback-start): Likewise.

2004-04-01  Jakub Jelinek  <jakub@redhat.com>

	PR c++/14755
	* fold-const.c (fold) <EQ_EXPR>: Properly compute newconst in
	"bitfld++ == const" to "++bitfld == const + incr" transformations.

2004-04-01  Jakub Jelinek  <jakub@redhat.com>

	PR c/14069
	* c-decl.c (finish_struct): Change type of incorrect flexible array
	field into error_mark_node.

	Backport from mainline:
	2003-04-07  J"orn Rennecke  <joern.rennecke@superh.com>

	* c-typeck.c (output_init_element): Check for type == error_mark_node.

2004-04-01  Alan Modra  <amodra@bigpond.net.au>

	* dwarf2out.c (DEBUG_STR_SECTION_FLAGS): Heed flag_merge_constants.

2004-03-30  Matthias Klose  <doko@debian.org>

	Backport:

	2004-01-14  Richard Earnshaw  <rearnsha@arm.com>

	PR bootstrap/12527
	* config.gcc (arm*-*-linux*): Don't include unknown-elf.h in tm_file.
	Move linux-gas.h and linux-elf.h before aout.h.
	* arm/arm.h (INITIALIZE_TRAMPOLINE): Only define if not already.
	* arm/linux-elf.h (SUBTARGET_CPU_DEFAULT): Define.

	2003-05-15  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.c (arm_is_xscale): Rename to arm_arch_xscale.
	All uses updated.
	(arm_tune_xscale): New variable.
	(arm_override_options): Set it.
	(arm_adjust_cost): Use it in place of arm_arch_xscale.
	(arm_gen_load_multiple): Likewise.
	(arm_gen_store_multiple): Likewise.
	* config/arm/arm.md (is_xscale): Likewise.
	* config/arm/arm.h (arm_tune_xscale): Declare.

	2003-04-28  Nick Clifton  <nickc@redhat.com>

	* config/arm/elf.h (ASM_OUTPUT_ALIGNED_COMMON): Remove definition.

2004-03-29  Matthias Klose  <doko@debian.org>

	2003-09-17  Daniel Jacobowitz  <drow@mvista.com>

	* config/rs6000/sysv4.h (LIB_LINUX_SPEC): Give -lpthread before -lc.

2004-03-29  Matthias Klose  <doko@debian.org>

	Backport:
	2004-01-15  Andreas Schwab  <schwab@suse.de>

	PR bootstrap/13562
	* config/m68k/m68k.c (output_move_const_into_data_reg): Clear cc
	status for NOTB/NOTW/NEGW methods.

2004-03-29  Aldy Hernandez  <aldyh@redhat.com>

	PR 14219
	* c-typeck.c (build_binary_op): Do not allow comparisons of
	vectors.

2004-03-27  Matthias Klose  <doko@debian.org>

	PR target/11716
	Michael Eager <eager@mvista.com>

	* config/mips/mips.md: Limit the maximum length of a short branch to
	64K instead of 128K.

2004-03-26  Richard Henderson  <rth@redhat.com>

	PR 11527
	* c-typeck.c (pop_init_level): Emit pending init elements earlier
	rather than later.

2004-03-26  Jan Hubicka  <jh@suse.cz>
	    H.J. Lu  <hongjiu.lu@intel.com>

	PR Target/14723
	* config.gcc: Add support --with-cpu=nocona.

	* config/i386/i386.c (override_options): Add support for
	Prescott and Nocona.

	* doc/invoke.texi: Extend documentation of -mcpu/-march for new
	CPUs.

2004-03-25  Jakub Jelinek  <jakub@redhat.com>

	* config.gcc (sparc-*-linux*): Add sparc/t-linux to tmake_file.
	* config/sparc/t-linux64 (TARGET_LIBGCC2_CFLAGS): Set.
	* config/sparc/t-linux: New file.

2004-03-24  Kelley Cook  <kcook@gcc.gnu.org>

	Backport:
	2004-03-01  Mark Mitchell  <mark@codesourcery.com>

	PR bootstrap/14356
	* gcc.c (process_command): Remove const-qualification from argv.
	(main): Likewise.

2004-03-24  Alexandre Oliva  <aoliva@redhat.com>

	PR preprocessor/14438
	* cpplib.c (do_pragma): Remove line_change call after pragma
	handler.

2004-03-22  Andrew Pinski  <pinskia@physics.uc.edu>

	BackPort:
		2004-01-09  Andrew Pinski <pinskia@physics.uc.edu>

		PR debug/11231
		* dbxout.c (dbxout_type_fields): Return if any item is error_mark_node or the
		type is error_mark_node.

2004-03-22  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/14470
	* expr.c (mark_queue): New function.
	(emit_insns_enqueued_after_mark): New function replacing
	emit_queue.  Clear the body of emitted queued insns.
	(emit_queue): Call emit_insns_enqueued_after_mark.
	(store_expr): Mark the increment queue on entry.  Emit
	only the incrementations queued when expanding the source.

2004-03-17  Ralf Corsepius <corsepiu@faw.uni-ulm.de>

	PR target/14260
	* config/rtems.h: Add STD_LIB_SPEC and LIB_SPEC.

2004-03-21  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold) <EQ_EXPR>: Rewrite optimization to transform
	"foo++ == const" into "++foo == const+incr".

2004-03-21  Roger Sayle  <roger@eyesopen.com>

	PR target/13889
	* cse.c (fold_rtx): Avoid substituting constants into unary
	conversion operations.

2004-03-17  Ian Lance Taylor  <ian@wasabisystems.com>

	Backport:
	2003-11-08  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Deprecate compound
	expressions as lvalues.
	* doc/extend.texi: Document that all extended lvalues are now
	deprecated.

	2003-11-05  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Deprecate use of
	conditional expressions as lvalues.

	2003-10-22  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Unconditionally warn of
	deprecation of casts as lvalues.
	* fixinc/inclhack.def (obstack_lvalue_cast): New fix.
	* fixinc/fixincl.x: Regenerate.

2004-03-15  Richard Henderson  <rth@redhat.com>

	PR middle-end/14535
	* except.c (collect_one_action_chain): Record action for cleanup
	outer of exception spec.

2004-03-13  Dara Hazeghi  <dhazeghi@yahoo.com>

	* doc/install.texi: Note status of -fnew-ra.

2004-03-13  Jakub Jelinek  <jakub@redhat.com>

	PR target/14533
	* config/s390/s390.c (legitimize_pic_address): Don't abort on UNSPEC
	other than 100.

2004-03-13  Alan Modra  <amodra@bigpond.net.au>

	PR debug/11983
	* dwarf2out.c (enum dw_val_class): Rename dw_val_class_float to
	dw_val_class_vec.  Replace use throughout file.
	(dw_float_const): Delete.
	(dw_vec_const): New.
	(dw_val_struct_union): Rename val_float to val_vec.  Replace use
	throughout file.
	(add_AT_vec): Rename from add_AT_float.  Add elt_size param.
	(same_dw_val_p): Adjust vec comparison.  Use memcmp.
	(size_of_die): Adjust dw_val_class_vec sizing.
	(output_die): Output dw_val_class_vec.
	(insert_int, extract_int, insert_float): New functions.
	(add_const_value_attribute): Use insert_float for CONST_DOUBLE.
	Handle CONST_VECTOR.
	(add_location_or_const_value_attribute): Handle CONST_VECTOR.

2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport:
	2004-03-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
	PR middle-end/14470
	* expr.c (store_expr): Call emit_queue before generating the move
	from the temporary to the original target.  Protect the temporary
	from emit_queue.

2004-03-10  James E Wilson  <wilson@specifixinc.com>

	PR target/13877
	* unroll.c (unroll_loop): If precondition loop, clear the initial_value
	field in loop_info.

2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport:
	2004-03-05  Nathan Sidwell  <nathan@codesourcery.com>
	PR driver/13577
	* gcc.c (cc1_options): Robustify -auxbase-strip from multiple -o
	options.

2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Endorse:
	2004-01-10  Eric Botcazou  <ebotcazou@libertysurf.fr>
	PR optimization/13472
	* reload1.c (reload): Don't record unchanging memory locations.

2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport
	2004-02-27  Mark Mitchell  <mark@codesourcery.com>
	PR middle-end/13448
	* c-tree.h (readonly_warning): Rename to ...
	(readonly_error): ... this.
	* c-typeck.c (build_unary_op): Adjust accordingly.
	(readonly_warning): Rename to ...
	(readonly_error): ... this and issue errors, not warnings.
	(build_modify_expr): Call readonly_error, not readonly_warning.
	(c_expand_asm_operands): Likewise.
	* tree-inline.c (optimize_inline_calls): Do not inline
	functions after errors have occurred.

2004-03-12  Philip Blundell  <philb@gnu.org>

	PR target/10730
	Backport from trunk:
	2003-05-15  Philip Blundell  <philb@gnu.org>
	* config/arm/arm.c (adjacent_mem_locations): Reject offsets
	involving invalid constants.

2004-03-12  Philip Blundell  <philb@gnu.org>

	PR target/14558
	Backport from trunk:
	2004-02-25  Richard Earnshaw  <rearnsha@arm.com>
	* arm.h (ARM_GO_IF_LEGITIMATE_INDEX): For QImode the range of
	an offset is -4095...+4095 inclusive.

2004-03-11  Richard Henderson  <rth@redhat.com>

	PR target/14539
	* config/alpha/alpha.h (STACK_BOUNDARY): Set to 128.

2004-03-10  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/14289
	* c-typeck.c (c_mark_addressable): A register variable should
	be considered global if its not automatic, i.e. TREE_PUBLIC,
	TREE_STATIC or DECL_EXTERNAL.
	* function.c (put_var_into_stack): Call abort when placing a
	hard register into the stack, if x_parm_reg_stack_loc is NULL.

2004-03-10  Andrew Haley  <aph@redhat.com>

	PR optimization/14381
	* function.c (expand_function_end): Emit a blockage insn before
	the epilogue when -fnon-call-exceptions is used.

2004-03-10  Joel Sherrill  <joel@oarcorp.com>

	PR target/14480
	* config.gcc (powerpc*-*-rtems*): Use rs6000/t-rtems.

2004-03-07  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.md (ashrdi3): Do not call ashrdi3_no_power
	for little endian.
	("ashrdi3_no_power"): Disable for little endian.
	(ashrdi3): Same.

2004-03-07  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (MASK_LONG_DOUBLE_128): New.
	(TARGET_LONG_DOUBLE_128): New.
	(TARGET_SWITCHES): Add long-double-{128,64}.
	(TARGET_HAS_XFLOATING_LIBS): Default to TARGET_LONG_DOUBLE_128.
	(LONG_DOUBLE_TYPE_SIZE): Honor TARGET_LONG_DOUBLE_128.
	(LIBGCC2_LONG_DOUBLE_TYPE_SIZE): New.
	(WIDEST_HARDWARE_FP_SIZE): New.
	(TARGET_CPU_CPP_BUILTINS): Define __LONG_DOUBLE_128__.
	* config/alpha/alpha.c (override_options): Clear MASK_LONG_DOUBLE_128
	if TARGET_VAX_FLOAT.
	* config/alpha/osf5.h (LONG_DOUBLE_TYPE_SIZE): Remove.
	(TARGET_DEFAULT): Set MASK_LONG_DOUBLE_128.

2004-03-08  Hans-Peter Nilsson  <hp@axis.com>

	PR target/14471
	* doc/invoke.texi (CRIS Options): Document -mmul-bug-workaround
	and -mno-mul-bug-workaround.
	* config/cris/cris.md ("smulsi3_highpart", "umulsi3_highpart")
	("mulsidi3", "umulsidi3"): Prefix output template with "%!".
	("umulhisi3", "umulqihi3", "mulsi3", "mulqihi3", "mulhisi3"):
	Ditto.  Make attribute "slottable" dependent on TARGET_MUL_BUG.
	* config/cris/mulsi3.asm (__Mul) [__CRIS_arch_version >= 10]: Make
	sure mulu.d is not last on cache-line.
	* config/cris/cris.h (ASM_SPEC): Translate -mno-mul-bug-workaround
	into -no-mul-bug-abort depending on HAVE_AS_MUL_BUG_ABORT_OPTION.
	(TARGET_MASK_MUL_BUG, TARGET_MUL_BUG): New macros.
	(TARGET_SWITCHES): New options -mmul-bug-workaround and
	-mno-mul-bug-workaround.
	(TARGET_DEFAULT): Include TARGET_MASK_MUL_BUG.
	(PRINT_OPERAND_PUNCT_VALID_P): Include '!'.
	* config/cris/cris.c (cris_operand_extend_operator): Clarify
	relation to MULT in head comment.
	(cris_op_str): Abort for MULT.
	(cris_print_operand) <case '!'>: New case.

2004-03-06  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_in_small_data_p): False for functions.

2004-03-05  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("load_multiple", "*load_multiple_di",
	"*load_multiple_si"): Allow only if reload_completed.
	("store_multiple", "*store_multiple_di", "*store_multiple_si"):
	Likewise.

2004-03-05  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_expand_movstr): Clobber double-word
	register before initializing high and low parts separately.
	(s390_expand_clrstr): Likewise.
	(s390_expand_cmpstr): Likewise.

2004-03-05  Ulrich Weigand  <uweigand@de.ibm.com>

	PR optimization/12147
	* reload1.c (reload_reg_free_p): RELOAD_OTHER conflicts with
	RELOAD_FOR_OPADDR_ADDR.
	(reload_reg_reaches_end_p): A RELOAD_FOR_OTHER_ADDRESS register
	might be reused as RELOAD_FOR_OPADDR_ADDR register.

2004-03-05  Ian Lance Taylor  <ian@wasabisystems.com>

	PR target/1532
	Backport from mainline:

	2004-02-24  Kazu Hirata  <kazu@cs.umass.edu>

	* cse.c (cse_change_cc_mode_insns): Stop at any instruction
	which modifies NEWREG.
	(cse_condition_code_reg): Update the mode of CC_REG in
	CC_SRC_INSN on our own.

	2004-02-11  Richard Henderson  <rth@redhat.com>

	* flow.c (insn_dead_p): A clobber of a dead hard register is a
	dead insn after reload.

	2004-01-24  Ian Lance Taylor  <ian@wasabisystems.com>

	* cse.c (cse_cc_succs): Change the mode of the source expression
	as soon as decide we need a new mode.  Don't permit changing modes
	if we found a match in a successor block.
	(cse_condition_code_reg): Save original mode of source expression
	so that we know whether we have to change the mode in other
	insns.

	2004-01-24  Andreas Tobler  <a.tobler@schweiz.ch>

	* cse.c: (cse_cc_succs) Fix comparison warning.

	2004-01-23  Ian Lance Taylor  <ian@wasabisystems.com>

	* cse.c: Include "target.h".
	(cse_change_cc_mode): New static function.
	(cse_change_cc_mode_insns, cse_cc_succs): Likewise.
	(cse_condition_code_reg): New function.
	(default_cc_modes_compatible): New function.
	* rtl.h (cse_condition_code_reg): Declare.
	(default_cc_modes_compatible): Declare.
	* toplev.c (rest_of_compilation): Call cse_condition_code_reg.
	* target.h (struct gcc_target): Add fixed_condition_code_regs and
	cc_modes_compatible.
	* target-def.h (TARGET_FIXED_CONDITION_CODE_REGS): Define.
	(TARGET_CC_MODES_COMPATIBLE): Define.
	(TARGET_INITIALIZER): Add new initializers.
	* targhooks.c (default_cc_modes_compatible): Declare.
	* hooks.c (hook_bool_intp_intp_false): New function.
	* hooks.h (hook_bool_intp_intp_false): Declare.
	* config/i386/i386.c (TARGET_FIXED_CONDITION_CODE_REGS): Define.
	(TARGET_CC_MODES_COMPATIBLE): Define.
	(ix86_fixed_condition_code_regs): New static function.
	(ix86_cc_modes_compatible): Likewise.
	* doc/gccint.texi: Add copyright 2004.
	* doc/tm.texi (Condition Code): Document new hooks.
	* Makefile.in (cse.o): Depend upon $(TARGET_H).

	PR inline-asm/6162
	* reload.c (find_reloads): Only support one pair of commutative
	operands.

2004-03-02  Richard Henderson  <rth@redhat.com>

	PR middle-end/11767
	* optabs.c (prepare_cmp_insn): Force trapping memories to registers
	before the compare, if flag_non_call_exceptions.

2004-03-02  Richard Henderson  <rth@redhat.com>

	PR middle-end/14327
	* stmt.c (expand_computed_goto): Do do_pending_stack_adjust before
	emitting the label, not after.

2004-03-02  Danny Smith  <dannysmith@users.sourceforge.net>

	* cppinit.c (init_standard_includes): Check that sysroot
	string is not empty.

2004-03-01  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport from 3.4.0:
	2004-02-29  Mark Mitchell  <mark@codesourcery.com>
	PR debug/14328
	* dwarf2out.c (gen_enumeration_type_die): Output all enumeration
	constants as signed values.

	2004-01-16  J"orn Rennecke <joern.rennecke@superh.com>
	PR optimization/11864
	* reload1.c (reload_cse_simplify_operands): Don't remove
	implicit extension from LOAD_EXTEND_OP.

2004-02-29  Hans-Peter Nilsson  <hp@axis.com>

	PR target/14346
	* config/cris/cris.c (cris_asm_output_mi_thunk): For PIC, prepend
	TAB to jumping "add.d" insn.  Avoid PLT indirection by equating a
	local symbol and jumping through it.

2004-02-29  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport from mainline:
	2004-01-27  Eric Botcazou  <ebotcazou@libertysurf.fr>
	PR target/10904
	PR target/13058
	* config/sparc/sparc.h (CANNOT_CHANGE_MODE_CLASS): New.
	Forbid mode changes from SImode for lower FP regs if ARCH64.

2004-02-28  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.h (TRAMPOLINE_TEMPLATE, TRAMPOLINE_SIZE, TRAMPOLINE_CODE_SIZE,
	MIN_CACHELINE_SIZE, INITIALIZE_TRAMPOLINE): Backport fixes from 3.5.
	* pa.md (anddi3, dcacheflush, icacheflush): Likewise.

	* pa64-hpux.h (LIB_SPEC): Fix linking under HP-UX 11.00 with -p and -pg.

2004-02-27  Ian Lance Taylor  <ian@wasabisystems.com>

	PR optimization/7871
	* flow.c (mark_set_1): Don't add LOG_LINKS for global registers
	from or to call insns.

2004-02-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/7871
	* flow.c (propagate_one_insn): Interpret calls as setting global
	registers, not merely clobbering them.

2004-02-26  Richard Earnshaw  <rearnsha@arm.com>
	Daniel Jacobowitz  <drow@mvista.com>

	PR target/14302
	* arm.h (ARM_GO_IF_LEGITIMATE_ADDRESS): Don't check the mode
	size for minipool references.

2004-02-25  Richard Earnshaw  <rearnsha@arm.com>

	PR target/14166
	* arm.h (THUMB_GO_IF_LEGITIMATE_ADDRESS): Only allow constant pool
	references from SImode.
	* arm.md (thumb_movhi_insn): Don't allow minipool references.

2004-02-24  Bob Wilson  <bob.wilson@acm.org>

	Backport from mainline (changes to xtensa_expand_prologue go into
	xtensa_reorg instead; remove irrelevant portions of the patch)

	2004-02-09  Bob Wilson  <bob.wilson@acm.org>:

	* config/xtensa/xtensa-protos.h (xtensa_copy_incoming_a7): Update.
	(init_cumulative_args): Likewise.
	(a7_overlap_mentioned_p): Delete prototype.
	* config/xtensa/xtensa.c (struct machine_function): Replace
	incoming_a7_copied field with need_a7_copy and vararg_a7 flags.
	Add set_frame_ptr_insn field.
	(xtensa_emit_move_sequence): Update call to xtensa_copy_incoming_a7.
	(xtensa_copy_incoming_a7): Rewrite to check need_a7_copy flag and check
	if the operand is an argument in a7.  If so, copy a7 to a new pseudo
	at the function entry and replace the operand with the pseudo.
	(init_cumulative_args): Remove unused arguments.  Add new "incoming"
	argument and record this flag in CUMULATIVE_ARGS.
	(function_arg): Remove result_mode and special-case code to handle
	arguments in a7.  Instead, set need_a7_copy flag when there is an
	incoming argument in a7.
	(xtensa_expand_prologue): Remove code to search for set_frame_ptr insn
	and use the value recorded in cfun->machine->set_frame_ptr_insn.
	(xtensa_builtin_saveregs): Check for negative gp_left value.  Set
	need_a7_copy and vararg_a7 flags.  Use move_block_from_reg instead of
	special-case code.
	(a7_overlap_mentioned_p): Delete.
	* config/xtensa/xtensa.h (CUMULATIVE_ARGS): Add "incoming" flag.
	(INIT_CUMULATIVE_ARGS, INIT_CUMULATIVE_INCOMING_ARGS): Remove useless
	arguments to init_cumulative_args and pass "incoming" flag instead.
	(BLOCK_REG_PADDING): Delete.
	* config/xtensa/xtensa.md (movdi, movsf, movdf): Remove unnecessary
	checks for reload_in_progress and reload_completed.  Update calls to
	xtensa_copy_incoming_a7.
	(ashlsi3): Rename existing insn to ashlsi3_internal.  Add expander
	to call xtensa_copy_incoming_a7.

2004-02-22  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (override_options): Don't imply 3DNow! for -m64
	by default.

2004-02-22  James E Wilson  <wilson@specifixinc.com>

	PR target/13918
	* sched-ebb.c (ebb_sched_info): Disable use of cselib.

2004-02-22  Hans-Peter Nilsson  <hp@axis.com>

	PR target/14209
	* config/cris/cris.md ("*andsi_movu", "*andhi_movu"): Tweak
	constraints to not match postincrement.  Adjust the predicate to
	exclude a volatile memory reference.
	("*andsi_clear"): Tweak constraints to not match postincrement.
	Adjust the predicate to exclude a volatile memory reference.
	("*andhi_clear"): Ditto.  Rename from "*andhi_clear_signed".
	("*andhi_clear_unsigned"): Remove, non-matching pattern.

2004-02-14  Release Manager

	* GCC 3.3.3 Released.

2004-02-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/14113
	Backport from mainline:

	2004-02-03  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.md (call followed by jump define_peephole's):
	Delete.

2004-02-06  H.J. Lu  <hongjiu.lu@intel.com>

	* doc/invoke.texi: Mention SSE2 and SSE3.

	* config/i386/i386.h: Deprecate -mpni/-mno-pni.

2004-02-06  Kelley Cook  <kcook@gcc.gnu.org>

	* config/i386/i386.c: Rename pni to sse3.
	* config/i386/i386.h: Likewise.
	* config/i386/i386.md: Likewise.
	* config/i386/pmmintrin.h: Likewise.
	* doc/extend.texi: Likewise.
	* doc/invoke.texi: Likewise.

2004-02-03  Wolfgang Bangerth  <bangerth@dealii.org>

	PR other/14003
	* doc/invoke.texi (x86 options): Fix spelling/wording.

2004-02-01  Geoffrey Keating  <geoffk@apple.com>

	PR bootstrap/13960
	* config/rs6000/rs6000.h (LEGITIMATE_LO_SUM_ADDRESS_P): Accept
	lo_sum addresses on Darwin.

2004-01-30  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c: Update copyright.
	* config/sparc/sparc.h: Likewise.
	* config/sparc/sparc.md: Likewise.

2004-01-29  Roger Sayle  <roger@eyesopen.com>

	PR java/13824
	* tree.c (unsafe_for_reeval): Handle EXIT_BLOCK_EXPR nodes specially
	as their EXIT_BLOCK_LABELED_BLOCK operands can lead to unbounded
	recursion.

2004-01-29  H.J. Lu  <hongjiu.lu@intel.com>

	* doc/invoke.texi: Remove the pni option from -mfpmath=.

2004-01-29  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport from mainline

	2004-01-20  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	PR optimization/12440
	* loop.c: Include ggc.h.
	(loop_optimize): Run garbage collector between optimization of loops.
	* Makefile.in (loop.o): Add GGC_H dependency.

2004-01-24  Matthias Klose  <doko@debian.org>

	* objc/objc-act.c (is_public): Fix typo in message.

2004-01-23  Richard Henderson  <rth@redhat.com>

	PR opt/12941
	* combine.c (SHIFT_COUNT_TRUNCATED): Provide default value.
	(simplify_comparison): Don't simplify (eq (zero_extract c 1 r) 0)
	if SHIFT_COUNT_TRUNCATED is set.

2004-01-23  Ian Lance Taylor  <ian@wasabisystems.com>

	* doc/invoke.texi (Optimize Options): Note that --param arguments
	are subject to change without notice.

2004-01-23  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* reload.c (can_reload_into): Add prototype and K&R style function
	declaration.

2004-01-21  Andreas Jaeger  <aj@suse.de>
	    Michael Matz  <matz@suse.de>

	* doc/extend.texi (Extended Asm): Clarify memory clobber.

2004-01-21  Ralf Corsepius  <corsepiu@faw.uni-ulm.de>

	PR target/13073
	* config/h8300/t-rtems (h8300-*-rtems*): New.
	* config.gcc: Use config/h8300/t-rtems.

2004-01-20  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Backport from mainline

	2004-01-10  Jan Hubicka  <jh@suse.cz>
	PR opt/12826
	* loop.c (insert_loop_mem): Prefer VOLATILE memory references to be
	stored.

2004-01-16  Jan Hubicka  <jh@suse.cz>

	PR opt/13608
	* i386.c (ix86_compute_frame_layout): Fix for alloca on leaf function.

2004-01-16  Segher Boessenkool  <boessen@de.ibm.com>

	PR target/11793
	* config/rs6000/rs6000.h (LEGITIMATE_CONSTANT_P): Handle
	vectors.

2004-01-16  Jan Hubicka  <jh@suse.cz>

	PR opt/11350
	* cfgcleanup.c (try_optimize_cfg): Suppress tablejump removal
	after reload.
	* cfgrtl.c (try_redirect_by_replacing_branch): Likewise.

2004-01-15  J"orn Rennecke <joern.rennecke@superh.com>

	PR optimization/10392
	* reload.c (can_reload_into): New function.
	(push_reload): Use it.

2004-01-14  J"orn Rennecke <joern.rennecke@superh.com>

	PR target/9365
	* sh.c (gen_block_redirect): Add special handling of RETURN.
	(gen_far_branch) Don't call gen_stuff_delay_slot if there is no
	far branch target (i.e. it's a return).

2004-01-14  Hartmut Penner  <hpenner@de.ibm.com>

	* gcc/config/rs6000/rs6000.c (rs6000_stack_info)
	Calculate always vrsave_mask if TARGET_ALTIVEC.
	(rs6000_emit_prologue): Emit code for vrsave
	only if TARGET_ALTIVEC_VRSAVE.
	(rs6000_emit_epilogue): Likewise.

2003-01-14  Nicola Pero  <n.pero@mi.flashnet.it>

	PR objc/7993
	* objc-act.c (is_private): Do not emit the 'instance variable %s
	is declared private' error.
	(is_public): Emit the error after calling is_private.
	(lookup_objc_ivar): If the instance variable is private, return 0
	- the instance variable is invisible here.

2004-01-12  Marc Espie <espie@openbsd.org>

	* system.h: handle YYBYACC like YYBISON.

2004-01-12  Matthias Klose  <doko@debian.org>

	Backport from mainline

	2003-12-08 Stuart Hastings <stuart@apple.com>
	* config/i386/i386.md: Typo in split of fp-valued if_then_else.

2004-01-12  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/11397
	* varasm.c (assemble_alias): Remove weak aliases from weak_decls.

2004-01-12  J"orn Rennecke <joern.rennecke@superh.com>

	PR target/13585
	* sh-protos.h (check_use_sfunc_addr): Declare.
	* sh.c (extract_sfunc_addr, check_use_sfunc_addr): New functions.
	* sh.md (use_sfunc_addr): Use check_use_sfunc_addr in insn predicate.

2004-01-12  Matthias Klose  <doko@debian.org>

	Backport from mainline

	2004-01-11  Richard Henderson  <rth@redhat.com>
	PR opt/12441
	Revert: Sat Mar 30 14:08:55 CET 2002  Jan Hubicka  <jh@suse.cz>
	* i386.c (aligned_operand): Be prepared for SUBREGed registers.
	(ix86_decompose_address): Use REG_P instead of GET_CODE (...) == REG.
	(ix86_address_cost): Be prepared for SUBREGed registers.
	(legitimate_address_p): Accept SUBREGed registers.

2004-01-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_encode_section_info): Use 'I'
	for TLS_MODEL_INITIAL_EXEC.
	(tls_symbolic_operand_1): Update to match.
	(tls_symbolic_operand_type): Likewise.

2004-01-11  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/13392
	* builtins.c (expand_builtin_expect_jump): Handle conditional jumps
	to drop through label.  Don't fall back to SCC even when conditional
	jump has not been found.

2004-01-09  Jeff Bailey  <jbailey@nisa.net>

	PR target/12561
	* config/t-gnu: Rename SYSTEM_HEADER_DIR to NATIVE_SYSTEM_HEADER_DIR.

2004-01-09  Richard Henderson  <rth@redhat.com>

	* recog.c (constrain_operands): Validate mem operands.

2004-01-02  Nathanael Nerode  <neroden@gcc.gnu.org>

	PR target/13069
	Backport the following from mainline:

	2003-03-08  Neil Booth  <neil@daikokuya.co.uk>
	* config/sh/rtemself.h (TARGET_OS_CPP_BUILTINS): Use instead of
	CPP_PREDEFINES.
	* config/sh/rtems.h (TARGET_OS_CPP_BUILTINS): Use instead of
	CPP_PREDEFINES.

	2003-09-27  Kelley Cook  <kcook@gcc.gnu.org>
	* config/sh/rtemself.h, config/sh/rtems.h: GNU CC -> GCC.

2004-01-02  Roger Sayle  <roger@eyesopen.com>

	* tree.h (integer_nonzerop): Use PARAMS macro with prototype.
	* tree.c (integer_nonzerop): Use K&R style function declaration.

2004-01-02  Andreas Schwab  <schwab@suse.de>

	* doc/c-tree.texi: Fix @item vs. @itemx.
	* doc/cpp.texi: Likewise.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.

2004-01-02  Andreas Jaeger  <aj@suse.de>, Gerald Pfeifer  <gp@suse.de>

	* doc/install.texi (Specific): Mention x86_64.

2004-01-01  Jakub Jelinek  <jakub@redhat.com>

	PR optimization/13521
	Backport from mainline:
		2003-03-22  Richard Henderson <rth@redhat.com>

		* cfgcleanup.c (insns_match_p): Do not do EQUIV substitution
		after reload.

2003-12-31  Roger Sayle  <roger@eyesopen.com>

	PR fortran/12632
	* tree.c (integer_nonzerop): New predicate for nonzero integers.
	* tree.h (integer_nonzerop): Add function prototype.
	* fold-const.c (fold) <COND_EXPR>: Don't fold a constant condition,
	if we'd replace a COND_EXPR of non-void type by one of its operands
	of void type.

2003-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	Backport from mainline:

	2003-09-12  Richard Sandiford  <rsandifo@redhat.com>

	PR target/13373
	* config/mcore/mcore-protos.h (mcore_r15_operand_p): Declare.
	(mcore_secondary_reload_class): Declare.
	(mcore_output_inline_const_forced): Remove.
	* config/mcore/mcore.md (movsi): Remove the code that forced
	non-inlineable constants into a register if the target was r15
	or the stack pointer.  Remove constant restrictions from the main
	define_insn.  Remove r <- I, r <- M and r <- N alternatives in favor
	of an r <- P alternative.  Remove fallback define_insn for reload.
	(movhi, movqi): Use gen_lowpart rather than gen_SUBREG.  Remove reload
	define_insn.  Use mcore_output_move in the remaining define_insn.
	Adjust condition and constraints in the way as for movsi.
	(movdi): Always split unacceptable constants into two.  Use
	simplify_gen_subreg instead of operand_subword{,_force}.
	* config/mcore/mcore.c (mcore_output_inline_const_forced): Remove.
	(mcore_output_move): Support HImode and QImode moves as well.
	(mcore_m15_operand_p): New function.
	(mcore_reload_class): Use it to detect cases where LRW_REGS are better.
	(mcore_secondary_reload_class): New function.
	* config/mcore/mcore.h (SECONDARY_RELOAD_CLASS): Redefine in
	terms of mcore_secondary_reload_class.

2003-12-31  Zack Weinberg  <zack@codesourcery.com>

	* config/ia64/ia64.c (ia64_va_arg): Pass pointer for
	variable-sized type through convert_memory_address.
	(ia64_in_small_data_p): Always return false for FUNCTION_DECLs.

2003-12-24  Andrew Pinski  <pinskia@physics.uc.edu>

	PR bootstrap/13068
	Backport from mainline:
		2003-05-09  Matt Kraai <kraai@alumni.cmu.edu>

		* mklibgcc.in: Remove extra quotes.
		2003-05-08  Aldy Hernandez  <aldyh@redhat.com>

		* mklibgcc.in: Use mkinstalldirs when installing multilib
		directories.

2003-12-24  Roger Sayle  <roger@eyesopen.com>

	Backport from mainline:

	2003-09-18  Mark Mitchell  <mark@codesourcery.com>
	* explow.c (convert_memory_address): Define even when
	POINTERS_EXTEND_UNSIGNED is not defined.  Do nothing if the address
	is already in the right mode.

2003-12-23  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/13475
	Backport from mainline:
		2003-06-19  Aldy Hernandez  <aldyh@redhat.com>

		* expr.c (const_vector_from_tree): Initialize remaining
		elements to 0.

2003-12-23  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/11576
	* config/h8300/h8300.h (CONSTANT_ADDRESS_P): Allow CONST and
	HIGH on all variants.

2003-12-23  Matthias Klose  <doko@debian.org>

	* config/mips/linux.h (LIB_SPEC): Use -lpthread when
	-pthread was specified.

2003-12-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13394
	* toplev.c (rest_of_compilation): Move call to
	check_function_return_warnings right after the sibcall
	optimization pass.

2003-12-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/13382
	* c-typeck.c (convert_for_assignment): When converting from
	integral type to pointer type, always call convert.

2003-12-22  Gabriel Dos Reis <gdr@integrable-solutions.net>

	PR target/11271
	* reload.c: Revert last backport from mainline.  It breaks s390.

2003-12-21  Roger Sayle  <roger@eyesopen.com>

	* config/ia64/hpux.h (TARGET_OS_CPP_BUILTINS): Define _ILP32
	when compiling in ILP32 mode.

2003-12-21  Gabriel Dos Reis <gdr@integrable-solutions.net>

    Backport from mainline:
    2003-10-31  Richard Earnshaw  <rearnsha@arm.com>

	    PR target/11271
	    * reload.c (find_reloads_address): Handle any register in
	    (PLUS (PLUS (REG) (REG)) (CONST_INT).

2003-12-21  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/13400
	* ifcvt.c (noce_process_if_block): Disable unconditional write
	optimizations if we could introduce a store to trapping memory
	that wasn't present previously.

2003-12-20  Roger Sayle  <roger@eyesopen.com>

	PR optimization/13031
	* gcse.c (cprop_jump): Backport code clean-up and bug-fix
	from mainline [2003-05-20 Sayle, Hirata and Rennecke patch].
	(cprop_insn): Don't attemp further substitutions if the
	current instruction has been deleted.
	(local_cprop_pass): Likewise.

2003-12-19  Jakub Jelinek  <jakub@redhat.com>

	PR c++/13239
	* builtins.c (expand_builtin_expect_jump): Update
	TREE_VALUE (arglist) if unsave_expr_now langhook
	created a new tree.

2003-12-18  Mark Mitchell  <mark@codesourcery.com>

	* config/sol2.h (LINK_ARCH32_SPEC): Define in terms of ...
	(LINK_ARCH32_SPEC_BASE): ... this new macro.
	* config/sparc/sol2-bi.h (LINK_ARCH64_SPEC): Define in terms of
	...
	(LINK_ARCH64_SPEC_BASE): ... this new macro.
	* config/sparc/sol2-gld-bi.h (LINK_ARCH32_SPEC): New macro.
	(LINK_ARCH64_SPEC): Likewise.

2003-12-17  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/11992
	* config/s390/s390.md ("*cmpmem_long_64"): Use CLCLE instruction
	instead of CLCL.
	("*cmpmem_long_31"): Likewise.

2003-12-16  Zack Weinberg  <zack@codesourcery.com>

	Backport the following patches from mainline.

    2003-12-05  Mark Mitchell  <mark@codesourcery.com>

	* config/ia64/ia64.h (MUST_PASS_IN_STACK): Define.

    2003-12-01  James E Wilson  <wilson@specifixinc.com>

	* config/ia64/ia64.h (FUNCTION_ARG_REGNO_P): Use AR_REG_FIRST not
	GR_ARG_FIRST.

    2003-10-21  Zack Weinberg  <zack@codesourcery.com>

	* config/ia64/ia64.md (cmpxchg_acq_si): Mark operand 3 as DImode.
	* config/ia64/ia64.c (ia64_expand_fetch_and_op,
	ia64_expand_op_and_fetch): Make sure the REG for ar.ccv is
	DImode.   Use convert_move to load ar.ccv.
	(ia64_expand_compare_and_swap): Likewise.
	If expand_expr doesn't put 'old' and 'new' in the proper
	modes, run them through convert_to_mode.

    2003-10-14  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_expand_call): Force function address
	to DImode.
	* config/ia64/ia64.md (call_gp): Put DImode on operand 0.

    2003-06-11  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.md (call_gp): Fix memory mode.

    2003-05-14  Eric Christopher  <echristo@redhat.com>

	* combine.c: Fix header comments.
	(distribute_notes): Remove usage of elim_i1, elim_i2. Propagate
	to all calls and prototype.

2003-12-16  David O'Brien  <obrien@FreeBSD.org>

	* config/alpha/freebsd.h (FBSD_TARGET_CPU_CPP_BUILTINS): Add __LP64__.
	* config/sparc/freebsd.h (FBSD_TARGET_CPU_CPP_BUILTINS): Likewise.
	* config/i386/freebsd64.h (FBSD_TARGET_CPU_CPP_BUILTINS): Conditionally
	add __LP64__.

2003-12-16  Hartmut Penner  <hpenner@de.ibm.com>

	* altivec.h (vec_cmple, vec_all_numeric): Fix typo.
	* testsuite/gcc.dg/altivec-10.c: Test for above.

2003-12-15  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/13122
	* config/h8300/h8300.md (pushqi1_h8300hs_normal): New.
	(pushqi1): Call gen_pushqi1_h8300hs_normal in normal mode.
	(pushhi1_h8300hs_normal): New.
	(pushhi1): Call gen_pushqi1_h8300hs_normal in normal mode.

	* config/h8300/h8300.h (LINK_SPEC): Support normal mode.
	* config/h8300/h8300.c (asm_file_start): Correctly output
	an architecture directive.
	* config/h8300/lib1funcs.asm: Correctly specify an
	architecture directive.

2003-12-12  Roger Sayle  <roger@eyesopen.com>

	PR optimization/13037
	* loop.c (update_giv_derive): Ignore redundant sets of a biv when
	calculating how to derive a giv from a biv.

2003-12-12  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/linux.h (IA64_GATE_AREA_END): Increase by 64K.
	(MD_FALLBACK_FRAME_STATE_FOR): Set fpsr_loc, br_loc[6] and
	br_loc[7].  Update comment.
	(MD_HANDLE_UNWABI): Define.
	* config/ia64/unwind-ia64.c (struct unw_state_record): Add
	unwabi field.
	(struct _Unwind_Context): Increase br_loc array size to 8 entries.
	(desc_abi): Set unwabi.
	(uw_update_reg_address): Allow br up to 7.
	(uw_update_context): Invoke MD_HANDLE_UNWABI if defined.
	(uw_install_context): Load b1..b5 from correct locations.
	Fix insn loading ar.fpsr.
	* doc/tm.texi: Document MD_HANDLE_UNWABI.

2003-12-12  Hans-Peter Nilsson  <hp@axis.com>

	PR target/13256
	Backport from mainline:
	* resource.h (enum mark_resource_type): Remove member MARK_DEST.
	The only user changed as follows:
	* resource.c (mark_set_resources) <case SET>: Always recurse for
	SET_SRC (x).
	<case SIGN_EXTRACT, case ZERO_EXTRACT>: Always recurse on
	operands.
	<case STRICT_LOW_PART>: Delete, deferring to default code.

	PR target/12598
	Backport from mainline:
	* config/cris/cris.md (define_split "*mov_sidesi_biap_mem"+1)
	(define_splits "*mov_sidesi_mem"+1, "casesi"+9, +10, +11, +12):
	Use cris_mem_op and replace_equiv_address, not gen_rtx_MEM.
	("call", "call_value", define_split "*mov_sidesi_mem"+19, +20)
	(define_split "*mov_sidesi_mem"+21, +22, +23, +24, +25, +26, +27)
	(define_split "*mov_sidesi_mem"+28, +29, +30): Use
	replace_equiv_address, not gen_rtx_MEM.
	* config/cris/cris.c (cris_mem_op): New match_operator function.
	(cris_notice_update_cc): Use replace_equiv_address, not
	gen_rtx_MEM.
	* config/cris/cris.h (PREDICATE_CODES): Add cris_mem_op.

2003-12-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13318
	* loop.c (express_from): Protect integer division from overflow.

2003-12-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13060
	* function.c (fixup_var_refs_1) [SUBREG]: Recognize even if a
	replacement already exists.  Fix again the whole insn if that fails.

2003-12-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12965
	* caller-save.c (save_call_clobbered_regs): Do not save/restore
	registers around no-return calls.

2003-12-10  Andrew Pinski  <pinskia@physics.uc.edu>

	* emit-rtl.c (copy_rtx_if_shared_1): Fix warning.

2003-12-10  Nathanael Nerode  <neroden@gcc.gnu.org>

	Backport from mainline (fixes unreported regression):
	* cpptrad.c (_cpp_scan_out_logical_line): Improve test for
	  whether directive begins at the beginning of a line.

2003-12-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/13354
	* config/sparc/sparc.c (sparc_output_mi_thunk): Load DELTA
	manually if one can do that with only one instruction.

2003-12-09  Kelley Cook  <kelleycook@wideopenwest.com>

	2003-06-04  Kelley Cook  <kelleycook@wideopenwest.com>
	PR optimization/4490
	* config/i386/i386.md: Don't use XFMode if TARGET_128BIT_LONG_DOUBLE.

2003-12-08  David Edelsohn  <edelsohn@gnu.org>
	    Graham Reed <greed@pobox.com>

	PR target/13150
	* collect2.c (GCC_OK_SYMBOL): Add support for AIX C_WEAKEXT.
	(GCC_UNDEF_SYMBOL): Same.

2003-12-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/10060
	* emit-rtl.c (copy_rtx_if_shared): Split out into ...
	(copy_rtx_if_shared_1): here and optimize the last one
	in the sequence into tail-recursion.
	(reset_used_flags): Optimize the last one
	in the sequence into tail-recursion.

2003-12-07  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_elf_section_type_flags): Don't
	set SECTION_WRITE on TARGET_RELOCATABLE.

2003-12-05  Andrew Pinski <pinskia@physics.uc.edu>

	PR driver/13211
	* gcc.c (execute) Increment execution_count when returning
	early because verbose_only_flag is true.

2003-12-05  Stuart Menefy <stuart.menefy@st.com>
	    J"orn Rennecke <joern.rennecke@superh.com>

	PR target/13302
	* sh.c (sh_build_builtin_va_list): Use (*lang_hooks.types.make_type).

2003-12-04  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/11322
	* config/sh/netbsd-elf.h (NO_PROFILE_COUNTERS): Define.

	PR target/12467
	* config/rs6000/altivec.md (altivec_vmsummbm): Fix typo.

2003-12-04  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile.in (stmp-fixinc): Don't bail out if SYSTEM_HEADER_DIR
	does not exist and it's the default sys-include directory.

2003-12-03  Mark Mitchell  <mark@codesourcery.com>

	* config/ia64/hpux.h (TARGET_HAVE_TLS): Define it to false.
	* config/ia64/ia64.h (TARGET_HAVE_TLS): Define it to true if
	HAVE_AS_TLS is true.
	* config/ia64/ia64.c (TARGET_HAVE_TLS): Do not define it.

2003-12-03  James E Wilson  <wilson@specifixinc.com>

       2003-11-29  James E Wilson  <wilson@specifixinc.com>
       * gcc.c (init_spec): Pass -lunwind to init_gcc_specs in eh_name
       instead of in shared_name.

2003-12-03 David Mosberger  <davidm@hpl.hp.com>

       2003-11-20 David Mosberger  <davidm@hpl.hp.com>
       * config/t-libunwind (LIB2ADDEH): Add unwind-c.c.
       (SHLIB_LC): Define.
       * unwind-libunwind.c (_Unwind_GetCFA): Implement.
       (_Unwind_GetBSP) [UNW_TARGET_IA64]: New function.

2003-12-03  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (store_constructor): Only set RTX_UNCHANGING_P for
	read-only field if cleared is 0.

2003-12-03  Kean Johnston  <jkj@sco.com>

	PR 12969
	* fixinc/inclhack.def (AAB_svr4_replace_byteorder): Revert the
	change I made on 2003-08-11 that removes the mach lines.
	Restore them to the same list thats in the head, as per
	Nathanael Nerode's changes.
	* fixinc/fixincl.x: Regenerated
	* fixinc/tests/base/ansi/string.h: Fix test case

2003-12-03  James E Wilson  <wilson@specifixinc.com>

	2003-12-01  James E Wilson  <wilson@specifixinc.com>
	PR target/8407
	* config/ia64/ia64.c (ia64_function_arg): For single-reg HFA, call
	gen_rtx_REG to create new reg with argument mode.

2003-12-03  Josef Zlomek  <zlomekj@suse.cz>

	Backport from mainline

	2003-10-31  Josef Zlomek  <zlomekj@suse.cz>

		PR/10239
		* cfgrtl.c (delete_insn): Decrease LABEL_NUSES for all
		REG_LABEL notes.

	2003-10-31  Josef Zlomek  <zlomekj@suse.cz>

		PR/11640
		* cfgrtl.c (try_redirect_by_replacing_jump): Move jump
		immediatelly before BARRIER.

2003-12-01  Kaz Kojima  <kkojima@gcc.gnu.org>

	Backport from mainline

	2002-11-19  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config.gcc (sh*-*-linux*): Add t-slibgcc-elf-ver and t-linux.
	to tmake_file.
	* config/sh/libgcc-glibc.ver: New file.

	Backport from mainline

	2003-10-08  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/t-linux (SHLIB_LINK): Override to use a linker script
	libgcc_s.so.
	(SHLIB_INSTALL): Likewise.

2003-12-01  Roger Sayle  <roger@eyesopen.com>

	PR optimization/11634
	* recog.c (split_insn): Factor test of INSN_P and handling of
	set_noop_p out of here into the two callers.
	(split_all_insns): Add INSN_P test and set_noop_p handling here.
	If deleting a no-op set after reload that has a REG_UNUSED note,
	mark the basic block as changed and recalculate life information.
	(split_all_insns_noflow): Add INSN_P test and set_noop_p handling
	here.

2003-12-01  Zack Weinberg  <zack@codesourcery.com>

	PR 12505
	* configure.in: Check for system-provided 'uchar' type.
	* configure, config.in: Regenerate.
	* cpphash.h: Only typedef 'uchar' if the system doesn't.

2003-12-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* unroll.c (find_splittable_givs): Add missing extend_value_for_giv.

2003-12-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-11-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13041
	* final.c (frame_pointer_needed): Fix comment.
	* reload1.c (reload): Decrease alignment of the frame
	pointer if it was used for register allocation.

2003-12-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-11-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12900
	* reg-stack (move_for_stack_reg): New prototype.  Return
	whether a control flow insn was deleted.
	(subst_stack_regs_pat): Likewise, using the information provided
	by move_for_stack_reg.
	(subst_stack_regs): Likewise, using the information provided
	by subst_stack_regs_pat.
	(convert_regs_1): Record whether a control flow insn was deleted,
	using the information provided by subst_stack_regs.  Purge dead
	edges only if a control flow insn was deleted.

2003-12-01  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* doc/c-tree.texi (Function Bodies): Update HANDLER documentation.

2003-11-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("cmpint_di"): Fix incorrect instruction lengths.

2003-11-19  Alan Modra  <amodra@bigpond.net.au>

	Backport 2003-03-26  Alan Modra  <amodra@bigpond.net.au>
	* cppinit.c (init_standard_includes): Add both "translated" and
	non-translated header paths.

2003-11-18  Gerald Pfeifer  <gerald@pfeifer.com>

	Fix links in online manuals.
	* doc/invoke.texi (H8/300 Options): @xref to ld, not ld.info.

2003-11-17  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/invoke.texi (Warning Options): Simplify and clarify the
	description of -Wnonnull.

2003-11-14  Matthias Klose  <doko@debian.org>

	Backport from mainline

	2003-06-04  Jakub Jelinek  <jakub@redhat.com>

	* function.c (trampolines_created): New variable.
	(expand_function_end): Set it when doing INITIALIZE_TRAMPOLINE.
	* function.h (trampolines_created): Add.
	* config/s390/linux.h (ASM_FILE_END): Define.
	* config/alpha/linux-elf.h (ASM_FILE_END): Define.
	* config/m68k/linux.h (ASM_FILE_END): Define.
	* config/rs6000/linux.h (ASM_FILE_END): Define.
	* config/rs6000/linux64.h (ASM_FILE_END): Define.
	* config/sparc/linux.h (ASM_FILE_END): Define.
	* config/sparc/linux64.h (ASM_FILE_END): Define.
	* config/i386/i386.c (ix86_asm_file_end): Use SUBTARGET_FILE_END.
	* config/i386/linux.h (SUBTARGET_FILE_END): Define.
	* config/i386/linux64.h (SUBTARGET_FILE_END): Define.

	2003-06-05  Jakub Jelinek  <jakub@redhat.com>

	* mklibgcc.in: Propagate .note.GNU-stack section if needed into
	the .hidden assembly stubs.

2003-11-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12926
	* expr.c (expand_assignment) [COMPONENT_REF]: Don't put
	the UNCHANGING_RTX_P flag on memory references to read-only
	components that are not addressable.

2003-11-12  Alexey Starovoytov  <alexey.starovoytov@sun.com>

	PR optimization/12953
	* c-objc-common.c (inline_forbidden_p): Added check for BUILT_IN
	before switch by FUNCTION_CODE.

2003-11-10  Waldek Hebisch  <hebisch@math.uni.wroc.pl>

	PR target/12865
	* config/sparc/sparc.c (sparc_initialize_trampoline): Call
	__enable_execute_stack only after writing onto the stack.
	(sparc64_initialize_trampoline): Likewise.

2003-11-08  Roger Sayle  <roger@eyesopen.com>

	Backport from mainline
	PR optimization/10467, PR optimization/11741
	* gcse.c (pre_insert_copy_insn): Tweak the logic for finding the
	appropriate set to match the code in hash_scan_insn.

2003-11-06  H.J. Lu <hongjiu.lu@intel.com>

	* cppinit.c (init_standard_includes): Updated.

	* Makefile.in (fixinc.sh): Updated.

	Backport from 3.4-branch

	2003-07-16  Daniel Jacobowitz  <drow@mvista.com>

	* gcc.c (STANDARD_STARTFILE_PREFIX): Remove unnecessary definition.
	(main): Remove unnecessary case.  Only use standard_startfile_prefix
	if native.

	2003-04-11 Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (fixinc.sh): Pass BUILD_LIBERTY as LIBERTY to
	mkfixinc.sh.
	* fixinc/mkfixinc.sh (defs): Add LIBERTY.
	* configure.in (STMP_FIXINC, STMP_FIXPROTO): Don't disable on
	build != host sysrooted builds.
	* configure.in (SYSTEM_HEADER_DIR): Make sure it contains
	TARGET_SYSTEM_ROOT even on sysrooted natives.
	* configure: Rebuilt.

	2003-03-04  Daniel Jacobowitz  <drow@mvista.com>

	* configure.in: Don't always define TARGET_SYSTEM_ROOT.
	* configure: Regenerated.
	* gcc.c: Check whether TARGET_SYSTEM_ROOT is defined.

	2003-01-16  Daniel Jacobowitz  <drow@mvista.com>

	* Makefile.in (PREPROCESSOR_DEFINES): Add
	@TARGET_SYSTEM_ROOT_DEFINE@.
	* configure.in (PREFIX_INCLUDE_DIR): Don't define if $with_sysroot
	is specified or if building a cross compiler.
	(TARGET_SYSTEM_ROOT_DEFINE): Add TARGET_SYSTEM_ROOT_RELOCATABLE
	if the sysroot is under $exec_prefix.
	* configure: Regenerated.
	* cppdefault.h: Use native include paths if TARGET_SYSTEM_ROOT is
	defined.
	(struct default_include): Add add_sysroot field.
	(cpp_SYSROOT): Declare.
	* cppdefault.c (cpp_include_defaults): Fill in add_sysroot
	field.
	(cpp_SYSROOT): New variable.
	* cppinit.c (cpp_create_reader): Initialize
	CPP_OPTION (pfile, sysroot).
	(init_standard_includes): Handle add_sysroot.  Do not
	add unrelocated copies of relocated directories.
	(COMMAND_LINE_OPTIONS): Add -isysroot.
	(cpp_handle_option): Handle -isysroot.
	* cpplib.h (struct cpp_options): Add sysroot member.
	* gcc.c (The Specs Language): Update description of %I.
	(target_system_root_changed): New variable.
	(process_command): Conditionalize make_relative_prefix call
	on !VMS and TARGET_SYSTEM_ROOT_RELOCATABLE.  Set
	target_system_root_changed.
	(do_spec_1): Add -isysroot to %I.
	* doc/invoke.texi (Spec Files): Update description of %I.
	* doc/install.texi (--with-sysroot): Update comment about
	relocation.

	2002-10-19  Alexandre Oliva  <aoliva@redhat.com>
		    Angela Marie Thomas  <angela@releasedominatrix.com>
		    Brendan Kehoe  <brendan@zen.org>
		    Nick Clifton  <nickc@redhat.com>
		    Andrew Haley  <aph@redhat.com>

	* configure.in (--with-sysroot): New.  Don't inhibit libc if
	given.  AC_SUBST TARGET_SYSTEM_ROOT, TARGET_SYSTEM_ROOT_DEFINE
	and CROSS_SYSTEM_HEADER_DIR.
	* configure: Rebuilt.
	* Makefile.in (CROSS_SYSTEM_HEADER_DIR): Set in configure.
	(TARGET_SYSTEM_ROOT): New.
	(DRIVER_DEFINES): Define CROSS_INCLUDE_DIR from
	CROSS_SYSTEM_HEADER_DIR.
	(install-gcc-tooldir): New target.
	(stmp-fixinc): Do not create $(libsubdir), but rather bail out
	of SYSTEM_HEADER_DIR does not exist.
	(deduced.h, stmp-fixproto): Quote SYSTEM_HEADER_DIR properly.
	(install-mkheaders): Likewise.
	* gcc.c (target_system_root): New variable.
	(add_sysrooted_prefix): New function.
	(process_command): Recompute run-time target_system_root from
	gcc_exec_prefix, keeping it unchanged if the relocated sysroot
	does not exist.
	(do_spec_1): Process 'R' spec.
	(main): Add md_exec_prefix to exec_prefixes regardless of
	startfile_prefix_spec.  Use add_sysrooted_prefix for
	startfile_prefixes, and don't skip the default ones when cross
	compiling with sysroot enabled.  Removed unused case of
	non-absolute standard_startfile_prefix.
	* config/interix.h: Remove the only potential, yet disabled,
	occurrence of non-absolute (empty) standard_startfile_prefix.
	* config/sh/linux.h (LIB_SPEC): Add -rpath-link in non-static
	linking.
	* config/mips/linux.h (LIB_SPEC): Define as in sh/linux.h.
	* doc/install.texi (--with-sysroot): Document.
	(--with-headers, --with-libs): Deprecate.

2003-11-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390-protos.h (s390_output_dwarf_dtprel): Declare.
	* config/s390/s390.c (s390_output_dwarf_dtprel): New function.
	* config/s390/s390.h (ASM_OUTPUT_DWARF_DTPREL): Define.

2003-11-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_function_arg_pass_by_reference): Return
	true for all arguments larger than 8 bytes, as well as for all vector
	type arguments.
	* config/s390/s390.h (RETURN_IN_MEMORY): Likewise for return values.

2003-11-05  Roger Sayle  <roger@eyesopen.com>

	PR optimization/10339
	* builtins.c (expand_builtin_strcmp): Try to emit cmpstrsi insn
	directly instead of unsafely transforming call into a memcmp.
	(expand_builtin_strncmp): Likewise.

2003-11-03  Alexander Kabaev  <ak03@gte.com>

	* real.c (encode_ieee_single): Ensure proper promotion.

2003-11-04  H.J. Lu <hongjiu.lu@intel.com>

	Backport from 3.4-branch

	2003-07-13  Andreas Jaeger  <aj@suse.de>

	* config.gcc: Add pmmintrin.h for x86_64-*-*.

	2003-06-26  H.J. Lu  <hongjiu.lu@intel.com>

	* config.gcc (extra_headers): Add pmmintrin.h for i[34567]86-*-*.

	* config/i386/i386.c (override_options): Turn on MASK_SSE2
	for -mpni.
	(bdesc_2arg): Add PNI builtins with 2 args.
	(bdesc_1arg): Add PNI builtins with 1 arg.
	(ix86_init_mmx_sse_builtins): Handle PNI builtins.
	(ix86_expand_builtin): Likewise.

	* config/i386/i386.h (MASK_3DNOW, MASK_3DNOW_A,
	MASK_128BIT_LONG_DOUBLE, MASK_64BIT, MASK_MS_BITFIELD_LAYOUT,
	MASK_TLS_DIRECT_SEG_REFS): Renumbered.
	(TARGET_PNI): New.
	(TARGET_SWITCHES): Add -mpni and -mno-pni.
	(TARGET_CPU_CPP_BUILTINS): Defined __PNI__ for PNI.
	(ix86_builtins): Add PNI builtins.
	(config/i386/i386.md): Add PNI patterns.

	* config/i386/pmmintrin.h: New file.

	* config/i386/i386.c (override_options): Turn on MASK_SSE for
	-msse2.
	(MASK_SSE1): Removed.
	(MASK_SSE164): Removed.
	(MASK_SSE264): Removed.
	(bdesc_2arg): Replace MASK_SSE1 with MASK_SSE. Replace
	MASK_SSE164 with MASK_SSE | MASK_64BIT. Replace MASK_SSE264
	with MASK_SSE2 | MASK_64BIT.
	(bdesc_1arg): Likewise.
	(ix86_init_mmx_sse_builtins): Likewise.

	* config/i386/i386.h (TARGET_SSE): Remove MASK_SSE2.

	2003-06-20  H.J. Lu  <hongjiu.lu@intel.com>

	* doc/extend.texi: Document new builtin functions for Intel
	Prescott New Intrunctions.

	* doc/invoke.texi: Document new command-line options, -mpni and
	-mno-pni, for Intel Prescott New Intrunctions.

	2003-06-05  H.J. Lu  <hongjiu.lu@intel.com>

	* config.gcc (extra_headers): Add emmintrin.h for i[34567]86-*-*
	and x86_64-*-*.

	* config/i386/mmintrin.h: Update version and add alternate
	intrinsic names.
	* config/i386/xmmintrin.h: Likewise.

	* config/i386/xmmintrin.h: Include <emmintrin.h>. Move SSE2
	intrinsics to ...
	* config/i386/emmintrin.h: Here. New file.

2003-11-04  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from 3.4-branch
	2003-04-25  H.J. Lu   <hjl@gnu.org>

	* config/ia64/ia64.c (ia64_expand_compare_and_swap): Add rmode
	for return mode.
	(ia64_expand_builtin): Set rmode to SImode for
	IA64_BUILTIN_BOOL_COMPARE_AND_SWAP_SI,
	IA64_BUILTIN_VAL_COMPARE_AND_SWAP_SI and
	IA64_BUILTIN_BOOL_COMPARE_AND_SWAP_DI. Set remode to DImode
	for IA64_BUILTIN_VAL_COMPARE_AND_SWAP_DI.

	2003-04-24  H.J. Lu  <hjl@gnu.org>

	* config/ia64/ia64.c (ia64_init_builtins): Add si_ftype_pdi_di_di
	for __sync_bool_compare_and_swap_di for int return type.

	* config/ia64/ia64intrin.h (__sync_bool_compare_and_swap_di):
	Change return type to int.
	(__sync_bool_compare_and_swap): Likewise.

2003-11-03  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* doc/contrib.texi: Add Giovanni Bajo, Dara Hazeghi, Falk Hueffner,
	and Andrew Pinski.

2003-11-03  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (stdio_va_list): Allow tab before va_list.
	Merge two substitutions.
	* fixinc/fixincl.x: Regenerate.
	Fixes PR bootstrap/12666.

2003-10-28  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR target/11598
	PR libgcj/10610
	* config/rs6000/sysv4.h (PREFERRED_STACK_BOUNDARY): New macro.

2003-10-27  Falk Hueffner  <falk@debian.org>

	PR target/12654
	* config/alpha/alpha.c (alpha_emit_conditional_branch): Don't do
	comparison against constant by adjusting the argument except for
	EQ and NE.

2003-10-26  Ottavio Campana <ottavio@campana.vi.it>

	PR target/12690
	* config/i386/mmintrin.h (_mm_set1_pi8): Fix comment.

2003-10-25  Bruce Korb  <bkorb@gnu.org>

	* gcc/fixinc/tests/base/ansi/string.h:
	This fixes a result from a broken sed or a hand-edited output file.
	The '__GNUC__' wrappers were misplaced.

2003-10-25  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12712
	* reg-stack.c (convert_regs_1): Create an arbitrary input stack
	if the block has no predecessors.
	(convert_regs_2): Document the problem with successors whose
	only predecessor is the block to be processed.
	(convert_regs): Don't create the arbitrary input stack here.

2003-10-22  David Taylor <dtaylor@emc.com>

	PR debug/12500
	* dbxout.c (dbxout_typedefs): Use COMPLETE_OR_VOID_TYPE_P.

2003-10-20  Zack Weinberg  <zack@codesourcery.com>

	* fixinc/inclhack.def (hpux11_snprintf): New edit.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/stdio.h: Add test for hpux11_snprintf.

2003-05-16  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/unwind-ia64.c (uw_update_reg_address): Handle
	.save XX, r0.

2003-10-19  Mark Mitchell  <mark@codesourcery.com>

	* doc/include/gcc-common.texi: Bump version number.
	* version.c (version_string): Reset to prerelease format.

2003-10-18  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/extend.texi: Fix typos.

2003-10-16  Release Manager

	* GCC 3.3.2 Released.

2003-10-14  Jason Merrill  <jason@redhat.com>

	PR c/11885
	* stor-layout.c (update_alignment_for_field): Packed non-bit-fields
	get byte alignment.

2003-10-14  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (alpha_pthread_gcc): New fix.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/pthread.h [ALPHA_PTHREAD_GCC_CHECK]: New
	testcase.
	Fixes PR bootstrap/9330.

2003-10-14  Steven Bosscher  <steven@gcc.gnu.org>

	PR target/11087
	Backport from gcc-3_3-rhl-branch and mainline.

	2003-07-17  Jakub Jelinek  <jakub@redhat.com>

	* loop.c (basic_induction_var): Check if convert_modes
	emitted any instructions. Remove them and return 0 if so.

2003-10-13  Matt Kraai <kraai@alumni.cmu.edu>

	PR target/11949
	Backport from mainline:

	2003-05-05  Aldy Hernandez  <aldyh@redhat.com>

	* testsuite/gcc.c-torture/compile/simd-6.c: New.
	* c-typeck.c (digest_init): Handle arrays of vector constants.

2003-10-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12544
	* function.c (put_var_into_stack): Don't generate ADDRESSOFs
	for DECL_NONLOCAL decls.

2003-10-09  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12510
	Backport from mainline:

	2003-09-08  Jakub Jelinek  <jakub@redhat.com>

	* toplev.c (rest_of_compilation): Call split_all_insns before
	regstack if optimizing but not scheduling after reload.

2003-10-09  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (stdio_va_list): Removed _ap fix.
	(irix_stdio_va_list): Don't require leading printf, IRIX 6.5.21
	introduced some multi-line prototypes.
	* fixinc/fixincl.x: Regenerate.
	Fixes PR libf2c/12263.

2003-10-08  Timo Kokkonen  <tjko@iki.fi>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR bootstrap/12490
	* scan-decls.c (MAX_EXTERN_C_BRACES): New preprocessor constant
	to define the size of the extern_C_braces array.  Set it to 200.
	(scan_decls): Abort when extern_C_braces_length is out-of-bounds.

2003-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12215
	* cse.c (cse_set_around_loop): Emit the move at the beginning
	of the next basic block for trapping sets.

2003-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11637
	* combine.c (adjust_for_new_dest): New function to adjust the
	notes and LOG_LINKS when the dest of an insn has changed.
	(try_combine): Use it when deleting the first insn of a two-insn
	parallel or splitting a two-load parallel.

2003-10-04  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/t-m68hc11-gas (MULTILIB_MATCHES): m68hcs12 is
	identical to m68hc12 as far as libraries are concerned.

2003-10-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/12446
	* c-typeck.c (convert_for_assignment): Issue an error for
	array to pointer assignment after default conversion.
	(digest_init): Likewise.

2003-10-03  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/extend.texi (Function Attributes): Fix title of GNU C
	Preprocessor manual.
	(C++ Extensions): Fix reference to "Predefined Macros" in the
	GNU C Preprocessor manual.

2003-10-03  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	PR/11883
	* cfgloop.c (flow_loops_find): Fix handling of abnormal edges.

2003-10-02  Mark Mitchell  <mark@codesourcery.com>

	PR optimization/12180
	* c-objc-common.c (inline_forbidden_p): Do not permit inlining of
	functions containing calls to __builtin_next_arg.

2003-10-02  Josef Zlomek  <zlomekj@suse.cz>

	PR/12292
	* combine.c (make_field_assignment): Check whether rtx's code
	is CONST_INT before using INTVAL.

2003-10-02  Josef Zlomek  <zlomekj@suse.cz>

	Waldek Hebisch <hebisch@math.uni.wroc.pl>
	PR/12072
	* varasm.c (compare_constant): Fix thinko.

2003-10-01  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* aclocal.m4: Add hpux10* and hpux11.00 to /dev/zero blacklist.
	* configure: Rebuilt.

2003-10-01  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* aclocal.m4: Add ultrix* to /dev/zero blacklist.
	* configure: Rebuilt.

2003-10-01  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config.gcc (sparc-*-solaris2*): Handle Solaris 10 and up like
	Solaris 7-9.

	* fixinc/inclhack.def (solaris_widec): Replace solaris2.[0-5]* by
	wildcards which explicitly match micro versions.
	* fixinc/fixincl.x: Regenerate.

2003-10-01  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (expand_builtin_init_dwarf_reg_sizes): Honor
	DWARF_ALT_FRAME_RETURN_COLUMN.
	* unwind-dw2.c (dwarf_reg_size_table): Expand by one.
	(_Unwind_GetGR, _Unwind_SetGR): Validate lookup column.
	(uw_frame_state_for): Return end-of-stack for null return address.

	* config/alpha/alpha.c (alpha_sa_mask): Add r31 for eh_return.
	(alpha_expand_prologue): Store a zero for it.
	(alpha_expand_epilogue): Don't reload it.
	* config/alpha/alpha.h (DWARF_ALT_FRAME_RETURN_COLUMN): New.
	* config/alpha/linux.h (MD_FALLBACK_FRAME_STATE_FOR): Use column 64
	for the sigframe return address.

2003-10-01  Nick Clifton  <nickc@redhat.com>

	* Import this patch from mainline:

	2003-02-01  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* collect2.c (pexecute_pid): Rename to pid.
	(collect_wait, collect_execute, scan_prog_file, scan_libraries): Use
	pid.

2003-09-23  David S. Miller  <davem@redhat.com>

	* config/sparc/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Undefine
	before redefining.
	* config/sparc/linux64.h (LINK_GCC_C_SEQUENCE_SPEC): Likewise.

2003-10-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11753
	* config/sparc/sparc.md (length attribute) [fcc branch]: Add 1 to
	the length in the non-V9 case.

2003-09-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12340
	* loop.h (struct induction): Document the new semantics
	of the 'same' field for bivs.
	* unroll.c (biv_total_increment): Don't count the same
	biv increment several times.
	(loop_iterations) [GENERAL_INDUCT]: Likewise.

2003-09-26  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR bootstrap/12358
	* pa.c (output_bvb): Fix typo.

2003-09-24  Alexandre Oliva  <aoliva@redhat.com>

	* cpplib.c (do_pragma): Reintroduce cb_line_change call in the
	code path that calls a handler.

2003-09-23  Geoffrey Keating  <geoffk@apple.com>

	* config/t-darwin (crt2.o): Add stmp-int-hdrs to dependencies.

	* config/rs6000/rs6000.c (function_arg_pass_by_reference): Don't
	pass zero-size arrays by reference.
	(rs6000_va_arg): Likewise.

2003-09-22	Joel Sherrill <joel@oarcorp.com>

	* combine.c, config/mips/t-elf, config/c4x/rtems.h: Revert patches
	which should not have been committed with other RTEMS changes.

2003-09-22  Olivier Hainque  <hainque@act-europe.fr>

	PR target/9786
	* reg-stack.c (convert_regs_1): Purge possible dead eh edges
	after potential deletion of trapping insn. Avoids later ICE
	from call to fixup_abnormal_edges.
	(convert_regs_2): Stack the current block successors before
	processing this block, that is, before the potential deletion of
	dead edges by convert_regs_1, because these edges have been used
	to initialize the predecessors count.

2003-09-21  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12301
	* reorg.c (stop_search_p): Return 1 for insns that can
	throw internally.

2003-09-19  Joel Sherrill <joel@oarcorp.com>

	* config/m68k/t-m68kbare, config/m68k/t-rtems: Change 68681 to
	68881.

2003-09-19  Ralf Corsepius <corsepiu@faw.uni-ulm.de>

	* config/m68k/t-rtems (m68k-*-rtems*): New.
	* config.gcc: Use config/m68k/t-rtems.

2003-09-19  Ralf Corsepius <corsepiu@faw.uni-ulm.de>

	* config/mips/t-rtems: New.
	* config.gcc (mips*-*-rtems*): Use config/mips/t-rtems.

2003-09-19  T. Papadopoulo <Theodore.Papadopoulo@sophia.inria.fr>
	    Eric Botcazou <ebotcazou@libertysurf.fr>

	PR target/12166
	* config/sparc/sol2-c1.asm (start): Set __Argv if GCRT1.

2003-09-18  Mark Mitchell  <mark@codesourcery.com>

	PR target/11184
	* builtins.c (expand_builtin_apply): Use convert_memory_address
	before returning the value.

2003-09-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_hidden): Only disable if no GNU ld
	detected.
	* configure: Regenerate.
	Fixes PR target/12248.

2003-09-17  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_expand_mov): Do gen_movdi_er_maybe_g
	always during initial code generation.
	* config/alpha/alpha.md (movdi_er_maybe_g): Don't conditionalize
	on flag_inline_functions.

2003-09-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11646
	* cfgrtl.c (purge_dead_edges) [JUMP_INSN]: Rematerialize the
	EDGE_ABNORMAL flag for EH edges.
	* toplev.c (rest_of_compilation): Delete unreachable blocks
	if dead edges were purged after the first CSE pass.

2003-09-16  Jakub Jelinek  <jakub@redhat.com>

	* config/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/alpha/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/arm/linux-elf.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/rs6000/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/rs6000/linux64.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/sh/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/sparc/linux.h (LINK_GCC_C_SEQUENCE_SPEC): Define.
	* config/sparc/linux64.h (LINK_GCC_C_SEQUENCE_SPEC): Define.

2003-09-15  Alexandre Oliva  <aoliva@redhat.com>

	* cpplib.c (do_pragma): Remove unnecessary cb_line_change.

2003-09-14  Alexandre Oliva  <aoliva@redhat.com>

	* cppmain.c (cb_line_change): Revert 2003-08-04's change.
	* c-lex.c (cb_line_change): Skip line changing whenever
	cppmain.c would.

2003-09-11  Alexandre Oliva  <aoliva@redhat.com>

	PR fortran/11522
	* dwarf2out.c (gen_inlined_subroutine_die): Emit abstract function
	for ultimate origin even if block is abstract.

2003-09-10  Martin Husemann  <martin@duskware.de>

	PR target/11965
	* config/sparc/sparc.c (sparc_v8plus_shift): Protect against
	constants greater than 63.
	* config/sparc/sparc.md (ashlsi3, ashrsi3, lshrsi3): Protect
	against constants greater than 31.
	(*ashldi3_sp64, *ashrdi3_sp64, *lshrdi3_sp64): Protect against
	constants greater than 63.

2003-09-09  Richard Henderson  <rth@redhat.com>

	PR target/12224:
	* config/ia64/ia64.c (ia64_expand_move): Properly truncate
	result when op0 is SImode.

2003-09-09  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_ix86_cmov_sun_syntax): Check if
	assembler supports Sun syntax for cmov.
	* configure: Regenerate.
	* config.in: Li{ewise.
	* config/i386/i386.c: Rename CMOV_SUN_AS_SYNTAX to
	HAVE_AS_IX86_CMOV_SUN_SYNTAX.
	* config/i386/sol2.h (CMOV_SUN_AS_SYNTAX): Remove.
	Fixes PR target/12101.

2003-09-09  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_hidden): Disable unless using GNU ld.
	* configure: Regenerate.

2003-09-08  Mark Mitchell  <mark@codesourcery.com>

	* mklibgcc.in (libcc.a): Depend on stmp-dirs.
	(libgov.a): Likewise.
	(libgcc_eh.a): Likewise.

2003-09-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/11689
	* config/i386/i386.c (memory_address_length): Fix computation when
	the base is esp or ebp.

2003-09-07  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11852
	* varasm.c (initializer_constant_valid_p): Correct logic for
	CONSTRUCTORs.

Sun Sep  7 14:53:36 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cfgcleanup.c (try_simplify_condjump): Fix again the preivous patch.

2003-09-07  Christian Ehrhardt  <ehrhardt@mathematik.uni-ulm.de>

	PR optimization/11662
	Backport from mainline:

	2003-07-10  Denis Chertykov  <denisc@overta.ru>
		    Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* combine.c (gen_binary): Handle the CLOBBER rtx and
	don't build a binary operation with it.

Sat Sep  6 23:16:35 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cfgcleanup.c (try_simplify_condjump): Fix my previous patch.

	PR target/12070
	* calls.c (emit_library_call_value_1): Fix saving of BLKmode arguments.

	PR opt/12082
	* cfgcleanup.c (try_simplify_condjump): Avoid unreachable code warning.

2003-09-06  Steven Bosscher  <steven@gcc.gnu.org>

	PR c/9862
	* c-decl.c (c_expand_body): Move return warning from here...
	(finish_function): ...to here.

2003-09-05  Jan Hubicka  <jh@suse.cz>

	PR target/8869
	* expr.c (convert_modes): Deal properly with integer to vector
	constant conversion.

2003-09-05  Andrew Pinski <pinskia@physics.uc.edu>

	PR c/10962
	* c-decl.c (field_decl_cmp): Add back function.
	(finish_struct): Sort fields if number greater than 15
	and no anymous structs/unions.

2003-09-04  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/libgcc-ia64.ver: Export _Unwind_GetBSP@@GCC_3.3.2.
	* config/ia64/unwind-ia64.c (_Unwind_GetBSP): New function.
	* unwind.h (_Unwind_GetBSP): New prototype.
	* libgcc-std.ver: Add empty GCC_3.3.2 version.
	* mkmap-symver.awk: For symbol versions with no exported symbols,
	don't put anything into version script, just change all symbol
	versions which inherit from it to inherit from its ancestor.

2003-09-02  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	This is a fix for PR 10988:
	* m32r.c (m32r_print_operand): Correct comment.
	(m32r_expand_block_move): Correct the handling of leftover/small
	blocks.
	(m32r_block_small_immediate_operand): New predicate.
	* m32r.md (movstrsi_small_internal): New pattern.
	* m32r.h (PREDICATE_CODES): Add m32r_block_small_immediate_operand.
	* m32r-protos.h: Add prototype for m32r_block_small_immediate_operand.

2003-08-25  Richard Henderson  <rth@redhat.com>

	* config/i386.i386.c (ix86_return_in_memory): Reformat.  Return true
	for 16-byte vector modes if sse not enabled; warn for abi change.
	(ix86_value_regno): Only return xmm0 for 16-byte vector types.

2003-08-25  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc (hppa*-*-hpux11*, ia64*-*-hpux*): Remove
	commented-out logic to use DCE threads (if present), add
	support for POSIX threads.
	* config/ia64/hpux.h: Define CPP_SPEC to set appropriate
	#defines for -pthread.  Add -lpthread to LIB_SPEC when
	-pthread.  In both cases take -mt as a synonym for -pthread
	for acc compatibility.
	Define GTHREAD_USE_WEAK to 0.
	* config/pa/pa-hpux11.h: Likewise for CPP_SPEC and LIB_SPEC.
	Remove old logic for DCE threads from LIB_SPEC.
	* config/pa/pa64-hpux.h: Define GTHREAD_USE_WEAK to 0.

2003-08-25  Ulrich Weigand  <uweigand@de.ibm.com>

	* combine.c (distribute_notes): Handle REG_ALWAYS_RETURN.

2003-08-23  Jakub Jelinek  <jakub@redhat.com>

	* c-decl.c (pushdecl): Only put decls which finish_struct will do
	something about onto incomplete chain.
	(finish_struct): If not removing type from incomplete
	list, update prev.

2003-08-23  Alexandre Oliva  <aoliva@redhat.com>

	* cppmain.c (cb_line_change): Don't skip line changing while
	parsing macro arguments in the top-level context.

2003-08-22  Mark Mitchell  <mark@codesourcery.com>

	* config/ia64/hpux.h (SUPPORTS_INIT_PRIORITY): Define to 0.

	* config/ia64/ia64.c (ia64_output_mi_thunk): Support ILP32 mode.

2003-08-21  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/11805
	* config/h8300/h8300.md (two anonymous patterns): Remove.

2003-08-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* stmt.c (expand_asm_operands): Avoid string concatenation.
	* tree.c (default_flag_random_seed): Avoid ISO C definition.
	* varasm.c (output_constant_def): Delete unused variable.

2003-08-18  Matt Kraai  <kraai@alumni.cmu.edu>

	PR c/11207
	* c-typeck.c (set_init_index): Check for negative index.

2003-08-14  Mark Mitchell  <mark@codesourcery.com>

	* version.c (version_string): Use "prerelease" not "experimental".

2003-08-11  James E Wilson  <wilson@tuliptree.org>

	PR optimization/11319
	PR target/10021
	* alias.c (find_base_value, case REG): Return 0 not src if no base
	found.

2003-08-11  Kean Johnston  <jkj@sco.com>

	* fixinc/inclhack.def (sco_math): Updated test text and select trigger
	according to bkorb's review.
	* fixinc/inclhack.def (sco_regset): Ditto.
	* fixinc/inclhack.def (AAB_svr4_replace_byteorder): Remove all mach
	lines so that this file is unconditionally replaced.
	* fixinc/inclhack.def (sco_string): Use ansi/string.h as the first file
	to check so that the Ultrix string.h check doesnt overwrite the test
	case with its replacement text.
	* fixinc/fixincl.x: Regenerated
	* fixinc/tests/base/math.h: Updated sco_math result text
	* fixinc/tests/base/ansi/string.h: New file.
	* fixinc/tests/base/sys/regset.h: Compacted result text to fewer lines.

2003-08-11  Dale Johannesen  <dalej@apple.com>
	* config/rs6000/rs6000.md (ctrsi, ctrdi):  Reenable handling of
	decrement-and-branch farther away than 32 bits.

2003-08-10  Zack Weinberg  <zack@codesourcery.com>

	Backport the following changes from mainline:

    2003-05-08  David Mosberger <davidm@hpl.hp.com>

	* unwind-libunwind.c (_Unwind_FindEnclosingFunction): New.

    2003-04-03  Richard Henderson  <rth@redhat.com>

	* unwind-libunwind.c (_Unwind_GetCFA): New.

    2003-03-27  David Mosberger <davidm@hpl.hp.com>

	* unwind-libunwind.c (uw_frame_state_for): Adjust for libunwind
	v0.9 API change: replace read of UNW_REG_HANDLER with
	unw_get_proc_info().
	(_Unwind_GetLanguageSpecificData): Replace read of UNW_REG_LSDA
	with unw_get_proc_info().
	(_Unwind_GetRegionStart): Replace UNW_REG_PROC_START with
	unw_get_proc_info().

    2003-03-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* unwind-libunwind.c: Replace "GNU CC" with "GCC".

    2002-10-02  David Mosberger-Tang  <David.Mosberger@acm.org>

	* config/t-libunwind: Mention unwind-sjlj.c.
	* unwind-libunwind.c: Change #ifdef __USING_LIBUNWIND_EXCEPTIONS__
	to #ifndef __USING_SJLJ_EXCEPTIONS__.

	* configure.in: Move sjlj-exceptions and --enable-libunwind-exceptions
	before inclusion of config.gcc, but after configuring the compiler etc.
	Determine default value for --enable-libunwind-exceptions based on
	whether the host has a libunwind library (not guaranteed to be correct,
	but it's a reasonable first guess and can always be overridden with an
	explicit --enable/disable-libunwind-exceptions.
	* config.gcc: For target ia64*-*-linux*, mention t-libunwind as a
	tmake_file when $use_libunwind_exceptions is enabled.
	* Makefile.in: Update comment: LIB2ADDEH is updated not just by
	ia64 (e.g., config/t-linux also updates it).
	* gcc.c (init_spec) [USE_LIBUNWIND_EXCEPTIONS]: Mention -lunwind
	along with the shared version of libgcc since the latter requires
	the former.

	* unwind-libunwind.c: New file.
	* config/t-libunwind: Ditto.

2003-08-10  Richard Henderson  <rth@redhat.com>

	PR target/11693
	* config/ia64/ia64.c (ia64_emit_nops): Skip L slots when
	padding before inline assembly.

2003-08-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR c++/11712
	* pa-hpux.h, pa-hpux10.h, pa-hpux11.h (TARGET_OS_CPP_BUILTINS): Define
	__STDC_EXT__ when using C++ dialect.

2003-08-08  Kean Johnston  <jkj@sco.com>

	PR target/9877
	PR target/8336
	* config.gcc (sco3.2v5*): Use elfos.h and dbxelf.h in tm_file;
	Eliminate need for t-sco5gas target fragment.
	No longer build crt{begin,end}S.o, that were used for COFF support.
	* tlink.c (recompile_files): Add missing = in putenv() calls.
	* unwind-dw2.c (_Unwind_GetCFA): Correct return cast.
	* config/i386/sco5.h: Major overhaul to remove all COFF support
	* config/i386/t-sco5: Multilib for PIC support
	* config/i386/t-sco5gas: Remove
	* config/i386/i386.c: Check value as well as presence of
	SUPPORTS_ONE_ONLY
	* doc/install.texi: Update for modern SCO instructions
	* fixinc/check.tpl: Allow user to specify diff program for make check
	* fixinc/inclhack.def: Fix several SCO header files, namely string.h,
	math.h, sys/byteorder.h and sys/regset.h.
	* fixinc/fixincl.x: Regenerate
	* fixinc/tests/base/math.h: Update
	* fixinc/tests/base/sys/byteorder.h: Update
	* fixinc/tests/base/string.h: Added
	* fixinc/tests/base/sys/regset.h: Added
	* testsuite/gcc.dg/nest.c: Allow failure on SCO (-pg not supported)

2003-08-08  Roger Sayle  <roger@eyesopen.com>

	PR c/11370
	* calls.c (emit_call_1): Don't bother popping the arguments off of
	the stack after a noreturn function call;  The adjustment is dead.
	(expand_call): Likewise.

2003-08-08  SUGIOKA Toshinobu  <sugioka@itonet.co.jp>

	* config.gcc: Do not override sh/t-linux with sh/t-le.

2003-08-08  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/linux.h (SUBTARGET_LINK_SPEC): Don't set rpath.
	(LIB_SPEC): Set -lpthread always when -pthread set.  Set -lieee
	when -mieee-fp set and -shared not set.

2003-08-08  Richard Henderson  <rth@redhat.com>

	PR target/11535
	* config/ia64/ia64.c (ia64_initial_elimination_offset): Remove
	RETURN_ADDRESS_POINTER_REGNUM.
	(ia64_expand_prologue): Don't frob it.
	(ia64_output_function_epilogue): Likewise.
	(ia64_return_addr_rtx): New.
	(ia64_split_return_addr_rtx): New.
	* config/ia64/ia64-protos.h: Update.
	* config/ia64/ia64.h (FIRST_PSEUDO_REGISTER): Decrement.
	(RETURN_ADDRESS_POINTER_REGNUM): Remove.
	(GENERAL_REGNO_P): Don't check it.
	(AR_*_REGNUM): Renumber.
	(FIXED_REGISTERS): Remove RETURN_ADDRESS_POINTER_REGNUM.
	(CALL_USED_REGISTERS, CALL_REALLY_USED_REGISTERS): Likewise.
	(REG_ALLOC_ORDER, REG_CLASS_CONTENTS): Likewise.
	(ELIMINABLE_REGS, REGISTER_NAMES): Likewise.
	(RETURN_ADDR_RTX): Use ia64_return_addr_rtx.
	* config/ia64/ia64.md (UNSPEC_RET_ADDR): New.
	(movdi_ret_addr): New.

2003-08-03  Geoffrey Keating  <geoffk@apple.com>

	PR 11709
	* varasm.c (output_constant_def_contents): Use
	ASM_DECLARE_CONSTANT_NAME if defined.
	* doc/tm.texi (Label Output): Document ASM_DECLARE_CONSTANT_NAME.
	* config/darwin.h (ASM_DECLARE_OBJECT_NAME): Ensure zero-sized
	objects get at least one byte to prevent assembler problems.
	(ASM_DECLARE_CONSTANT_NAME): New.

2003-08-07  Mark Mitchell  <mark@codesourcery.com>

	* version.c (version_string): Reset to prerelease.
	* doc/include/gcc-common.texi: Update version.

2003-08-04  Release Manager

	* GCC 3.3.1 Released.

2003-08-04  Release Manager

	* GCC 3.3.1 Released.

2003-08-03  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/11534
	* cppexp.c (parse_defined): Warn only if -pedantic.

2003-08-03  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (ORDINARY_FLAGS_TO_PASS): Pass AR.

	* Makefile.in (STAGE2_FLAGS_TO_PASS): Pass AR_FOR_TARGET and
	RANLIB_FOR_TARGET.
	(stage1_build): Likewise.

2003-08-03  Jan Hubicka  <jh@suse.cz>

	PR 10510
	* config/pa/pa.h (MAYBE_FP_REG_CLASS_P): New.
	(SECONDARY_MEMORY_NEEDED): Use it.

2003-08-01  Geoffrey Keating  <geoffk@apple.com>

	PR 11709 (partial fix)
	* config/rs6000/rs6000.c (rs6000_output_function_epilogue): Don't
	insert a label at the end of an function under Mach-O.

	PR 11313
	* c-pragma.c (maybe_apply_pragma_weak): Don't get DECL_ASSEMBLER_NAME
	when it's not needed.

2003-07-29  Richard Henderson  <rth@redhat.com>

	PR target/10681

	2003-06-27  J"orn Rennecke <joern.rennecke@superh.com>
	* flow.c (propagate_one_insn): Use proper test for a register
	being part of the return value.

	2003-06-26  Richard Henderson  <rth@redhat.com>
	* flow.c (propagate_one_insn): Preserve live-at-end registers
	across tail calls.

	2003-06-26  Richard Henderson  <rth@redhat.com>
	* config/ia64/ia64.c (ia64_expand_call): Don't add ar.pfs for sibcalls.
	(ia64_split_call): Only load descriptor for GP register inputs.
	(ia64_expand_epilogue): Check current_frame_info.mask not
	current_function_is_leaf to restore ar.pfs.

2003-07-26  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Testing): Adjust required versions of DejaGnu.

2003-07-24  Aldy Hernandez  <aldyh@redhat.com>

	Backport the folling patch.

	2003-04-01  Aldy Hernandez  <aldyh@redhat.com>

	PR/8878
	* expr.c (expand_expr): Handle VECTOR_CST.
	(const_vector_from_tree): New.

	* varasm.c (output_constant): Handle VECTOR_CST.

	* c-typeck.c (digest_init): Build a vector constant from a
	VECTOR_TYPE.

2003-07-23  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/11607 and PR target/11516
	* pa.md (extzv, extv, insv): Revert latter half of last patch.

2003-07-23  Mark Mitchell  <mark@codesourcery.com>

	PR optimization/10679
	* tree-inline.c (inlinable_function_p): Honor MIN_INLINE_INSNS.

2003-07-22  Bob Wilson  <bob.wilson@acm.org>

	* unwind-c.c (PERSONALITY_FUNCTION): Delete duplicate define.

2003-07-23  Dave Fluri  <dave.fluri@onlink.net>

	* doc/extend.texi: Fixes to spelling, grammar, and diction.

2003-07-21  H.J. Lu <hongjiu.lu@intel.com>

	PR optimization/11599
	* config/ia64/ia64.md (prefetch): Support predicate.

2003-07-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11536
	* unroll.c (loop_iterations): Do not replace a register holding
	the final value by its equivalent before the loop if it is not
	invariant.

2003-07-21  Ben Elliston  <bje@wasabisystems.com>

	* doc/invoke.texi (V850 Options): Spelling fixes.

2003-07-21  Lisa M. Goldstein  <opus@gnu.org>

	* doc/invoke.texi: Fixes to style, grammar and diction.

2003-07-20  Mark Mitchell  <mark@codesourcery.com>

	PR debug/11279
	* dwarf2out.c (gen_enumeration_type_die): Remember that
	enumerators can be unsigned.

2003-07-19  Kelley Cook  <kelleycook@wideopenwest.com>

	* c-tree.texi: Backport changes from mainline.
	* c-tree.texi: Ditto.
	* collect2.texi: Ditto.
	* cpp.texi: Ditto.
	* cppopts.texi: Ditto.
	* extend.texi: Ditto.
	* fragments.texi: Ditto.
	* headerdirs.texi: Ditto.
	* install.texi: Ditto.
	* invoke.texi: Ditto.
	* md.texi: Ditto.
	* portability.texi: Ditto.
	* rtl.texi: Ditto.
	* sourcebuild.texi: Ditto.
	* trouble.texi: Ditto.

2003-07-19  Kelley Cook  <kelleycook@wideopenwest.com>

	PR optimization/4490
	* doc/invoke.texi (m96bit-long-double, m128bit-long-double):  Reword
	documentation to accurately reflect what these options do.

2003-07-18  Richard Henderson  <rth@redhat.com>
	    David S. Miller  <davem@redhat.com>

	PR target/11556
	* optabs.c (prepare_operand): Fail gracefully instead of abort
	if the predicate doesn't satisfy.
	(gen_cond_trap): Allow prepare_operand to fail.
	Pass correct opnum argument to prepare_operand.

2003-07-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11083
	* toplev.c (rest_of_compilation): Delete unreachable blocks
	if dead edges were purged after the addressof pass.

2003-07-17  Mark Mitchell  <mark@codesourcery.com>

	PR optimization/11557
	* calls.c (flags_from_decl_or_type): Do not set ECF_LIBCALL_BLOCK
	unless we know which function is being called.

2003-07-17  Nathanael Nerode  <neroden@gcc.gnu.org>

	PR bootstrap/11043
	* config/arc/t-arc: Replace bogus references to "x-crtinit.o",
	"x-crtfini.o" with "crtinit.o", "crtfini.o".

2003-07-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR other/11466
	* doc/invoke.texi (SPARC Options): Document "-mlittle-endian"
	and its restrictions for the SPARC64 port.

	Backport from mainline:
	2003-06-13  Florian Weimer  <fw@deneb.enyo.de>

	* doc/invoke.texi (SPARC Options): Document "-mimpure-text".

2003-07-17  Eric Botcazou <ebotcazou@libertysurf.fr>
	    Phil Edwards <phil@jaj.com>

	* doc/install.texi (*-*-solaris2*): Document the step-by-step
	procedure to bootstrap and install.
	Document the preference for the legacy Sun tools in /usr/bin
	over the POSIX tools in /usr/xpg4/bin for the build process.

2003-07-16  Richard Henderson  <rth@redhat.com>

	PR target/10907
	* config/ia64/ia64.c (ia64_epilogue_uses): GP is live at end
	even with !TARGET_CONST_GP.
	(ia64_function_ok_for_sibcall): Reject non-local functions.

2003-07-15  Geoffrey Keating  <geoffk@apple.com>

	* config/darwin.c (machopic_select_section): Use decl_readonly_section
	to do most of the work.

2003-07-15  David S. Miller  <davem@redhat.com>

	* config/sparc/sparc.c (sparc_nonflat_function_epilogue): Only
	emit nop if the last real insn is CALL_INSN.

2003-07-15  Loren James Rittle  <ljrittle@acm.org>

	* config/i386/freebsd.h (SET_ASM_OP): Remove.
	(SUBTARGET_OVERRIDE_OPTIONS): Handle TARGET_64BIT case.
	(ASM_COMMENT_START, ASM_APP_ON, ASM_APP_OFF, DBX_REGISTER_NUMBER
	 MCOUNT_NAME, SIZE_TYPE, PTRDIFF_TYPE, WCHAR_TYPE_SIZE): Whitespace.

2003-07-15  Mark Mitchell  <mark@codesourcery.com>

	PR debug/11473
	* dbxout.c (dbxout_type): Use TYPE_SIZE to determine the sizes of
	base classes.

2003-07-15  James A. Morrison  <ja2morri@student.math.uwaterloo.ca>

	* doc/include/texinfo.tex: Upgrade to texinfo 4.6.

2003-07-15  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11320
	* sched-int.h (struct deps) [reg_conditional_sets]: New field.
	(struct sched_info) [compute_jump_reg_dependencies]: New prototype.
	* sched-deps.c (sched_analyze_insn) [JUMP_INSN]: Update call to
	current_sched_info->compute_jump_reg_dependencies. Record which
	registers are used and which registers are set by the jump.
	Clear deps->reg_conditional_sets after a barrier.
	Set deps->reg_conditional_sets if the insn is a COND_EXEC.
	Clear deps->reg_conditional_sets if the insn is not a COND_EXEC.
	(init_deps): Initialize reg_conditional_sets.
	(free_deps): Clear reg_conditional_sets.
	* sched-ebb.c (compute_jump_reg_dependencies): New prototype.
	Mark registers live on entry of the fallthrough block and conditionally
	set as set by the jump. Mark registers live on entry of non-fallthrough
	blocks as used by the jump.
	* sched-rgn.c (compute_jump_reg_dependencies): New prototype.
	Mark new parameters as unused.

2003-07-14  Mark Mitchell  <mark@codesourcery.com>

	PR debug/11098
	* integrate.c (copy_decl_for_inlining): Do not mark copied decls
	as DECL_ABSTRACT.

2003-07-14  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR optimization/11440
	* gcse.c (try_replace_reg): Don't attach notes to ZERO_EXTRACT or
	SIGN_EXTRACT SETs.

2003-07-13  Aaron W. LaFramboise  <awlaframboise@aol.com>

	* config/i386/gthr-win32.c (__GTHREAD_HIDE_WIN32API): Define to 1.

2003-07-13  Roger Sayle  <roger@eyesopen.com>

	PR optimization/11059
	* expr.c (can_store_by_pieces): Return true if length is zero.
	(store_by_pieces): Do nothing if length is zero.
	(clear_by_pieces): Do nothing if length is zero.
	(clear_storage): Do nothing if length is zero.
	(store_constructor): Simplify code when size is zero, or the
	target has already been cleared.  This avoids emitting a
	blockage instruction when initializing empty structures.

2003-07-13  Richard Henderson  <rth@redhat.com>

	* libgcc-std.ver (GCC_3.3.1): Export __gcc_personality_sj0,
	__gcc_personality_v0.

2003-07-11  Dara Hazeghi  <dhazeghi@yahoo.com>

	PR optimization/10877
	* doc/install.tex: Update required binutils for i?86-*-linux*

2003-07-11  Ben Elliston  <bje@redhat.com>

	PR c++/1607
	* doc/extend.texi (Function Attributes): Document the effect of
	the C++ "this" parameter on the counting of arguments for the
	"format" and "format_arg" attributes.

2003-07-11  Danny Smith  <dannysmith@users.sourceforge.net>

	Backport from mainline.

	2003-05-13  Richard Henderson  <rth@redhat.com>

	* c-decl.c (duplicate_decls): Re-invoke make_decl_rtl if
	the old decl had instantiated DECL_RTL.

	2003-05-21  Danny Smith  <dannysmitx@users.sourceforge.net>

	PR c++/9738
	* config/i386/winnt.c (i386_pe_encode_section_info): Enable
	even if not first.

	2003-07-04  Danny Smith  <dannysmith@users.sourceforge.net>

	PR c++/5287, PR c++/7910, PR c++/11021
	* config/i386/winnt.c (ix86_handle_dll_attribute): Don't add
	dllimport attribute if function is defined at declaration, but
	report error instead. Likewise for dllimport'd variable
	definitions.  Set implicit TREE_PUBLIC for dllimport'd variables
	declared within functions, Report error if dllimport or dllexport
	symbol is not global.
	(i386_pe_dllimport_p): Ignore dllimport attribute of functions
	if defined after declaration or if inlined. Don't allow definition
	of static data members of C++ classes. Don't dllimport virtual
	methods.
	(i386_pe_mark_dllexport): Warn about inconsistent dll attributes.
	(i386_pe_mark_dllimport): Remove unnecessary checks.
	(i386_pe_encode_section_info): Warn if the dllimport attribute
	and symbol prefix have been instantiated and then overridden.

	* doc/extend.texi: Document dllimport and dllexport attributes.

2003-07-10  James E Wilson  <wilson@tuliptree.org>

	PR optimization/9745
	* loop.c (loop_iv_add_mult_emit_before): Call loop_regs_update before
	loop_insn_emit_before.
	(loop_iv_add_mult_sink, loop_iv_add_mult_hoist): Likewise.

2003-07-10  Dara Hazeghi  <dhazeghi@yahoo.com>

	PR bootstrap/10758
	* doc/install.texi: Document requirements for ia64-*-hpux* target.

2003-07-09  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10032
	* doc/invoke.texi (C++ Dialect Options): Change documentation of
	-fpermissive.

2003-07-10  Matt Kraai  <kraai@alumni.cmu.edu>

	* doc/invoke.texi: Fix misspelling of "@item".

2003-07-09  Hans-Peter Nilsson  <hp@bitrange.com>

	* doc/install.texi (Configuration): Document the valgrind option
	to --enable-checking.

2003-07-08  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR Target/11453
	* pa.md: Disparage all mtsar constraints.
	(extzv, extv, insv): Don't fail on length of {32|64}.

2003-07-08  James E Wilson  <wilson@tuliptree.org>

	PR target/10021
	* emit-rtl.c (set_mem_attribute_minus_bitpos): When handle ARRAY_REF,
	loop over new variable t2 instead of t.

2003-07-08  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.h (HAVE_AS_DWARF2_DEBUG_LINE): Don't define
	as .file/.loc directives are incompatible with linker relaxation.

2003-07-08  Jakub Jelinek  <jakub@redhat.com>

	PR c/11420
	* config/i386/i386.c (ix86_check_movabs): New function.
	* config/i386/i386-protos.h (ix86_check_movabs): New prototype.
	* config/i386/i386.md (movabs[shqd]i_1_rex64): Kill broken alternative.
	(movabs[shqd]i_[12]_rex64): Add ix86_check_movabs check to conditions.

	* config/i386/i386.md (movdi_1_rex64): Set Y<-m alternative's type
	to ssemov.

2003-07-08  Jakub Jelinek  <jakub@redhat.com>

	* unroll.c (reg_dead_after_loop): Check for reg in REG_EQUAL and
	REG_EQUIV notes as well.

2003-07-07  Dale Johannesen <dalej@apple.com>

	PR 10900
	* config/rs6000/darwin-tramp.asm:  Fix trampolines.

2003-07-07 Andrew Pinski <pinskia@physics.uc.edu>

	PR optimization/11368
	* doc/invoke.texi (-falign-functions): Document that
	when n is zero then a machine-dependent default is used.
	(-falign-labels): Document that when n is zero then a
	machine-dependent default is used and that -falign-labels =1
	is equivalent to -fno-align-labels.
	(-falign-loops): Likewise.
	(-falign-jumps): Likewise.

2003-07-07  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11198
	* alias.c (objects_must_conflict_p): Return 1 if the types have
	the same alias set, not if the alias sets only conflict.

2003-07-06  Matthias Klose  <doko@debian.org>

	Backport from mainline:

	2003-07-04  Zack Weinberg  <zack@codesourcery.com>

	* doc/extend.texi: Delete entire section on multiline strings.

2003-07-04  H.J. Lu <hongjiu.lu@intel.com>

	* Makefile.in: Replace PWD with PWD_COMMAND.

2003-07-03  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11304
	Backport from mainline:

	2003-04-18  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* cfgcleanup.c (flow_find_cross_jump): Use INSN_P, not active_insn_p.

2003-07-03  Roger Sayle  <roger@eyesopen.com>

	PR target/10700
	* fold-const.c (extract_muldiv_1): There's nothing that can be done
	if the expression is a SAVE_EXPR.

2003-07-03  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11381
	* simplify-rtx.c (simplify_relational_operation): Check that
	two equal operands have no side-effects before simplifying
	the comparison.

2003-07-01  Zack Weinberg  <zack@codesourcery.com>

	PR 2873
	* fixinc/inclhack.def (avoid_wchar_t_type): Add bypass
	expressions to prevent triggering on recent curses.h,
	linux/nls.h, or X11/Xlib.h.
	(stdio_va_list): Add _G_va_list to bypass pattern.
	(strict_ansi_not): Add bypass pattern for __SCO_VERSION__.
	* fixinc/fixincl.x: Regenerate.

2003-07-02  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (irix_stdio_va_list): Apply to IRIX 6.5
	<internal/stdio_core.h> too.
	(stdio_va_list): Apply to IRIX 6.5 <internal/stdio_core.h> and
	<internal/wchar_core.h> too.
	Substitute va_list uses in inline definition.
	* fixinc/fixincl.x: Regenerate.

2003-07-01  Richard Henderson  <rth@redhat.com>
	    (blame to: Loren James Rittle  <ljrittle@acm.org>)

	* real.h (ieee_extended_intel_96_round_53_format): New.
	* real.c (ieee_extended_intel_96_round_53_format): New.
	* config/i386/freebsd.h (SUBTARGET_OVERRIDE_OPTIONS): Use it
	for XFmode and TFmode.

2003-07-01  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/contrib.texi: Fix typos.
	* doc/sourcebuild.texi: Likewise.

2003-06-27  Gunther Nikl  <gni@gecko.de>

	PR target/11014
	* config/m68k/m68k.c (m68k_output_mi_thunk): Use correct assembly
	syntax for MIT / MOTOROLA.

2003-06-27  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.h (SECONDARY_OUTPUT_RELOAD_CLASS): Define.
	* config/s390/s390.c (s390_secondary_output_reload_class): New function.
	* config/s390/s390-protos.h (s390_secondary_output_reload_class):
	Declare it.
	* config/s390/s390.md ("reload_outti", "reload_outdi",
	"reload_outdf"): New expanders.

	* config/s390/s390.md ("movti" + splitters): Handle non-offsettable
	memory operands as source.
	("movdi" + splitters): Likewise.
	("movdf" + splitters): Likewise.
	* config/s390/s390.c (s390_split_ok_p): New function.
	* config/s390/s390-protos.h (s390_split_ok_p): Declare it.

2003-06-27  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.md (trap): Use break 0 when !TARGET_GAS.

	* config/mips/iris6-o32.h (MIPS_ISA_DEFAULT): Remove.
	(MIPS_CPU_STRING_DEFAULT): Redefine to mips2.

	* config/mips/mips.c (TARGET_ASM_UNALIGNED_DI_OP) [TARGET_IRIX5 &&
	!TARGET_IRIX6]: Define as NULL.

	* config/mips/iris5gas.h (MDEBUG_ASM_SPEC): Override to match
	DWARF 2 default.

	* config/mips/dbxmdebug.h: New file.
	* config.gcc (mips-sgi-irix6*o32, mips-sgi-irix5*): Use it with
	gas and --with-stabs.

2003-06-27  Andreas Schwab  <schwab@suse.de>

	* config.gcc (m68k-*-linux*): Don't override extra_parts and
	gnu_ld, use the generic *-*-linux* settings instead.

2003-06-26  Roger Sayle  <roger@eyesopen.com>

	PR optimization/11054
	* rtlanal.c (reg_overlap_mentioned_p): Handle ZERO_EXTRACT
	and SIGN_EXTRACT.

2003-06-25  Zack Weinberg  <zack@codesourcery.com>

	PR bootstrap/3163
	* aclocal.m4 (AC_FUNC_MMAP_ANYWHERE, AC_FUNC_MMAP_FILE): Delete.
	(gcc_AC_FUNC_MMAP_BLACKLIST): New.
	* configure.in: Check for sys/mman.h and mmap in AC_CHECK_HEADERS
	and AC_CHECK_FUNCS lists, respectively.  Use
	gcc_AC_FUNC_MMAP_BLACKLIST, not AC_FUNC_MMAP_ANYWHERE nor
	AC_FUNC_MMAP_FILE.
	* configure, config.in: Regenerate.

	* ggc-page.c (init_gcc): Call fatal_io_error, not abort,
	if opening /dev/zero fails.

2003-06-25  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin_strcpy): Construct new argument list
	manually instead of using chainon to modify the original arglist.
	(expand_builtin_strcmp): Likewise.

2003-06-25  David O'Brien  <obrien@FreeBSD.org>

	* config/i386/i386.h (builtin_define): Remove duplicate __amd64
	and __amd64__.

2003-06-25	Dhananjay Deshpande <dhananjayd@kpitcummins.com>

	* config/sh/sh.c (sh_register_move_cost):
	Add case for moving between MAC_REGS.

2003-06-24  Jerry Quinn  <jlquinn@optonline.net>

	PR other/11280
	* gcc/doc/invoke.texi (Optimization Options): Remove -Os from
	-freorder-functions description.

2003-06-25  Richard Sandiford  <rsandifo@redhat.com>

	PR target/11084
	* config/mips/mips.c (mips_expand_prologue): Fix setting of regno
	for the end of a variable argument list.

2003-06-25  Josef Zlomek  <zlomekj@suse.cz>

	* dwarf2out.c (gen_field_die): Return if type of decl is error mark.

2003-06-24  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR target/11260
	* config/alpha/alpha.md (sqrtdf2): Fix operand substitution.

2003-06-24  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (expand_builtin_strcpy): Don't evaluate side-effects in
	src twice.

2003-06-23  Jakub Jelinek  <jakub@redhat.com>

	* config/s390/s390.c (s390_output_mi_thunk): Avoid .plt in -m31
	mode, as it requires pic register loaded.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/extend.texi: Fix typos.
	* doc/md.texi: Likewise.

2003-06-23  Roger Sayle  <roger@eyesopen.com>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add a note on testing and
	remove duplicates from testers list.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Document dump options, dT and dW.

2003-06-23  Andreas Schwab  <schwab@suse.de>

	* doc/invoke.texi: Remove leading `-' from options in index.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Document dump, .cfg.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Alphabetize dump options.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Remove a duplicate -dk.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/rtl.texi: Fix the @findex for pre_modify.

Sat Jun 21 13:37:52 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_va_arg): Fix allocation of temporary slot.

2003-06-21  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Use Windows instead of Win32.

	Update Andreas Jaeger's entry.

	Merge the two entries of Kaveh Ghazi, David Edelsohn, and
	Loren J. Rittle.

2003-06-20  Geoffrey Keating  <geoffk@apple.com>

	PR c++/9393
	* doc/invoke.texi (Debugging Options): Document -frandom-seed.
	* configure.in: Check for gettimeofday.
	* tree.c (flag_random_seed): Define.
	(default_flag_random_seed): New.
	(append_random_chars): Use flag_random_seed rather than trying
	to acquire randomness here.
	* tree.h (default_flag_random_seed): Declare.
	* toplev.c (display_help): Add -frandom-seed and -fstack-limit-*
	descriptions.
	(decode_f_option): Handle -frandom-seed.
	(print_switch_values): Call default_flag_random_seed.
	* flags.h (flag_random_seed): Declare.
	* configure: Regenerate.
	* config.in: Regenerate.

2003-06-20  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10888
	* tree-inline.c (expand_call_inline): Do not warn about failing to
	inline functions declared in system headers.
	* doc/invoke.texi (-Winline): Expand on documentation.

2003-06-20  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_gstabs_flag): Disable if assembler warns.
	* configure: Regenerate.
	Fixes PR driver/9362.

2003-06-19  Vladimir Makarov  <vmakarov@redhat.com>

	* haifa-sched.c (max_isse): Backport from the mainline.
	(choice_entry): New structure.
	(choice_stack, cycle_issued_insns, max_lookahead_tries,
	cached_first_cycle_multipass_dfa_lookahead, cached_issue_rate):
	New variables.
	(choose_ready): Calculate max_lookahead_tries.  Initiate
	ready_try.
	(schedule_block): Allocate/deallocate choice_stack.  Change
	cycle_issued_insns value as necessary.
	(sched_init): Check cached_issue_rate.

2003-06-20  Daniel Egger  <degger@fhm.edu>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Building): Correct and improve statement
	about parallel builds.

2003-06-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (--with-gnu-as): Mention SPARC/Solaris and
	SPARC64/Solaris as platforms where --with-gnu-as makes a difference.
	(--with-as): Add @anchor.
	(--with-gnu-ld): Fix typo.
	(--with-ld): Add @uref to --with-as.

2003-06-19  Kazu Hirata  <kazu@cs.umass.edu>

	* flow.c (initialize_uninitialized_subregs): Use
	emit_move_insn instead of emitting a hardcoded move.

2003-06-19  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (init_cumulative_args): Limit CALL_LIBCALL
	to ABI_V4.

2003-06-19  DJ Delorie  <dj@redhat.com>

	PR preprocessor/11022
	* cppmacro.c (warn_of_redefinition): Handle cases where the two
	definitions have different numbers of tokens.

2003-06-18  Richard Henderson  <rth@redhat.com>

	* config/ia64/unwind-ia64.c (_Unwind_GetCFA): New.
	(_Unwind_FindEnclosingFunction): Implement.

2003-06-18  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/rs6000.c (init_cumulative_args): Add and handle LIBCALL
	argument.
	(function_arg): Handle CALL_LIBCALL flag.
	* config/rs6000/rs6000-protos.h (init_cumulative_args): Update
	prototype.
	* config/rs6000/rs6000.h (CALL_LIBCALL): New macro.
	(INIT_CUMULATIVE_LIBCALL_ARGS): New macro.
	(INIT_CUMULATIVE_ARGS): Add LIBCALL argument.
	(INIT_CUMULATIVE_INCOMING_ARGS): Likewise.

2003-06-17  Jason Merrill  <jason@redhat.com>

	PR c++/10929
	* tree-inline.c (expand_call_inline): Don't warn about failing to
	inline a function which was made inline by -finline-functions.

2003-06-17  Ranjit Mathew  <rmathew@hotmail.com>

	* install.texi (Testing): Add information on how to run Java
	runtime tests separately.

2003-06-17  Christopher Faylor  <cgf@redhat.com>

	* doc/install.texi: Add msvc rebuild caveat.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/contrib.texi: Replace Hitachi with Renesas.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.

2003-06-17  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/linux.h (MD_FALLBACK_FRAME_STATE_FOR): Partly revert
	2003-01-23 patch. Corrected to handle kernels with changed ucontext.

	* config/rs6000/sysv4.h (SUBTARGET_OVERRIDE_OPTIONS): Error on invalid
	-msdata=eabi usages.

2003-06-14  Richard Earnshaw  <rearnsha@arm.com>

	PR optimization/10842
	From trunk:
	2003-01-20  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (sibcall_epilogue): Add an
	UNSPEC_PROLOGUE_USE to prevent the link register from being
	considered dead.

	2003-02-02  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (sibcall_epilogue): Set the "conds" to "clob".
	(epilogue_insns): Likewise.

2003-06-14  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11183
	* arm.c (output_move_double): Pass SImode to adjust_address.

2003-06-13  Janis Johnson  <janis187@us.ibm.com>

	* doc/install.texi (m32r-*-elf): Change company to Renesas.

2003-06-13  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (output_call_mem): If the address references the link-register
	use an instruction sequence that avoids early-clobbering IP.
	(eliminate_lr2ip): Delete.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR target/11089
	* config/i386/i386.md (sse_movaps): Use an expander to force
	one operand to be a register.
	(sse_movups): Likewise.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR middle-end/10557
	* rtlanal.c (subreg_offset_representable_p): Relax subreg check.

2003-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Christian Ehrhardt <ehrhardt@mathematik.uni-ulm.de>

	PR target/10142
	* config/sparc/sparc.c (function_arg_record_value_parms): Add
	new 'stack' field.
	(function_arg_record_value_1): Set 'stack' to 1 if we run out of
	integer slots for an integer field.
	(function_arg_record_value_3): Shift vector index.
	(function_arg_record_value_2): Likewise.
	(function_arg_record_value): Initialize 'stack' to 0.
	Set 'stack' to 1 if we run out of integer slots for an integer field.
	Generate (parallel [(expr_list (nil) ...) ...]) if 'stack' is set to 1.

2003-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/10955
	* unroll.c (unroll_loop): Fix off-by-one bug.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR middle-end/10475
	* expmed.c (emit_store_flag): Use simplify_gen_subreg directly
	for extracting sub-words.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR target/7594
	* config/m68k/m68k.md (zero_extendhisi2): Use gen_lowpart_SUBREG.
	(zero_extendqihi2, zero_extendqisi2): Likewise.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR inline-asm/4823
	* reg-stack.c (any_malformed_asm): New.
	(check_asm_stack_operands): Set it.
	(convert_regs_1): Check it before aborting.

2003-06-12  Jakub Jelinek  <jakub@redhat.com>

	* c-decl.c (c_expand_body): Save input_filename and lineno,
	set it before tree inlining and restore before return.

2003-06-12  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_emit_prologue): Use LA instead of AR
	to initialize GOT register.

2003-06-12  Jakub Jelinek  <jakub@redhat.com>

	* c-opts.c (complain_wrong_lang): Add on argument.
	Print no- switch if on is false.
	(c_common_decode_option): Adjust caller.

2003-06-11  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_asm_operands): Don't warn for memories with
	queued addresses.

2003-06-11  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/8787
	* config/i386/djgpp.h (ASM_FILE_START): emit `.intel_syntax'
	if -masm=intel.

2003-06-10  Andrew Haley  <aph@redhat.com>

	* langhooks-def.h (LANG_HOOKS_DECL_OK_FOR_SIBCALL): New.
	(LANG_HOOKS_DECLS): Add LANG_HOOKS_DECL_OK_FOR_SIBCALL.
	(lhd_decl_ok_for_sibcall): New.
	* langhooks.c (lhd_decl_ok_for_sibcall): New.
	* langhooks.h (lang_hooks_for_decls.ok_for_sibcall): New field.
	* calls.c (expand_call): Check lang_hook before generating a
	sibcall.

2003-06-09  Richard Henderson  <rth@redhat.com>

	2003-05-11  Ulrich Weigand  <uweigand@de.ibm.com>
	* except.c (EH_RETURN_STACKADJ_RTX): Do not define.
	(EH_RETURN_HANDLER_RTX): Likewise.
	(expand_builtin_eh_return): Do not copy stack adjustment
	if EH_RETURN_STACKADJ_RTX is not defined.
	(expand_eh_return): Likewise.  Also, do not pass stack
	adjustment as argument to the eh_return pattern.
	* except.h (MUST_USE_SJLJ_EXCEPTIONS): Do not define just
	because EH_RETURN_STACKADJ_RTX is not defined.
	* unwind-dw.c (uw_update_context_1): If EH_RETURN_STACKADJ_RTX
	is not defined, treat stack pointer like a regular register.
	(uw_init_context_1): Set up fake initial stack pointer register.
	(uw_install_context_1): Do not compute stack adjustment if
	EH_RETURN_STACKADJ_RTX is not defined.

	* config/i386/i386.md ("eh_return"): Remove first argument.
	* config/mips/mips.md ("eh_return"): Likewise.
	* config/rs6000/rs6000.md ("eh_return"): Likewise.
	* config/sh/sh.md ("eh_return"): Likewise.

	* config/s390/s390.h (EH_RETURN_STACKADJ_RTX): Remove.

2003-06-08  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_asm_operands): Re-word warning.

2003-06-08  Richard Henderson  <rth@redhat.com>

	* expr.h (EXPAND_MEMORY): New.
	* expr.c (expand_expr): Check it.
	* stmt.c (expand_asm_operands): Provide it when the constraint
	requires a memory.  Warn for memory input constraints without
	a memory operand.

2003-06-07  Richard Henderson  <rth@redhat.com>

	* c-common.c (cb_register_builtins): Define __EXCEPTIONS for C also.

2003-06-07  Kelley Cook  <kelleycook@wideopenwest.com>

	* configure.in (HAVE_LD_RO_RW_SECTION_MIXING): Remove quotes in
	section names.
	* configure: Regenerate.

2003-06-07  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux64.h (CRT_CALL_STATIC_FUNCTION): Define.

2003-06-06  James E Wilson  <wilson@tuliptree.org>

	PR inline-asm/10890
	* reload1.c (merge_assigned_reloads): Abort only if two reloads have
	different in fields.

2003-06-06  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11052
	* ifcvt.c (noce_process_if_block): Fail if the destination has
	side-effects.

2003-06-06  Dan Kegel  <dank@kegel.com>
	    Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/10331
	* config/sh/t-linux (STMP_FIXPROTO): Define.

	PR target/11096
	* config/sh/linux.h (CPLUSPLUS_CPP_SPEC): Redefine so to include
	-D_GNU_SOURCE.

2003-06-05  David Miller  <davem@redhat.com>
	    Richard Henderson  <rth@redhat.com>

	* optabs.c (HAVE_conditional_trap): Provide default.
	(gen_conditional_trap): Likewise.
	(init_optabs): Merge init_traps.
	(gen_cond_trap): Use prepare_operand.  Restructure and avoid ifdef.

2003-06-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Machine Constraints): Correct the meaning of
	constraints related to floating-point registers on SPARC.

2003-06-05  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Paolo Bonzini  <bonzini@gnu.org>

	PR target/10663
	* configure.in (HAVE_LD_RO_RW_SECTION_MIXING): Redirect
	assembler and linker output to /dev/null.
	Use a 'sed' construct instead of 'grep -A1'.
	* configure: Regenerate.

2003-06-04  David Edelsohn  <edelsohn@gnu.org>

	* doc/install.texi (*-ibm-aix*): Native as and ld required
	to bootstrap on AIX 5L.

2003-06-04  Richard Henderson  <rth@redhat.com>

	* c-common.c (handle_cleanup_attribute): New.
	(c_common_attributes): Add it.
	* c-decl.c (finish_decl): Honor the cleanup attribute.
	* doc/extend.texi (Variable Attributes): Document it.

	* unwind-c.c: New file.
	* Makefile.in (LIB2ADDEH): Add it.
	* config/t-darwin, config/t-linux, config/t-linux-gnulibc1,
	config/ia64/t-ia64: Likewise.

2003-06-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11018
	* config/sparc/sparc.c (sparc_v8plus_shift): Use which_alternative
	consistently to decide whether the scratch register is really
	required.

2003-06-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/10876
	* config/sparc/sparc.h (CONST_OK_FOR_LETTER): Add
	new 'O' constraint for constant 4096.
	(CONST_DOUBLE_OK_FOR_LETTER_P): Likewise.
	* config/sparc/sparc.md (adddi3 expander): Canonicalize pattern.
	Do not transform into MINUS insn for constant 4096.
	(*adddi3_sp64 insn): Canonicalize pattern. Add new alternative
	for constant 4096 as third operand.
	(addsi3 expander): Remove.
	(*addsi3 insn): Rename into 'addsi3'. Canonicalize pattern. Add
	new alternative for constant 4096 as third operand.
	(subdi3 expander): Do not transform into PLUS insn for constant 4096.
	(*subdi3_sp64 insn): Add new alternative for constant 4096 as third
	operand.
	(subsi3 expander): Remove.
	(*subsi3 insn): Rename into 'subsi3'. Add new alternative for
	constant 4096 as third operand.
	* doc/md.texi (Machine Constraints): Document new 'O' constraint for
	the SPARC port.

2003-06-03  Richard Henderson  <rth@redhat.com>

	* unwind.inc (_Unwind_Resume_or_Rethrow): Fix return type.
	* unwind.h (_Unwind_Resume_or_Rethrow): Update.
	(_Unwind_SjLj_Resume_or_Rethrow): Likewise.

2003-06-03  Douglas B Rupp  <rupp@gnat.com>

	* Makefile.in (TEXI_GCC_FILES): Remove vms.texi entry.
	* doc/gcc.texi: Remove vms.texi section.
	* doc/vms.texi: Remove obsolete file.

2003-06-03  Richard Henderson  <rth@redhat.com>

	PR target/10673
	* config/i386/i386.c (ix86_split_long_move): Fix base register
	mode for XFmode splits for TARGET_64BIT.

2003-06-02  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* gcc/config.gcc Add support multilib parts for m32rx processor.

2003-06-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/11044
	* config/i386/i386.md (length attribute): Set length to 4
	for instructions of type "fcmp".

2003-06-01  Josef Zlomek  <zlomekj@suse.cz>

	* rtl.def (CONST_DOUBLE): Update comment.

2003-06-01  Seth Arnold  <sarnold@wirex.com>
	    Aldy Hernandez  <aldyh@redhat.com>

	PR10871
	* config/rs6000/rs6000.c (rs6000_stack_info): Do not add
	vrsave_size twice.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (mips-sgi-irix5): Add missing
	HTML <hr> marker.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Machine Constraints): Document
	missing SPARC constraints.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Automaton pipeline description): Use
	"type" instead of "cpu" as the attribute in the examples.

2003-05-30  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.h (SUBTARGET_ASM_DEBUGGING_SPEC): Move
	-mdebug/-no-mdebug switches ...
	(MDEBUG_ASM_SPEC): ... here.
	Use only with gas.
	(EXTRA_SPECS): Initialize mdebug_asm_spec.
	(CONSTANT_ADDRESS_P): Allow native IRIX 6 O32 assembler.

2003-05-29  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* diagnostic.h (output_verbatim): Remove printf attribute.
	(verbatim): Likewise.
	* diagnostic.c (output_pointer): New function.
	(output_format): Use it.  Handle %p format specifier.

2003-05-27  Denis Chertykov  <denisc@overta.ru>

	* cselib.c (cselib_invalidate_regno): Abort if hardreg have a
	VOIDmode.
	* cselib.c (cselib_process_insn): Pass reg_raw_mode for hardreg in
	call of cselib_invalidate_regno.

2003-05-25  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Update Kean Johnston.

Fri May 23 21:19:31 CEST 2003  Jan Hubicka  <jh@suse.cz>
			       Andreas Jaeger  <aj@suse.de>

	* i386.h (TARGET_CPU_CPP_BUILTINS): Define __amd64 and __amd64__;
	do not use assertion.

Fri May 23 20:55:39 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse_loadss, sse_loadss_1, sse2_loadsd, sse2_loadsd_1):
	Rewrite

2003-05-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi: Remove sparc64-*-*. Add sparc64-*-solaris2*.
	Document sparcv9-*-solaris2* as a synonym for sparc64-*-solaris2*.

2003-05-22  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR bootstrap/10805
	* doc/install.texi (sparc-sun-solaris2.7): Document bootstrap
	failure with Sun assembler 5.0 Alpha 03/27/98.

2003-03-21  Loren James Rittle  <ljrittle@acm.org>

	* config/sparc/freebsd.h (CPP_CPU64_DEFAULT_SPEC): Add -D__sparcv9
	-D__sparc__ to match system compiler convention.

2003-05-20  Kevin Ryde <user42@zip.com.au>
	    Wolfgang Bangerth <bangerth@dealii.org>

	PR c/10355
	* doc/extend.texi: Put a warning into the documentation
	of attribute regparm.

2003-05-20  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("*iordi3_oi"): Do not mark commutative.
	("*iorsi3_oi"): Likewise.

2003-05-19  John David Anglin  <dave.anglin@nrc-gnrc.gc.ca>

	* pa/milli64.S ($$mulI): Fix typo.

2003-05-19  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* hashtable.h (struct ht_identifier): Add new field "hash_value".
	* hashtable.c (ht_lookup): Use it.
	(ht_expand): Likewise.  Avoid doing the same computation twice.
	* tree.h (IDENTIFIER_HASH_VALUE): New macro.

2003-05-19  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (use_return_insn): Do not use a single return
	instruction for interrupt handlers which have to create a stack
	frame.
	(arm_expand_prologue): Do not pre-bias the return address of
	interrupt handlers which create a stack frame.

2003-05-19  Eric Botcazou  <ebotcazou@libertysurf.fr>

	Backport from mainline:

	2003-05-10  Alexander Aganichev  <aaganichev@yandex.ru>

	* config/i386/i386.h (MODES_TIEABLE_P): Fix typo.

2003-05-16  Wolfgang Bangerth <bangerth@dealii.org>

	* doc/bugreport.texi: Remove most of the preface of the
	bugs section.

2003-05-16  Nick Clifton  <nickc@redhat.com>

	* config/mcore/mcore.md (jump): Use emit_jump_insn to generate the
	jump insn.

2003-05-15  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/invoke.texi (Warning Options): Mark -Wmissing-declarations
	as a C only option.

2003-05-15  Wolfgang Bangerth <bangerth@dealii.org>

	* doc/bugreport.texi: Remove most of the bug reporting
	instructions and merge them into bugs.html.

2003-05-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* sparc.c (print_operand): Fix uninitialized warning.

2003-05-14  Mark Mitchell  <mark@codesourcery.com>

	* version.c: Reset to prerelease format.
	* doc/include/gcc-common.texi: Update version number.

2003-05-13  Release Manager

	* GCC 3.3 Released.

2003-05-12  Mark Mitchell  <mark@codesourcery.com>

	PR other/10745
	* configure.in: Correct detection of GNU ld version number.
	* configure: Regenerated.

2003-05-08  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (gen_block_redirect, split_branches): Use
	CODE_FOR_jump_compact instead of CODE_FOR_jump

2003-05-06  Eric Christopher  <echristo@redhat.com>

	* config/mips/linux.h: Fix typo.

2003-05-06  Ulrich Weigand  <uweigand@de.ibm.com>

	PR other/10650
	* unwind-dw2.c (uw_update_context_1): Don't set sp as cfa on s390.
	(uw_init_context_1): Set initial sp to outer cfa on s390.

2003-05-06  Mark Mitchell  <mark@codesourcery.com>

	PR other/10658
	* gcc.c (process_command): Update copyright date.

2003-05-06  Bruce Korb  <bkorb@gnu.org>

	* inclhack.def: fix up whitespace differences from mainline.
	mark fix tests that fail on BSD systems (like mainline).
	Fixup the solaris_mutex_init test to cope with Sol. 2.6 (like mainline).
	Removed unused SONY commentary (its obsolete anyway).
	(svr4_mach_defines): remove i860 machine from comment (like mainline).
	* gcc/fixinc/tests/base/pthread.h: solaris_mutex_init fix tests
	* gcc/fixinc/tests/base/testing.h: remove ^M chars from some mistake
	* gcc/fixinc/tests/base/Xm/Traversal.h: accommodate BSD's sed
	* gcc/fixinc/tests/base/sys/stat.h: accommodate BSD's sed
	* gcc/fixinc/fixincl.x: regenerated

2003-05-06  Phil Edwards  <pme@gcc.gnu.org>

	* doc/install.texi (mips-*-*):  Add note about libstdc++.

2003-05-05  Mark Mitchell  <mark@codesourcery.com>
	    Kean Johnston <jkj@sco.com>

	* toplev.c (check_global_declarations): Do not warn about unused
	static consts.

2003-05-05  Richard Henderson  <rth@redhat.com>

	* builtins.c (expand_builtin) <BUILT_IN_DWARF_FP_REGNUM>: Remove.
	<BUILT_IN_DWARF_SP_COLUMN>: New.
	* builtins.def (BUILT_IN_DWARF_FP_REGNUM): Remove.
	(BUILT_IN_DWARF_SP_COLUMN): New.
	* dwarf2out.c (expand_builtin_dwarf_fp_regnum): Remove.
	(expand_builtin_dwarf_sp_column): New.
	* except.h: Update to match.
	* unwind-dw2.c (execute_stack_op): Correct stack push typo.
	(execute_cfa_program): Record location expression address
	before extracting length.
	(uw_update_context_1): Install old CFA into stack pointer column.
	(uw_init_context_1): Set cfa_reg to stack pointer column.

2003-05-05  David O'Brien  <obrien@FreeBSD.org>

	* config/rs6000/sysv4.h (CPP_OS_FREEBSD_SPEC): Add __ELF__ to mirror
	other FreeBSD ports.
	(LINK_OS_FREEBSD_SPEC): Mirror conventions on other FreeBSD ports.

2003-05-05  Jason Merrill  <jason@redhat.com>

	* stor-layout.c (update_alignment_for_field): Set DECL_ALIGN for
	the field.

2003-05-02  Zack Weinberg  <zack@codesourcery.com>

	PR c/10604
	* c-opts.c (c_common_decode_option <OPT_Wall>): Set
	warn_sign_compare for C++ only.
	* doc/invoke.texi: Clarify documentation of -Wsign-compare.

2003-05-03  Falk Hueffner <falk.hueffner@student.uni-tuebingen.de>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add Zdenek Dvorak, Aldy
	Hernandez, and Kazu Hirata.

2003-05-02  Richard Henderson  <rth@redhat.com>

	PR c++/10570
	* except.c: Revert 04-01 and 04-02 forced-unwind changes.
	* flags.h, toplev.c, doc/invoke.texi: Likewise.

	* unwind-dw2.c (_Unwind_GetCFA): Fix ptr->int conversion warning.
	* unwind.inc (_Unwind_DeleteException): Check for null
	exception_cleanup.

	* unwind-sjlj.c (_Unwind_SjLj_Resume_or_Rethrow): New.
	* unwind.inc (_Unwind_Resume_or_Rethrow): New.
	* unwind.h: Declare them.
	* libgcc-std.ver (GCC_3.3): Export them.

2003-05-02  Steven Bosscher  <steven@gcc.gnu.org>

	* tree-inline.c (find_alloca_call):
	Use walk_tree_without_duplicates, instead of walk_tree.
	(find_builtin_longjmp_call): Ditto.
	* c-objc-common.c (c_cannot_inline_fn): Ditto.

2003-05-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add Daniel Berlin.

2003-05-01  Rodney Brown  <rbrown64@csc.com.au>

      * rtl.h (subreg_offset_representable_p): Prototype.

2003-05-01  Roger Sayle  <roger@eyesopen.com>

	PR fortran/9974
	* gcse.c (reg_killed_on_edge): New function to test whether the
	given reg is overwritten by any instruction queued on an edge.
	(bypass_block): Ignore substitutions killed on incoming edges.
	Don't bypass outgoing edges that have queued instructions.

2003-04-30  Andreas Schwab  <schwab@suse.de>

	* doc/extend.texi (Other Builtins): Enclose multiple word data
	type in braces for @deftypefn.

2003-04-29  Jason Merrill  <jason@redhat.com>

	PR middle-end/10336
	* jump.c (never_reached_warning): Really stop looking if we reach
	the beginning of the function.

Tue Apr 29 21:07:00 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cse.c (count_reg_usage): Revert my previous patch.

2003-04-29  Alexander Kabaev  <kan@FreeBSD.ORG>

	bootstrap/10452
	* gengtype-yacc.y: Improve portability.

2003-04-29  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc: Install obsolete target list for GCC 3.3.
	* doc/install.texi: Mention in specific-target instructions
	that certain configurations are deprecated.

2003-04-29  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* c-pragma.c (maybe_apply_renaming_pragma): Fix typo.
	* gcc.c (display_help): Likewise.
	* toplev.c (f_options): Likewise.
	* params.def (PARAM_MAX_INLINE_SCOPE): Likewise.
	* config/c4x/c4x.h (TARGET_SWITCHES): Likewise.
	* config/mcore/mcore.h (TARGET_SWITCHES): Likewise.
	* config/s390/s390.h (TARGET_SWITCHES): Likewise.
	* config/v850/v850.h (TARGET_SWITCHES): Likewise.

2003-04-29  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/mingw32.h (LIBGCC_SPEC): Add libmingwex.a.
	Update copyright.
	* config/i386/cygwin.h (LIBGCC_SPEC): Add libmingwex.a, for
	-mno-cygwin case.

2003-04-29  J"orn Rennecke <joern.rennecke@superh.com>

	* varasm.c (default_assemble_visibility): Use assemble_name.

2003-04-29  David O'Brien  <obrien@FreeBSD.org>

	* config/i386/freebsd64.h (LINK_SPEC): Mirror FreeBSD linker.
	* config/rs6000/freebsd.h (LINK_SHLIB_SPEC): New macro.
	(SIZE_TYPE): New macro.
	* config/i386/freebsd-aout.h (NO_PROFILE_COUNTERS): New macro.
	(SET_ASM_OP): New macro.
	(HANDLE_SYSV_PRAGMA): New macro.
	(ASM_WEAKEN_LABEL): New macro.

2003-04-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10180
	* tree-inline.c (expand_call_inline): Call push_srcloc when
	encountering EXPR_WITH_FILE_LOCATION.  Honor warn_inline.

2003-04-28  Mike Stump  <mrs@apple.com>

	* gdbinit.in: Update to reflect new identifier structure.

2003-04-28  Richard Henderson  <rth@redhat.com>

	* config/sparc/sparc.c (print_operand): Add 's' to sign-extend.
	* config/sparc/sparc.md (const_mulsidi3_v8plus): Fix mode of
	integral constant mult operand.
	(const_mulsidi3_sp32, const_mulsidi3_sp64): Likewise.
	(const_smulsi3_highpart_v8plus): Likewise.
	(const_smulsi3_highpart): Likewise.
	(const_umulsidi3_sp32): Likewise; sign-extend it in the output.
	(const_umulsidi3_sp64, const_umulsidi3_v8plus): Likewise.
	(const_umulsi3_highpart_v8plus): Likewise.
	(const_umulsi3_highpart): Likewise.

2003-04-28  David O'Brien  <obrien@FreeBSD.org>

	* config/i386/i386.h (builtin_define): Add __amd64 and __amd64__.

Mon Apr 28 09:54:56 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR c/10308
	* reload.c (find_reloads_address_1): Reload plus at the place of
	index register.

2003-04-26  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (ia64_compute_frame_size): Allow inline asm
	to clobber ar.pfs and ar.unat.
	(ia64_expand_prologue): Force alloc instruction if ar.pfs saved;
	fix test for spilling ar.pfs to the stack.

2003-04-26  Stephane Carrez  <stcarrez@nerim.fr>

	* doc/install.texi (Binaries): Mention binaries for HC11/HC12.

2003-04-26 Stephane Carrez <stcarrez@nerim.fr>

	* doc/extend.texi (Function Attributes): Document "near" and "far"
	for 68HC11 and 68HC12.

2003-04-25  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/linux.h (TARGET_OS_CPP_BUILTINS): Back out previous
	addition of __PIC__ and __pic__ macros.
	* config/xtensa/xtensa.h: Clean up indentation.

2003-04-25  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/linux.h (TARGET_OS_CPP_BUILTINS): Remove definition of
	_GNU_SOURCE.  Add definitions of __PIC__ and __pic__.
	(SUBTARGET_CPP_SPEC): Define.
	(LIB_SPEC): Delete.
	* config/xtensa/xtensa-protos.h (xtensa_declare_object): Delete.
	* config/xtensa/xtensa.c (xtensa_declare_object): Delete.
	* config/xtensa/xtensa.h (CPP_SPEC, SUBTARGET_CPP_SPEC, EXTRA_SPECS):
	Define.
	(ASM_OUTPUT_COMMON, ASM_OUTPUT_LOCAL): Delete.
	(ASM_OUTPUT_ALIGNED_BSS, BSS_SECTION_ASM_OP): Define.

2003-04-25  Richard  Henderson  <rth@redhat.com>

	PR opt/10315
	* config/rs6000/rs6000.c (rs6000_emit_move): Only elide proper
	checks during reload; use validize_mem instead of adjust_address.

Fri Apr 25 15:43:23 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* emit-rtl.c (subreg_hard_regno):  Check that register is
	representable.
	* reload.c (reload_inner_reg_of_subreg):  When register is not
	representable, reload the whole thing.
	(find_reloads): Likewsie.
	* rtlanal.c (subreg_representable_p):  New function.

Sun Apr 20 18:23:18 CEST 2003  Richard Henderson  <rth@redhat.com>

	(backported to 3.3 by Jan Hubicka)

	* config/ia64/ia64.md (UNSPECV_SETJMP_RECEIVER): New.
	(builtin_setjmp_receiver): Delay call to ia64_reload_gp
	until after reload.

	* emit-rtl.c (try_split): Handle 1-1 splits of call insns properly.

	* config/ia64/ia64.c (TARGET_FUNCTION_OK_FOR_SIBCALL): New.
	(ia64_gp_save_reg): Remove.
	(struct ia64_frame_info): Move to the beginning of the file;
	add reg_save_gp.
	(ia64_expand_call): Rearrange for new call patterns.
	(ia64_reload_gp): New.
	(ia64_split_call): New.
	(ia64_compute_frame_size): Allocate reg_save_gp.
	(ia64_expand_prologue): Save reg_save_gp.
	(ia64_expand_epilogue): Don't restore gp.
	(ia64_hard_regno_rename_ok): Remove R4 hack.
	(ia64_function_ok_for_sibcall): New.
	(ia64_output_mi_thunk): Set reload_completed, no_new_pseudos;
	call try_split on sibcall pattern.
	* config/ia64/ia64-protos.h: Update.
	* config/ia64/ia64.md (call_nogp, call_value_nogp, sibcall_nogp):
	Rename from nopic versions.  Confiscate 2nd argument to call as
	a marker.
	(call_pic, call_value_pic, sibcall_pic): Remove.
	(call_gp, call_value_gp, sibcall_gp): New.
	(builtin_setjmp_setup): Remove.
	(builtin_setjmp_receiver): Call ia64_reload_gp.

2003-04-24  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR opt/8705
	* gcse.c (try_replace_reg): On a successful substitution of a constant
	into a single set, try to simplify the source of the set.
	* loop.c (scan_loop): Don't try to optimize a MODE_CC set with a
	constant source.

2003-04-24  Alexander Kabaev <kan@FreeBSD.ORG>

	bootstrap/10453
	* config/sparc/sparc.md (umulsidi3, mulsidi3): Avoid using
	const_umulsidi3_sp32 and const_mulsidi3_sp32 on 64bit targets
	where they might be not present. Use their _sp64 equivalent
	instead.

2003-04-23  Richard Henderson  <rth@redhat.com>

	PR opt/8300
	* toplev.c (rest_of_compilation): Delay no_new_pseudos until
	after initialize_uninitialized_subregs; update reg info assuming
	new pseudos were created.

2003-04-23  Olivier Hainque  <hainque@act-europe.fr>

	* config/pa/pa.md (extv, extzv): FAIL if the bitfield length is zero.

2003-04-23  James A Morrison  <ja2morri@uwaterloo.ca>

	* invoke.texi: Eliminate extra white-space caused by @gccoptlist{
	on its own line.
	Ensure there are two spaces between each pair of options and add
	@gol where appropriate.

2003-04-23  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_expand_cmpstr): Disable CLC loop.

2003-04-22  Devang Patel  <dpatel@apple.com>

	* cpptrad.c (_cpp_replacement_text_len): Add check for macro parameter count.
	(_cpp_copy_replacement_text): Same.

2003-04-22  Richard Henderson  <rth@redhat.com>

	PR 8866
	* rtl.h (MEM_NOTRAP_P): New.
	(MEM_COPY_ATTRIBUTES): Copy it.
	* rtlanal.c (may_trap_p): Check it.
	* expr.c (do_tablejump): Set it.

	* cfgrtl.c (try_redirect_by_replacing_jump): Revert last three changes.

2003-04-22  David Turner <novalis@gnu.org>

	* gbl-ctors.h: Add special license exception.
	* libgcc2.h: Likewise.
	* tsystem.h: Likewise.
	* gcov-io.h: Likewise.

2003-04-21  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (calls.o): Depend on except.h.
	* calls.c: Include except.h.
	(emit_call_1): Call note_eh_region_may_contain_throw if
	appropriate.
	* except.c (eh_region): Add may_contain_throw.
	(expand_eh_region_end_cleanup): Do not include handler code when
	it cannot be reached.
	(note_eh_region_may_contain_throw): New function.
	* except.h (note_eh_region_may_contain_throw): New function.

2003-04-21  Mark Mitchell  <mark@codesourcery.com>

	* config/i386/winnt.c (i386_pe_mark_dllimport): Revert previous
	changes.

2003-04-21  Mark Mitchell  <mark@codesourcery.com>

	* config/i386/winnt.c (i386_pe_}ark_dllimport): Make the new RTL
	have the same form as the old RTL.

2003-04-18  Mark Mitchell  <mark@codesourcery.com>

	* cfgrtl.c (try_redirect_by_replacing_jump): Create a basic block
	for orphaned jump tables.

2003-04-20  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR/8705
	* pa.md (movccfp): New expander.
	(setccfp0, setccfp1): Rename to movccfp0 and movccfp1, respectively.
	Reverse fcmp conditions.

2003-04-20  Marek Michalkiewicz  <marekm@amelek.gda.pl>

	* config/avr/avr.md (*cmpqi_sign_extend): Handle negative values
	of operand 1 correctly.

2003-04-19  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* cfgrtl.c (try_redirect_by_replacing_jump): Remove unused variables.
	* flow.c (life_analysis): Fix warning.

2003-04-18  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Prefer "bug fix" over "bugfix".
	Add Segher Boessenkool.

2003-04-18  Alexander Sotirov  <sluncho@mirizma.org>

	PR c/9177
	* c-decl.c (c_expand_body): Don't garbage collect the function
	body if we are going to dump it later.

2003-04-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/7675
	* c-typeck.c (build_external_ref): Set the DECL_NONLOCAL flag
	on VAR_DECL, PARM_DECL and FUNCTION_DECL from within
	nested functions if they refer to declarations from parent functions.
	* stmt.c (expand_decl): Don't put automatic variables in registers
	if the DECL_NONLOCAL flag is set.

2003-04-17  Janis Johnson  <janis187@us.ibm.com>

	* doc/sourcebuild.texi (Test Suites): Document support for testing
	binary compatibility (moved from testsuite/README.compat).

2003-04-17  Simon Law  <sfllaw@engmail.uwaterloo.ca>

	* doc/include/gpl.texi: Fix double-spacing after "MA" to match
	the one provided by the FSF.

2003-04-17  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Binaries): Update URL and list of platforms
	provided by ftp.thewrittenword.com.

2003-04-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/invoke.texi (inline-limit): Fix pasto.

2003-04-16  Mark Mitchell  <mark@codesourcery.com>

	PR middle-end/8866
	* cfgtrl.c (try_redirect_by_replacing_jump): Do not delete
	jumptables.

2003-04-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR/10271
	* pa-protos.h (function_arg): Remove last argument.
	* pa.c (function_arg): Likewise.  Use CUMULATIVE_ARGS struct instead.
	* pa.h (struct hppa_args): Add member incoming.
	(INIT_CUMULATIVE_ARGS, INIT_CUMULATIVE_INCOMING_ARGS): Initialize
	member incoming.
	(FUNCTION_ARG): Revise call to function_arg.
	(FUNCTION_INCOMING_ARG): Delete.

2003-04-15  J"orn Rennecke <joern.rennecke@superh.com>

	PR target/9594:
	* sh.c (barrier_align): Also recognize stuff_delay_slot as
	an indicator that a barrier was created by branch splitting.

	merge from mainline:

	2003-03-05  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (OVERRIDE_OPTIONS): For TARGET_SHMEDIA, the minimum value
	for align_jumps is 4.

	(SECONDARY_INPUT_RELOAD_CLASS): If reloading a PLUS into FPUL,
	use GENERAL_REGS.

	2003-03-03  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (OVERRIDE_OPTIONS): Set default values for align_loops
	and align_jumps if not set.
	Force align_jumps to be at least 2.
	When relaxing, force align_functions to be at least the maximum of
	align_loops, align_jumps and 4.
	* sh.c (find_barrier, barrier_align): Honour align_jumps_log.
	(sh_loop_align): Honour align_loops_log.

	* sh.md (length attribute): Use prev_nonnote_insn instead of PREV_INSN
	to check for indirect_jump_scratch.
	(indirect_jump_scratch): Add second set.
	* sh.c (output_far_jump): Use prev_nonnote_insn instead of PREV_INSN
	when looking for indirect_jump_scratch.
	Extract scratch register taking new structure of indirect_jump_scratch
	into account.
	(gen_block_redirect): Set INSN_SCOPE for indirect_jump_scratch.

2003-04-15  James A. Morrison  <ja2morri@uwaterloo.ca>

	* invoke.texi (Spec Files): Wrap if-exists-else example.
	(MCore): Remove duplicate @itemx entries and @opindex entries.

2003-04-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* unwind.inc (_Unwind_Backtrace): New function.
	* unwind.h (_Unwind_Backtrace): Declare it.
	* libgcc-std.ver (_Unwind_Backtrace): Export it.

2003-04-15  Jason Merrill  <jason@redhat.com>

	PR middle-end/10336, c++/10401
	* jump.c (never_reached_warning): Also stop looking if we reach the
	beginning of the function.

2003-04-15  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR target/10338
	PR bootstrap/10198
	PR bootstrap/10140
	* fixinc/gnu-regex.c (regerror): Use mempcpy not __mempcpy.

2003-04-15  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.h (EPILOGUE_USES): Use register 2,
	instead of TOC_REGISTER in epilogue in
	current_function_calls_eh_return functions.

2003-04-14  Hans-Peter Nilsson  <hp@axis.com>

	PR target/10377
	* config/cris/cris.md ("*mov_sideqi", "*mov_sidehi")
	("*mov_sidesi", "*mov_sideqi_mem", "*mov_sidehi_mem")
	("*mov_sidesi_mem", "*clear_sidesi", "*clear_sidehi")
	("*clear_sideqi", "*ext_sideqihi", "*ext_sideqisi")
	("*ext_sidehisi", "*op_sideqi", "*op_sidehi", "*op_sidesi")
	("*op_swap_sideqi", "*op_swap_sidehi", "*op_swap_sidesi")
	("*extopqihi_side", "*extopqisi_side", "*extophisi_side")
	("*extopqihi_swap_side", "*extopqisi_swap_side")
	("*extophisi_swap_side", 8th, 9th, 10th, 11th, 14th peepholes):
	When next to constraint R, replace constraint i with n.

Mon Apr 14 16:14:37 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR opt/10024
	* cfgrtl.c (force_nonfallthru_and_redirect): Use unchecked_make_edge.

2003-04-14  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* doc/contrib.texi (Contributors): Correct my entry.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11-protos.h
	(m68hc11_eq_compare_operator): Declare
	* config/m68hc11/m68hc11.h (PREDICATE_CODES): Register new predicate.
	* config/m68hc11/m68hc11.c (m68hc11_eq_compare_operator): New predicate
	(d_register_operand): Check the operand mode.
	(hard_addr_reg_operand): Likewise.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md ("decrement_and_branch_until_zero"): New
	pattern for dbcc/ibcc generation for 68HC12.
	("doloop_end"): New pattern.
	("m68hc12_dbcc_dec_hi"): New pattern for dbeq/dbne.
	("m68hc12_dbcc_inc_hi"): New pattern for ibeq/ibne.
	("m68hc12_dbcc_dec_qi"): New pattern.
	("m68hc12_dbcc_inc_qi"): New pattern.
	(split): Add split for the above when we can't use dbcc/ibcc due to
	reloading.
	(peephole2): Add peephole2 to generate the above when possible.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md ("bitcmpqi" split): No need to test the
	mode of operand 0.
	(peephole2 optimize const load): Likewise for operand 2.
	("*rotlhi3_with_carry"): Change pattern to a const 1 rotate which
	clobbers CC_REGNUM.
	("*rotrhi3_with_carry"): Likewise.
	(ashift:DI 1 split): Update pattern to create the above rotate.
	(lshiftrt:DI 1 split): Likewise.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md (SOFT_Z_REGNUM): New constant.
	("tstqi_z_used" split): Use it.
	("cmphi_z_used"): Likewise.
	("bitcmpqi_z_used"): Likewise; also use SP_REGNUM constant.
	("cmpqi_z_used"): Likewise.

2003-04-12  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7910
	* config/i386/winnt.c (i386_pe_mark_dllimport): Fix thinko.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.h (TARGET_SWITCHES): Fix -mnominmax option;
	recognize -mnorelax.
	(reg_class): Add Z_OR_S_REGS to represent soft registers with Z
	(REG_CLASS_NAMES): Add its name.
	(REG_CLASS_CONTENTS): Define its content.

2003-04-12  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/larith.asm (memcpy): Use ARG macro to access stack
	parameters so that offsets are valid for far definition.
	(__mulsi3): Likewise and use ret to return.
	(___adddi3, ___subdi3, ___notdi2, ): Don't use it to save the result.

2003-04-11  Geoffrey Keating  <geoffk@apple.com>

	* doc/extend.texi (Empty Structures): New.

2003-04-11  Richard Henderson  <rth@redhat.com>

	PR c++/10202
	* expr.c (expand_expr): Use COMPLETE_OR_UNBOUND_ARRAY_TYPE_P
	not COMPLETE_TYPE_P for re-invoking layout_decl.

2003-04-11  Simon Law  <sfllaw@engmail.uwaterloo.ca>

	* doc/bugreport.texi: Fix paragraph breaking between sections
	in preparation for TeXinfo's paragraph indentation fixes.
	* doc/extend.texi: Ditto.
	* doc/invoke.texi: Ditto.
	* doc/objc.texi: Ditto.
	* doc/gcov.texi: Wrap 'gcov' in @command{}.
	* doc/invoke.texi (Darwin Options): Add a preamble.

2003-04-11  Richard Henderson  <rth@redhat.com>

	PR c/10201
	* expr.c (expand_expr): Move DECL_RTL frobbing ...
	* stor-layout.c (layout_decl): ... here.

2003-04-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* doc/install.texi (hppa): Update links for HP-UX patches.  Revise
	notes on linker selection and configuration for 64-bit HP-UX port.
	* doc/invoke.texi (hppa): Remove hppa text from description for
	-ffunction-sections and -fdata-sections.  Document -static, -nolibdld
	and -threads options.

	* pa-hpux10.h (LIB_SPEC): Add link options to resolve dependency of
	libc.a on libdld.sl when -static is specified and -nolibdld is not
	specified.
	* pa64-hpux.h (LIB_SPEC): Likewise.
	* pa-hpux11.h (LIB_SPEC): Likewise.
	(LINK_SPEC): Add __gcc_plt_call as an undefined symbol when -shared
	is not specified.

2003-04-08  Jonathan Wakely  <redi@gcc.gnu.org>

 	* doc/extend.texi (Template Instantiation): Refer to ISO standard,
 	not Working Paper.
 	* doc/invoke.texi (C++ Dialect Options): Same.

Fri Apr 11 00:12:14 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR inline-asm/8803
	* function.c (instantate_virtual_regs):  Verify that all ASM statements
	match after the virutal regs instantiation.

2003-04-10  Steve Ellcey  <sje@cup.hp.com>

	* ia64-protos.h (addp4_optimize_ok): New.
	* ia64.c (addp4_optimize_ok): New.
	* ia64.md (*ptr_extend_plus_1): Use addp4_optimize_ok.
	(*ptr_extend_plus_2): Ditto.

2003-04-10  Steve Ellcey  <sje@cup.hp.com>

	* expr.c (expand_assignment): Extend offset_rtx with convert_to_mode
	not with convert_memory_address.
	(store_constructor): Ditto, and same for copy_size_rtx.
	(expand_expr): Ditto.

2003-04-10  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (larl_operand): Do not allow symbols
	marked with '@'.
	(s390_encode_section_info): Mark symbols with forced 1-byte
	alignment with '@'.
	(s390_strip_name_encoding): Strip '@'.
	(legitimize_pic_address): Handle symbols that are not valid
	LARL operands in 64-bit mode.

2003-04-10  Andrew Haley  <aph@redhat.com>

	* tree-inline.c (inlinable_function_p): Disable inlining for
	synchronized methods.

2003-04-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/fp-bit.c (unpack_d): Handle pair of doubles with
	different signs correctly.

2003-04-08  Richard Henderson  <rth@redhat.com>

	PR target/9886
	* config/ia64/ia64.md (cmovdi_internal): Use 'n' not 'i' constraints.
	(cmovsi_internal): Likewise.

2003-04-07  Matt Kraai  <kraai@alumni.cmu.edu>

	* doc/install.texi: Use @command and @samp for single- and
	multi-word commands respectively.
	* doc/makefile.texi: Likewise.
	* doc/sourcebuild.texi: Likewise.

2003-04-07  Christian Ehrhardt  <ehrhardt@mathematik.uni-ulm.de>
	    Richard Henderson  <rth@redhat.com>

	PR c/9516
	* expr.c (safe_from_p): Rearrange to avoid deep recursion in
	favour of looping and tail recursion for TREE_LIST and binops.

2003-04-07  Glen Nakamura  <glen@imodulo.com>

	PR opt/8634
	* explow.c (maybe_set_unchanging): Don't flag non-static const
	aggregate type initializers with RTX_UNCHANGING_P.

2003-04-07  Richard Henderson  <rth@redhat.com>

	PR opt/8634
	* function.c (purge_addressof_1): Don't try arithmetics for
	unchanging memories.

2003-04-07  Janis Johnson  <janis187@us.ibm.com>

	* doc/sourcebuild.texi (Test Suites): Document testing support for
	gcov and profile-directed optimizations; describe gcc.misc-tests.

2003-04-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/rtl.texi (Comparison operations): Update to
	record the allowed comparison modes.

Mon Apr  7 22:13:38 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR target/10077
	* i386.md (movsi_1):  Fix SSEMOV alternative.

Mon Apr  7 15:56:30 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR opt/10024
	Revert Zack's change
	* cfglayout.c (cfg_layout_redirect_edge):
	Redirect any branch edges unified with the fallthru one.
	* cfgrtl.c (force_nonfallthru_and_redirect):  Do not special
	case fallthru edges when called via cfglayout.c

2003-04-07  James A Morrison <ja2morri@student.math.uwaterloo.ca>

	* doc/extend.texi (Darwin Pragmas): Fix spelling of Mac OS.

2003-04-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-decl.c (set_save_expr_context): Prototype.

2003-04-05  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (RTX_COSTS): Halve Power multiply costs.
	* config/rs6000/rs6000.md: Correct Power4 multiply latency.

2003-04-05  Zack Weinberg  <zack@codesourcery.com>

	PR optimization/10024
	* cfgrtl.c (force_nonfallthru_and_redirect): If e is the edge
	we want, use it.

2003-04-05  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	PR bootstrap/10267
	* doc/install.texi (*-*-solaris2): /bin/ksh is not just recommended
	for configuring.

2003-04-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-decl.c (set_save_expr_context): Use traditional-style function
	definition.

2003-04-04  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add entries for Wolfgang
	Bangerth, DJ Delorie, Christian Ehrhardt, Christopher Faylor,
	Nathanael Nerode, Diego Novillo, Hartmut Penner, Volker Reichelt,
	Danny Smith, and Ulrich Weigand.
	Update Kriang Lerdsuwanakij and fix a typo in Janis Johnson's
	entry.

2003-04-04  Zack Weinberg  <zack@codesourcery.com>

	PR bootstrap/10216
	* configure.in: Check whether it is necessary to link against
	libm to use ldexp.
	* configure: Regenerate.
	* Makefile.in: Add LDEXP_LIB substitution variable.

2003-04-03  Jason Merrill  <jason@redhat.com>

	PR c/10175
	* jump.c (never_reached_warning): Revert patch of 2002-11-02.
	Look backwards for a line note.

2003-04-02  Mike Stump  <mrs@apple.com>

	* doc/extend.texi (PowerPC AltiVec Built-in Functions): Split up
	some to avoid faulting makeinfo --html.

2003-04-02  Richard Henderson  <rth@redhat.com>

	* libgcc-std.ver (_Unwind_GetCFA): New.
	* unwind-dw2.c (_Unwind_GetCFA): New.
	* unwind-sjlj.c (_Unwind_GetCFA): New.
	* unwind.h: Declare it.

2003-04-02  Mike Stump  <mrs@apple.com>

	* doc/install.texi (Specific): Update pointers to apple.com.

2003-04-01  Jan Hubicka  <jh@suse.cz>

	PR inline-asm/8088
	* i386.c (ix86_hard_regno_mode_ok):  Return 0 for MMX/SSE registers
	when MMX/SSE is not available.

2003-04-02  Richard Henderson  <rth@redhat.com>

	* except.c (sjlj_find_directly_reachable_regions): Recognize when
	must-not-throw region has been deleted.

2003-04-02  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (output_call_frame_info): Ignore fde->nothrow as an
	optimization when flag_exceptions not enabled.

2003-04-01  Richard Henderson  <rth@redhat.com>

	* except.c (convert_from_eh_region_ranges_1): Smash REG_EH_REGION
	notes for nothrow calls if flag_forced_unwind_exceptions.
	(build_post_landing_pads): Mind flag_forced_unwind_exceptions.
	(sjlj_find_directly_reachable_regions): Likewise.
	(reachable_handlers): Likewise.
	(can_throw_external): Likewise.
	(collect_one_action_chain): Record cleanups after catch-all and
	must-not-throw if flag_forced_unwind_exceptions.
	* flags.h (flag_forced_unwind_exceptions): Declare.
	* toplev.c (flag_forced_unwind_exceptions): New.
	(lang_independent_options): Add it.
	* doc/invoke.texi: Add it.

2003-04-01  Geoffrey Keating  <geoffk@apple.com>

	* unwind-dw2-fde-darwin.c (DESTRUCTOR_MAY_BE_CALLED_LIVE): New.
	(live_image_destructor): Reset image to initial state.
	(examine_objects): Set DESTRUCTOR_MAY_BE_CALLED_LIVE.

2003-04-01  Dale Johannesen  <dalej@apple.com>

	* cse.c (count_reg_usage): Fix handling of REG_EQUAL notes.
	(Zdenek Dvorak's fix from 3.4 branch)

2003-04-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_fixup_clobbered_return_reg):
	Do nothing if __builtin_return_address was not used.

2003-04-01  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (function_arg_pass_by_reference):
	Return true for variable sized types.
	(rs6000_va_arg): Handle variable sized types passed by reference
	on non-SVR4 ABI.

2003-03-31  Mark Mitchell  <mark@codesourcery.com>

	PR c/9936
	* c-decl.c (grokdeclarator): Clear SAVE_EXPR_CONTEXT for
	variably-sized arrays in parameters.
	(set_save_expr_context): New function.
	(c_expand_body): Use it, via walk_tree.

2003-03-31  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (hard_reg_operand): Check the mode.

2003-03-31  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (m68hc11_gen_movhi): Don't rely on REG_WAS_0
	notes as they are boggus.
	(m68hc11_gen_movqi): Likewise.

2003-03-31  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (expand_prologue): For an interrupt handler
	save the soft registers after the frame pointer so that gdb can unwind
	the frame more easily.
	(expand_epilogue): Likewise in opposite order; allow to use X register
	as scratch if the return value is by reference.

2003-03-31  Jason Merrill  <jason@redhat.com>

	PR java/10145
	* stor-layout.c (update_alignment_for_field): Respect
	DECL_USER_ALIGN for zero-length bitfields, too.
	* c-decl.c (finish_struct): Don't set DECL_ALIGN for normal
	fields.

2003-03-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR other/6955
	* collect2.c (collect_wait): Use WCOREDUMP and fix output message.
	* system.h (WCOREDUMP, WCOREFLG): Define if necessary.

2003-03-30  Richard Henderson  <rth@redhat.com>

	PR c/10083
	* config/alpha/alpha.md (umuldi3_highpart): Change to expander;
	don't zero_extend const inputs.

2003-03-29  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi: Add Eric Botcazou and Roger Sayle.
	Uniformly use bugfix instead of bug fix.

2003-03-29  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	PR doc/895
	* ONEWS: Remove those items that already appear in the EGCS
	release notes on our web pages.

2003-03-29  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.h (FUNCTION_VALUE_REGNO_P): Respect
	TARGET_HARD_FLOAT.  Reformat.
	(FUNCTION_ARG_REGNO_P): Likewise, and remove unneeded casts.

2003-03-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_emit_prologoue): Make sure backchain is
	set up before any trapping memory access if flag_non_call_exceptions.

2003-03-29  Alan Modra  <amodra@bigpond.net.au>

	* reload1.c (reload_as_needed): Allow a USE in asm reloads.

	* loop.c: (find_mem_in_note_1, find_mem_in_note): Comment.

2003-03-28  Loren James Rittle  <ljrittle@acm.org>

	* doc/install.texi (*-*-freebsd*): Update with known status.

2003-03-28  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("literal_pool_31"): Output pool anchor
	label even if pool empty when generating PIC.
	("literal_pool_31", "literal_pool_64"): Coding style cleanup.

2003-03-28  Kazu Hirata  <kazu@cs.umass.edu>,
	    Dhananjay Deshpande  <dhananjayd@kpit.com>

	PR target/10205
	* config/h8300/h8300.c (h8300_initial_elimination_offset):
	Correct the offset computation when TARGET_NORMAL.

2003-03-28  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/10067
	* config/sparc/sparc.md (jump pattern): Correct order
	when issuing the annuling marker.

2003-03-28  Alan Modra  <amodra@bigpond.net.au>

	* loop.c: (find_mem_in_note_1, find_mem_in_note): New functions.
	(replace_loop_mems): Add "written" param.  Remove invalid REG_EQUAL
	notes after hoisting.
	(load_mems): Adjust replace_loop_mems call.

2003-03-28  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/8281
	* config/sparc/sparc.md (movdi_insn_sp32_v9): Remove 'f-f' alternative.
	(movdi reg/reg split): Match only on sparc32, and v9 when int regs.

2003-03-28  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Richard Henderson  <rth@redhat.com>

	PR target/10114 and PR target/10084
	* dwarf2out.c (mem_loc_descriptor): Handle LO_SUM.

2003-03-27  Olivier Hainque  <hainque@act-europe.fr>

	PR ada/9953
	* ada/Makefile.in (gnatlib configuration for HPUX): Split
	the general section for HPUX into specific sections for
	HPUX 10 and HPUX 11. Fix the setting of TGT_LIB in the HPUX
	11 case.

2003-03-26  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_optimize_prolog): Do not save/restore
	registers used for global asm variables.
	(s390_frame_info, s390_arg_frame_offset): Likewise.
	(s390_emit_prologue, s390_emit_epilogue): Likewise.

2003-03-26  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Update Janis Johnson.

2003-03-26  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/ia64.c (ia64_expand_op_and_fetch): Fix comment.
	(ia64_expand_compare_and_swap): Use always DImode ar.ccv,
	zero extend old to it.
	* config/ia64/ia64.md (cmpxchg_acq_si): Remove mode from ccv
	operand.

2003-03-26  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/7784
	* reload.c (find_reloads_address): Handle
	(PLUS (PLUS (REG) (REG)) (CONST_INT)) form for
	all base registers.

2003-03-25  Marcelo Abreu  <mmabreu@inf.ufrgs.br>

	PR other/10203
	* version.c: Reference the GCC web site in the URL.

2003-03-25  Jan Hubicka  <jh@suse.cz>

	PR opt/10056
	* cfglayout.c (fixup_reorder_chain):  Fix dealing with the conditional
	jump jumping to the next instruction.
	* cfgrtl.c (force_nonfallthru_and_redirect):  Likewise.
	* cfg.c (unchecked_make_edge): New.
	* basic-block.h (unchecked_make_edge): Declare.

2003-03-25  Jason Merrill  <jason@redhat.com>

	PR optimization/10171
	* unroll.c (unroll_loop): Don't delete the jump at the end unless
	we also delete a jump at the beginning.

2003-03-25  Stephane Carrez  <stcarrez@nerim.fr>

	* doc/contrib.texi (Contributors): Mention self as 68HC11/68HC12
	contributor.

2003-03-25  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/passes.texi (Passes): Properly document that we do not
	perform jump2 any longer; remove command-line option -dJ.

2003-03-25  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8746
	* config/i386/i386.md (and promoting splitters): Disable HImode to
	SImode promoting when the sign bit matters and is not preserved, or
	when TARGET_FAST_PREFIX is true. Disable promoting when optimizing
	for size.

2003-03-24  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/t-m68hc11-gas (LIB1ASMFUNCS): Add _call_far and
	_return_far
	(MULTILIB_OPTIONS): Don't multilib on -mlong-calls.
	(MULTILIB_EXCEPTIONS): Likewise.
	* config/m68hc11/m68hc11.md ("call"): Support far calls for 68HC11
	by calling some board support routine.
	("call_value"): Likewise.
	("*return_void"): Likewise for return.
	("*return_16bit"): Likewise.
	("*return_32bit"): Likewise.
	* config/m68hc11/m68hc11.h (ASM_DECLARE_FUNCTION_NAME): Generate .far
	for 68HC11 too.
	(DWARF2_ADDR_SIZE): Use 4 so that addresses can
	* config/m68hc11/m68hc11.c (m68hc11_override_options): Accept
	-mlong-calls for 68HC11.
	* config/m68hc11/larith.asm (declare_near): New macro.
	(__premain, ___negsi2, ___one_cmplsi2, ___ashlsi3): Use it.
	(___ashrsi3, ___lshrsi3, ___lshrhi3, ___lshlhi3): Likewise.
	(___rotrhi3, ___rotlhi3, ___ashrhi3, ___ashrqi3): Likewise.
	(___lshlqi3, __divmodhi4, ___mulqi3, ___mulhi3): Likewise.
	(__mulhi32): Likewise.
	(ret): Update macro for 68HC11.
	(__far_trampoline): Implement for 68HC11.
	(__call_a16, __call_a32, __return_void, __return_16): New support
	routines for 68HC11 memory bank switching calling support.
	(__return_32): Likewise.

2003-03-21  Glen Nakamura  <glen@imodulo.com>

	PR opt/10087
	* loop.c (loop_givs_reduce): Skip bivs with duplicate locations
	while incrementing giv.
	(record_biv): Check for duplicate biv locations and
	set (struct induction *) v->same if found.

2003-03-24  Janis Johnson  <janis187@us.ibm.com>

	* doc/install.texi (Testing): Mention test result links from build
	status pages.

2003-03-24  Mark Mitchell  <mark@codesourcery.com>

	* function.c (put_var_into_stack): Change bool parameter to int.
	(gen_mem_addressof): Likewise.
	* rtl.h (gen_mem_addressof): Likewise.
	* tree.h (put_var_into_stack): Likewise.
	* config/alpha/alpha.c (alpha_gp_save_rtx): Adjust call to
	gen_mem_addressof or put_var_into_stack.
	* config/c4x/c4x.c (c4x_expand_builtin): Likewise.

2003-03-24  Andreas Schwab  <schwab@suse.de>

	* config/ia64/ia64.c (spill_tfmode_operand): Adjust calls to
	gen_mem_addressof.

2003-03-24  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (do_jump): Handle UNSAVE_EXPR specially.

2003-03-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/10072
	* combine.c (simplify_if_then_else): Check that the mode
	has MODE_INT class before applying the (OP Z (mult COND C2))
	transformation.

2003-03-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/9414
	* config/sparc/sparc.md (widening peepholes): Use
	widen_memory_access instead of change_address.

2003-03-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7086
	* c-typeck.c (c_mark_addressable): Adjust calls to
	put_var_into_stack.
	* expr.c (expand_expr): Likewise.
	* function.c (put_var_into_stack): Add rescan parameter.  Do not
	call fixup_var_refs when rescan is false.
	(gen_mem_addressof): Likewise.
	(assign_parms): Adjust calls to put_var_into_stack.
	(setjmp_protect): Likewise.
	(setjmp_protect_args): Likewise.
	* rtl.h (gen_mem_addressof): Change prototype.
	* stmt.c (expand_decl): Adjust calls to put_var_into_stack.
	* tree.h (put_var_into_stack): Change prototype.

2003-03-23  Arpad Beszedes <beszedes@cc.u-szeged.hu>

	PR middle-end/9967
	* builtins.c (expand_builtin_fputs): When optimizing for size,
	don't transform fputs into fwrite.

2003-03-24  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/sysv4.h (ASM_OUTPUT_ALIGNED_BSS): Remove unnecessary
	globalize_label.

	Merge from mainline.
	2003-01-13  Andreas Schwab  <schwab@suse.de>
	* config/rs6000/sysv4.h (ASM_OUTPUT_ALIGNED_LOCAL): Output type
	directive.

2003-03-23  Glen Nakamura <glen@imodulo.com>

	PR c/8224
	* fold-const.c (extract_muldiv_1): Don't pass through type conversions
	when signedness changes for division or modulus.

2003-03-23  Richard Henderson  <rth@redhat.com>

	* cfgcleanup.c (try_optimize_cfg): Allow merging of tablejumps
	before flow2.
	* cfgrtl.c (try_redirect_by_replacing_jump): Similarly.

2003-03-23  Richard Henderson  <rth@redhat.com>

	PR opt/10116
	* ifcvt.c (find_if_block): Disallow tablejump insns outgoing
	from then_bb or else_bb after flow2.
	* jump.c (tablejump_p): New.
	* rtl.h: Declare it.

2003-03-22  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (output_cbranch): Fix typo in comment.

2003-03-22  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (output_cbranch, output_bb, output_bvb): Output nop for
	conditional branch to the following instruction.  Use next_real_insn
	instead of next_active_insn.
	(output_dbra, output_movb, jump_in_call_delay): Use next_real_insn
	instead of next_active_insn.

2003-03-22  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("movti", "*movdi_31", "*movdf_31"): Use 'o' instead
	of 'm' constraint in forced-split alternatives.
	("*adddi3_31", "*subdi3_31"): Likewise.  Also, pass 0 instead of 1 as
	VALIDATE_ADDRESS parameter to operand_subword.

2003-03-22  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* config/c4x/t-c4x (MULTILIB_MATCHES): Make gcc recognize a c33 as
	a c30 instead of a c40 processor.

2003-03-21  Richard Henderson  <rth@redhat.com>

	PR opt/2001
	* bb-reorder.c (maybe_duplicate_computed_goto_succ): New.
	(make_reorder_chain_1): Call it.

	* function.h (struct function): Add computed_goto_common_label,
	computed_goto_common_reg.
	* function.c (free_after_compilation): Zap them.
	* stmt.c (expand_computed_goto): Use them to produce one
	indirect branch per function.

2003-03-22  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md ("call_value"): Fix trap check.

2003-03-22  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.h (ASM_DECLARE_FUNCTION_NAME): Fix typo in
	writing .interrupt command.
	* config/m68hc11/m68hc11.md ("call"): Look at the symbol to see
	if it's a far or near function.
	("call_value"): Likewise.
	* config/m68hc11/m68hc11.c (m68hc11_attribute_table): Add far and
	near attributes.
	(m68hc11_handle_fntype_attribute): Accept attributes on methods.
	(m68hc11_override_options): Ignore -mlong-calls for 68HC11.
	(m68hc11_initial_elimination_offset): Set current_function_far
	according to attributes.
	(expand_prologue): Likewise.
	(trap_handler_symbol): New global to keep track of trap handlers.
	(m68hc11_encode_section_info): Mark symbol as far if needed; set
	trap symbol.
	(m68hc11_is_far_symbol): New function.
	(m68hc11_is_trap_symbol): New function.
	* config/m68hc11/m68hc11-protos.h (m68hc11_is_far_symbol): Declare.
	(m68hc11_is_trap_symbol): Declare.

2003-03-21  Jan Hubicka  <jh@suse.cz>

	PR inline-asm/7916

	* function.c (instantiate_virtual_regs_lossage): New function.
	(instantiate_virtual_regs_1): Use it.
	(instantiate_virtual_regs): Do not continue in substition when insn has
	been deleted.

2003-03-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.h: Do not include fixdfdi.h on s390x.
	(TARGET_64BIT): Define as compile-time constant when IN_LIBGCC2.
	(MIN_UNITS_PER_WORD): Do not define when IN_LIBGCC2.

2003-03-21  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR doc-bug/9813
	* doc/extend.texi: Move misplaced paragraph about underscores in
	variables in macros.

2003-03-21  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* doc/invoke.texi: Fix table environment.

2003-03-21 Richard Earnshaw  <rearnsha@arm.com>

	* ifcvt.c (find_if_case_1): If we add a new bb, update the dominance
	information.

2003-03-21  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Richard Henderson  <rth@redhat.com>

	PR optimization/8366
	* config/sparc/sparc.h: (SYMBOLIC_CONST): New macro.
	(GO_IF_LEGITIMATE_ADDRESS): Use it. Reject the form
	PIC+SYMBOLIC_CONST in other modes than Pmode.
	(GO_IF_MODE_DEPENDENT_ADDRESS): Use it. Mark
	the form PIC+SYMBOLIC_CONST as mode dependent.

2003-03-20  Richard Henderson  <rth@redhat.com>

	* fold-const.c (extract_muldiv_1): Revert changing order of
	operands in case MULT_EXPR of 2003-02-16 patch.

2003-03-20  Richard Henderson  <rth@redhat.com>

	PR c/8602
	* integrate.c (output_inline_function): Reset input_filename
	and lineno from the decl before rest_of_compilation.

2003-03-20  Richard Earnshaw  <rearnsha@arm.com>

	PR 10066
	* arm.md (UNSPEC_PIC_BASE): New constant.
	(pic_add_dot_plus_four): Wrap with unspec.
	(pic_add_dot_plus_eight): Likewise.

2003-03-19  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_preferred_reload_class): Do not
	force constants to the pool unless necessary.
	(s390_decompose_address): Prefer to use pointer as base,
	not index register.
	* config/s390/s390.md ("*tsthiCCT_only"): Remove '?' from
	Q alternative.
	("*movdi_64", "*movsi", "movhi", "movqi_64", "movqi",
	"*movdf_64", "*movsf"): Add '?' to Q->Q alternatives.
	("*extractqi", "*extracthi", "*zero_extendhisi2_31",
	"*zero_extendqisi2_31", "*zero_extendqihi2_31",
	"*adddi3_31", "*subdi3_31"): Do not set "type" attribute.

2003-03-19  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (rs6000_emit_load_toc_table): Don't call
	rs6000_maybe_dead if !fromprolog.

2003-03-19  Jakub Jelinek  <jakub@redhat.com>

	* ifcvt.c (dead_or_predicable): Fail if there are any references
	to tablejump in merge_bb other than the final JUMP_INSN.

2003-03-19  Jakub Jelinek  <jakub@redhat.com>

	* stmt.c (expand_start_case): Call emit_queue ().

2003-03-19  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR 10062
	* config/pa/pa-hpux.h (TARGET_HPUX_UNWIND_LIBRARY): Redefine.
	* pa-protos.h (output_lbranch): New prototype.
	* pa.c (compute_frame_size): Change size of the frame marker on the
	64-bit ports to 48 bytes.
	(pa_output_function_prologue): Document why SAVE_SP is set.
	(hppa_expand_prologue): Save previous stack pointer into frame marker
	on targets which use the hpux unwind library.
	(output_cbranch): Use output_lbranch.
	(output_lbranch): New function to output long unconditional branches.
	* pa.h (TARGET_HPUX_UNWIND_LIBRARY): Define.
	(STACK_POINTER_OFFSET): Update offset for 48-byte frame marker on
	64-bit ports.
	* pa.md (jump): Use output_lbranch.
	(allocate_stack): New expander for dynamic stack allocation.

2003-03-18  Alexandre Oliva  <aoliva@redhat.com>

	* toplev.c (independent_decode_option): Return success for --help,
	--target-help and --version.

2003-03-19  Alan Modra  <amodra@bigpond.net.au>

	PR target/10073
	* combine.c (force_to_mode <NOT>): Use gen_int_mode.

2003-03-18  Andreas Schwab  <schwab@suse.de>

	PR target/7248
	* config/m68k/m68k.md (iordi3): Fix setting low half to -1.  From
	martin@blom.org.

2003-03-17  Jason Merrill  <jason@redhat.com>

	PR c++/10091
	* expr.c (expand_expr) [ADDR_EXPR]: Disallow taking the address of
	an unaligned member of TREE_ADDRESSABLE type.

2003-03-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* dwarf2asm.h: Delete obsolete comment.
	(dw2_asm_output_data, dw2_asm_output_delta, dw2_asm_output_offset,
	dw2_asm_output_pcrel, dw2_asm_output_addr,
	dw2_asm_output_addr_rtx, dw2_asm_output_encoded_addr_rtx,
	dw2_asm_output_nstring, dw2_asm_output_data_uleb128,
	dw2_asm_output_data_sleb128, dw2_asm_output_delta_uleb128,
	dw2_asm_output_delta_sleb128): Add ATTRIBUTE_NULL_PRINTF.

2003-03-17  Steve Ellcey  <sje@cup.hp.com>

	* stmt.c (tail_recursion_args): Call promote_mode to set
	unsignedp flag correctly before calling convert_move.

2003-03-17  Dave Love  <fx@gnu.org>
	    Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/alpha/osf.h (TARGET_OS_CPP_BUILTINS): Define __digital__,
	__arch64__ to match Compaq cc.

2003-03-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* function.c (thread_prologue_and_epilogue_insns): Set delete_unused
	argument to 0 for redirect_jump.

2003-03-16  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8805
	* except.c (eh_region_u_cleanup): Add prev_try.
	(expand_eh_region_end_cleanup): Set it.
	(reachable_handlers): Use it to skip over cleanup blocks.

2003-03-16  Richard Henderson  <rth@redhat.com>

	PR opt/6798
	* cfgcleanup.c: Include params.h.
	(try_crossjump_bb): Use PARAM_MAX_CROSSJUMP_EDGES.  Fix test for
	too many outgoing edges from a block.
	* Makefile.in (cfgcleanup.o): Depend on PARAMS_H.
	* params.def (max-crossjump-edges): New.
	* doc/invoke.texi: Document it.

2003-03-16  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.md (movstrictqi, movstrictqi_1): Check
	optimize_size as well.

2003-03-16  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (print_operand): Handle 'b' modifier
	for D register to specify the low part of it, aka B.
	(m68hc11_gen_movhi): Use REG_WAS_0 note and increment or decrement
	the register if we are loading 1 or -1 to it; avoid using temp
	register when moving X/Y to Y/X.
	(m68hc11_gen_movqi): Likewise.
	(m68hc11_check_z_replacement): Fix last insn setting for compare case.

2003-03-14  Mark Mitchell  <mark@codesourcery.com>

	PR optimization/9016
	* config/i386/i386.c (ix86_expand_move): Force more CONST_DOUBLEs
	into the constant pool.

2003-03-16  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR target/9164
	* tree.c (get_narrower): For extensions with unchanged bit number,
	return the unsignedness of the outer mode.

2003-03-16  Roger Sayle  <roger@eyesopen.com>

	* c-typeck.c (build_component_ref):  Turn "for" into "do .. while"
	to avoid "may be used uninitialized" warning on ia64-hpux.
	* config/ia64/ia64-c.c: Include "tm_p.h" for function prototypes.

2003-03-16  Neil Booth  <neil@daikokuya.co.uk>

	* cppinit.c: Remove support of -A-.
	* doc/cppopts.texi: Remove documentation of -A-.

2003-03-15  Richard Henderson  <rth@redhat.com>

	2003-01-14  Richard Henderson  <rth@redhat.com>
	* config/alpha/alpha.c (alpha_expand_mov): Use correct mode
	for force_const_mem.

2003-03-15  Richard Henderson  <rth@redhat.com>

	PR target/9700
	* config/alpha/alpha.c (alpha_va_start): Account for
	current_function_pretend_args_size in the AP offset.

2003-03-15  Jason Merrill  <jason@redhat.com>

	PR debug/6387
	* dwarf2out.c (dwarf2out_decl): If we're at -g1, just stick nested
	function DIEs at toplevel.
	(decls_for_scope): At -g1, don't descend into subblocks.

2003-03-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* varasm.c (struct rtx_const): Change type of un.addr member
	to struct holding an additional 'symbol' member.
	(decode_rtx_const): Re-enable optimization to count SYMBOL_REFs
	with equal string addresses as equal.
	(simplify_subtraction): Adapt to struct rtx_const change.

2003-03-15  Glen Nakamura  <glen@imodulo.com>

	* reload1.c (choose_reload_regs): Use && instead of ||
	with REG_CANNOT_CHANGE_MODE_P condition.

2003-03-15  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	PR optimization/9387
	* function.c (thread_prologue_and_epilogue_insns): Use redirect jump
	for conditional returns.

2003-03-14  Jason Merrill  <jason@redhat.com>

	PR optimization/6871
	* varasm.c (assemble_variable): Leave constant zeroes in .rodata.

2003-03-12  Andrew Lewycky  <andrew@mxc.ca>

	PR c++/7050
	* expr.c (store_expr): Don't attempt to store void-typed trees,
	just evaluate them for side effects.

2003-03-14  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8396
	* tree-inline.c (initialize_inlined_parameters): Make sure the value
	of read-only constant arguments is passed with the right type.

2003-03-14  Andreas Jaeger  <aj@suse.de>
	    Gwenole Beauchesne  <gbeauchesne@mandrakesoft.com>

	* linux64.h (TARGET_OS_CPP_BUILTINS): Define _LP64 and __LP64__ in
	64-bit mode.

2003-03-13  Mike Stump  <mrs@apple.com>

	* ggc-page.c (struct page_entry): Remove varray.h header.
	Add index_by_depth field.
	Remove save_in_use_p field.
	(struct globals): Add depth_in_use, depth_max, by_depth_in_use,
	by_depth_max, by_depth, and save_in_use fields.
	(INITIAL_PTE_COUNT): Add.
	(save_in_use_p_i): Add.
	(save_in_use_p): Add.
	(adjust_depth): Add.
	(push_depth): Add.
	(push_by_depth): Add.
	(prefetch): Add.
	(free_page): Add support for and use faster data structures.
	(ggc_alloc): Likewise.
	(init_ggc): Likewise.
	(ggc_recalculate_in_use_p): Likewise.
	(ggc_pop_context): Likewise.
	(clear_marks): Likewise.
	* Makefile.in (ggc-page.o): Remove varray.h.

2003-03-12  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (pa_init_builtins): Fix warning.

2003-03-12  Richard Henderson  <rth@redhat.com>

	PR opt/8178
	* config/i386/i386.md (ffssi2): Tighten op1 predicate to
	the requirements of the output insns.

2003-03-12  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.h (ASM_OUTPUT_XDATA_CHAR): Remove.
	(ASM_OUTPUT_XDATA_SHORT): Remove.
	(ASM_OUTPUT_XDATA_INT): Remove.
	(ASM_OUTPUT_XDATA_DOUBLE_INT): Remove.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Handled 32 bit address diffs.
	(ASM_PREFERRED_EH_DATA_FORMAT): Handle 32 bit EH pointers.
	(CASE_VECTOR_MODE): Handle 32 bit pointers in case statement.

2003-03-12  Andrew Lewycky  <andrew@mxc.ca>

	PR c++/7050
	* expr.c (store_expr): Don't attempt to store void-typed trees,
	just evaluate them for side effects.

2003-03-12  Bob Wilson  <bob.wilson@acm.org>

	Backport from mainline:
	2003-03-12  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.md (adddi3): Don't clobber source operand used
	to detect carry.
	(subdi3): Reorder emitted instructions.

2003-03-12  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_setup_incoming_varargs): Set stack_alignment_needed to 128.

2003-03-12  Daniel Jacobowitz  <drow@mvista.com>

	Fix PR target/9797 and PR c/9853.
	* stmt.c (expand_decl_init): Call push_temp_slots () and
	pop_temp_slots ().

2003-03-12  Hans-Peter Nilsson  <hp@bitrange.com>

	* configure.in (rlim_t): Define to long if no valid definition
	found in sys/resource.h.
	* config.in, configure: Regenerate.

2003-03-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/9928
	* c-decl.c (duplicate_decls): Discard the initializer of the new decl
	only if it is a VAR_DECL.

2003-03-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/9888
	* config/i386/i386.md (jcc_1): Fix range.
	(jcc_2): Likewise.
	(jump): LIkewise.
	(doloop_end_internal): Likewise.

2003-03-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/9888
	* config/i386/i386.md (movsi_1): Remove special alternatives
	for %eax register.
	(movhi_1): Likewise.
	* config/i386/i386.c (memory_address_length): Do not use
	short displacement when there is no base.
	(ix86_attr_length_address_default): Handle LEA instructions.

2003-03-11  Loren James Rittle  <ljrittle@acm.org>

	(per-port preprocessor fix, concurrent to Neil's cppinit.c fix)
	* config/freebsd-spec.h (FBSD_CPP_PREDEFINES): Remove.
	(FBSD_TARGET_OS_CPP_BUILTINS): New port-specific macro.
	(FBSD_TARGET_CPU_CPP_BUILTINS): New port-specific macro.
	* config/freebsd.h (CPP_PREDEFINES): Remove.
	(TARGET_OS_CPP_BUILTINS): New.
	* config/alpha/freebsd.h: Use overridden FBSD_TARGET_CPU_CPP_BUILTINS
	instead of TARGET_OS_CPP_BUILTINS.
	* config/sparc/freebsd.h (CPP_PREDEFINES): Remove.

2003-03-11  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR bootstrap/9994
	Backport from mainline:

	2003-02-18  Roger Sayle  <roger@eyesopen.com>

	* sbitmap.c (sbitmap_resize): New function.
	* sbitmap.h (sbitmap_resize): Prototype here.
	* recog.c (split_all_insns): Use sbitmap_resize.

	Mon Feb 17 16:16:54 CET 2003  Jan Hubicka  <jh@suse.cz>

	* recog.c (split_all_insns):  Fix memory overflow.

	2003-02-15  Richard Henderson  <rth@redhat.com>

	* recog.c (split_all_insns): Include new blocks in life update;
	do a global life update.

2003-03-11  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/cris/cris.md: Remove lingering EGCS reference.
	("*extopqihi_side_biap"): For HI operation, match
	cris_additive_operand_extend_operator, not
	cris_operand_extend_operator.  Adjust condition.
	("*extopqihi_side", "*extopqihi"): Ditto.
	("*extopqisi_side_biap"): Correct operand numbers in condition.
	("*extophisi_side_biap", "*extopqisi_swap_side_biap"): Ditto.
	("*extophisi_swap_side_biap", "*extopqisi_swap"): Ditto.
	("*extophisi_swap"): Ditto.
	("*extopqihi_swap_side_biap"): For HI operation, match a simple
	PLUS, not cris_operand_extend_operator.  Adjust condition and
	output template.
	("*extopqihi_swap_side", "*extopqihi_swap"): Ditto.
	* config/cris/cris.h (PREDICATE_CODES): Add
	cris_additive_operand_extend_operator.
	* config/cris/cris.c (cris_additive_operand_extend_operator):
	New predicate.

	* config/cris/aout.h (ENDFILE_SPEC): Undef.
	(CRIS_CPP_SUBTARGET_SPEC): Move -D__AOUT__ to...
	(TARGET_OS_CPP_BUILTINS): New macro.
	(HAVE_GAS_HIDDEN): Undef.
	* config/cris/cris.h: Remove EGCS references.
	(CPP_SPEC): Remove "-$".
	(INIT_CUMULATIVE_ARGS): Correct comment.
	* config/cris/cris.h (CRIS_CPP_SUBTARGET_SPEC): Move -D__ELF__ to...
	(TARGET_OS_CPP_BUILTINS): New macro.
	(CPP_PREDEFINES): Don't define.  Move old definitions and...
	(CPP_SPEC): ...move -D__CRIS_ABI_version=2 to...
	(TARGET_CPU_CPP_BUILTINS): New macro.
	* config/cris/linux.h (CRIS_CPP_SUBTARGET_SPEC): Move constant
	definitions and the optional __PIC__, __pic__ and
	__NO_UNDERSCORES__ definitions to...
	(TARGET_OS_CPP_BUILTINS): New macro.

2003-03-10  Devang Patel  <dpatel@apple.com>

	PR c++/9394
	* gcc.c (DEFAULT_SWITCH_TAKES_ARG): Remove.
	(DEFAULT_WORD_SWITCH_TAKES_ARG): Remove.
	* gcc.h (DEFAULT_SWITCH_TAKES_ARG): Add.
	(DEFAULT_WORD_SWITCH_TAKES_ARG): Add.
	* cppspec.c (DEFAULT_SWTICH_TAKES_ARG): Remove.
	(DEFAULT_WORD_SWITCH_TAKES_ARG): Remove.

2003-03-10  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.h (HARD_REGNO_RENAME_OK): Define.
	* config/m68hc11/m68hc11-protos.h (m68hc11_hard_regno_rename_ok):
	Declare.
	* config/m68hc11/m68hc11.c (m68hc11_hard_regno_rename_ok): New function
	for reg rename optimization to avoid using Z and Y registers.

2003-03-10  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md ("*addhi3_68hc12"): Accept any constant
	when adding to X and Y since leax/leay are fast.
	("*addhi3"): Accept 'I' constraint when adding to address register.
	("rotlhi3"): Operand 1 must be a register_operand.
	(peephole2): New peephole to optimize some adds.
	* config/m68hc11/m68hc11.h (CONST_OK_FOR_LETTER_P): Use 'I' constraint
	to represent -2 .. 2 small integer range.

2003-03-10  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (m68hc11_gen_rotate): Set carry before
	each 16-bit rotation.

2003-03-10  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.h: Merge from mainline.

2003-03-10  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation):  Revert the previous patch.

2003-03-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/9986
	* c-common.c (c_common_nodes_and_builtins): Initialize target builtins
	after the common builtins.
	* pa-hpux.h (DONT_HAVE_FPUTC_UNLOCKED): Define.
	* pa.c (TARGET_INIT_BUILTINS): Define.
	(pa_init_builtins): New function.

	* pa.md (call, call_value, sibcall, sibcall_value): When sufficient
	space has been allocated for the outgoing arguments, set the arg
	pointer for a call emitted after virtuals have been instantiated
	using the stack pointer offset, otherwise abort.

2003-03-06  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation):  Defer RTL compilation only when
	RTL inlining is done.

	* i386.c (ix86_expand_vector_move): Do not crash when offloading
	to memory in PIC mode.

2003-03-08  Neil Booth  <neil@daikokuya.co.uk>

	* cppinit.c (cpp_finish_options): Set first_unused_line to -1.

2003-03-08  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/7796
	* unroll.c (calculate_giv_inc): Handle constants being
	loaded with LSHIFTRT.

2003-03-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8726
	Backport patch from mainline:

	2003-01-08  Dale Johannesen  <dalej@apple.com>

	* function.c (assign_parms):  Don't set pretend_args_size if
	REG_PARM_STACK_SPACE.

2003-03-06  Kurt Garloff  <garloff@suse.de>
	    Geoffrey Keating  <geoffk@apple.com>
	    Dale Johannesen  <dalej@apple.com>
	* params.def: Introduce parameter max-inline-insns-rtl for
	a separate limit for the RTL inliner.
	* params.h: Likewise.
	* integrate.c (function_cannot_inline_p): Use it.
	* toplev.c (decode_f_option): Set multiple parameters
	controlling inlining with -finline-limit.
	* params.def: Fix orthographic and typographic errors.
	* doc/invoke.texi: Document parameters controlling inlining
	and the way -finline-limit sets multiple of them.
	* tree.h (struct tree_decl): Introduce inlined_function_flag,
	recording whether the function became eligible for inlining
	by a compiler flag rather than the declaration.
	Provide DID_INLINE_FUNC macro to access it.
	* c-decl.c (grokdeclarator): Set DID_INLINE_FUNC.
	* cp/decl.c (grokfndecl): Likewise.
	* toplev.c (rest_of_compilation): Likewise.
	* cp/optimize (maybe_clone_body): Copy DID_INLINE_FUNC.
	* print-tree.c (print_node): Report it.
	* params.def: Introduce new max-inline-insns-auto limit.
	* params.h: Likewise.
	* tree-inline.c (inlinable_function_p): Apply it to functions
	with DID_INLINE_FUNC set.
	* toplev.c (decode_f_option): Initialize it from -finline-limit
	value.
	* doc/invoke.texi: Document new parameter.

2003-03-06  Michael Matz  <matz@suse.de>

	* i386/i386.c (ix86_save_reg): Also test
	current_function_uses_const_pool.

2003-03-05  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md (return_external_pic): Add !TARGET_PA_20 to constraint.
	(epilogue): Don't generate return_external_pic when emitting PA 2.0
	code.

2003-03-05  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.h (PAD_VARARGS_DOWN): Define and return
	according to va_arg type.
	(EXPAND_BUILTIN_VA_ARG): Remove.
	* config/m68hc11/m68hc11.c (m68hc11_va_arg): Remove.
	* config/m68hc11/m68hc11-protos.h (m68hc11_va_arg): Remove.

2003-03-05  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation):  Do duplicate loop headers when
	optimizing for size.

2003-03-05  Michael Matz  <matz@suse.de>

	* unwind.h: Add the GPL exception.
	* Makefile.in (USER_H): Add unwind.h.

2003-03-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/9799
	* c-typeck.c (push_init_level): Add sanity check.

2003-03-04  Steve Ellcey  <sje@cup.hp.com>

	* expr.c (convert_modes): Check for legal hard register.

2003-03-04  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.c (m68k_output_function_prologue): Fix CFA
	offset without frame pointer.

2003-03-04  Steve Ellcey  <sje@cup.hp.com>

	* expr.c (expand_expr): Call promote_mode to set unsignedp.

2003-03-04  Roger Sayle  <roger@eyesopen.com>

	PR c++/9367
	* builtin-types.def (DEF_FUNCTION_TYPE_VAR_3): New macro.
	(BT_FN_INT_CONST_STRING_VALIST_ARG,
	BT_FN_INT_STRING_CONST_STRING_VALIST_ARG,
	BT_FN_INT_CONST_STRING_CONST_STRING_VALIST_ARG,
	BT_FN_INT_STRING_SIZE_CONST_STRING_VALIST_ARG,
	BT_FN_INT_STRING_CONST_STRING_VAR,
	BT_FN_INT_CONST_STRING_CONST_STRING_VAR,
	BT_FN_INT_STRING_SIZE_CONST_STRING_VAR): New built-in types.
	* builtin-attrs.def (ATTR_NONNULL_1, ATTR_NONNULL_2,
	ATTR_NONNULL_3): Also include the nothrow attribute.
	(sprintf, scanf, sscanf, vprintf, vsprintf, snprintf,
	vsnprintf, vscanf, vsscanf): Don't define attributes here.
	* builtins.def (putchar, puts): Make full C89 built-ins.
	(snprintf, sprintf, scanf, sscanf, vprintf, vscanf,
	vsscanf, vsnprintf, vsprintf): New built-ins.
	* c-common.c (c_common_nodes_and_builtins): Handle new macro
	DEF_FUNCTION_TYPE_VAR_3.

	* doc/extend.texi: Document these new built-in functions.

2003-03-04  Jan Hubicka  <jh@suse.cz>

	* calls.c (rtx_for_function_call): Take the address as an argument
	(expand_call): Do not modify the expression.

2003-03-04  Kevin Buettner  <kevinb@redhat.com>

	* dwarf2out.c (rtl_for_decl_location): Don't return NULL_RTX for
	global register variables.

2003-03-03  Richard Henderson  <rth@redhat.com>

	* configure.in (HAVE_AS_LTOFFX_LDXMOV_RELOCS): New ia64 test.
	* config.in, configure: Rebuild.
	* config/ia64/ia64.c (ia64_ld_address_bypass_p): Accept lo_sum.
	* config/ia64/ia64.md (load_symptr): Use high/lo_sum for the
	paired ldtoffx and ldxmov annotations.
	(load_symptr_internal1): Remove.
	(load_symptr_high, load_symptr_low): New.
	* config/ia64/ia64.h (HAVE_AS_LTOFFX_LDXMOV_RELOCS): Default to 0.

2003-03-03  Jason Merrill  <jason@redhat.com>

	* calls.c (compute_argument_addresses): Give the new MEMs a
	minimum alignment of PARM_BOUNDARY.

2003-03-03  Geoffrey Keating  <geoffk@apple.com>

	* doc/install.texi (Specific): Update entry for powerpc-darwin.

2003-03-03  Jan Hubicka  <jh@suse.cz>
	* toplev.c (rest_of_compilation):  Avoid cfg_cleanup calls when not
	optimizing.

2003-02-28  Jan Hubicka  <jh@suse.cz>

	* combine.c (gen_lowpart_for_combine): Update handling of subregs_of_mode
	* flow.c (life_analysis, mark_used_regs): Likewise.
	* regclass.c (subregs_of_mode): Turn into single bitmap.
	(cannot_change-mode_set_regs, invalid_mode_change_p): Update
	dealing with subregs_of_mode
	* regs.h (subregs_of_mode): Update prototype.

2003-02-28  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Rearrange insn splitting
	* reg-stack.c (reg_to_stack): Do not split insns.

2003-03-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* ggc-common.c (ggc_rlimit_bound): Cast RLIM_INFINITY to avoid
	warnings.

2003-03-02  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (m68hc11_override_options): Don't enable
	min/max instructions by default as may result in reload errors.

2003-03-02  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.md ("mulqi3"): Allow address register to
	avoid reload problems; define split for it.

2003-03-02  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c (m68hc11_shift_operator): New function.
	* config/m68hc11/m68hc11-protos.h (m68hc11_shift_operator): Declare.
	* config/m68hc11/m68hc11.h (PREDICATE_CODES): Register.
	* config/m68hc11/m68hc11.md ("rotrhi3", "rotlhi3"): New patterns for
	rotatert and rotate.
	("rotrhi3_const", "rotlhi3_const"): Rename of old 'rotrhi3' insns.
	("*rotrhi3", "*rotlhi3"): New insn pattern for non-const rotatert.
	("*rotrhi3_addr"): New split for shift insns on address register.
	("*lshrhi3", "*ashrhi3", "*ashlhi3_2"): Use new split.
	* config/m68hc11/larith.asm (___rotlhi3): New asm function.
	(___rotrhi3): Likewise.
	* config/m68hc11/t-m68hc11-gas (LIB1ASMFUNCS): Build them.

2003-03-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fp-bit.h (float_to_usi): Fix condition wrapping prototype.

2003-03-02  Ashif Harji  <asharji@uwaterloo.ca>

	* gcc.c (default_compilers): Add -no-integrated-cpp flag to invoke
	  an external cpp during compilation.
	(option_map): Likewise.
	* objc/lang-specs.h (default_compilers): Similarly.
	* doc/invoke.texi: Document -no-integrated-cpp flag.

2003-03-01  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (*-*-netbsd[2-9]*, *-*-netbsdelf[2-9]*): Enable
	POSIX thread support by default.

2003-03-01  Roger Sayle  <roger@eyesopen.com>

	PR bootstrap/7389.
	* basic-block.h (flow_bb_inside_loop_p): Correct prototype.

2003-02-28  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/netbsd.h: Update copyright years.
	(NETBSD_CPP_SPEC): Define _REENTRANT and _PTHREADS if
	-pthread is specified on the command line.

2003-02-28  Bob Wilson  <bob.wilson@acm.org>

	Backport following patch:

	2003-02-28  Bob Wilson  <bob.wilson@acm.org>
	* config.gcc (xtensa-*-linux*): Add t-slibgcc-elf-ver to tmake_file.

2003-02-27  Joel Sherrill <joel@OARcorp.com>

	PR 9638/other
	* config/i386/i386.c (DEFAULT_PCC_STRUCT_RETURN): Ensure the
	this constant defaults to 1.

2003-02-28  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md: Disable the movstrsi define_split.

2003-02-28  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (CRT_CALL_STATIC_FUNCTION): Wrap in
	#ifndef __mips16.

2003-02-27   Geert Bosch <bosch@gnat.com>

	* toplev.c (print_version): Add indentation for GGC heuristics and
	output after printing version information.

2003-02-27  James E Wilson  <wilson@tuliptree.org>

	PR bootstrap/9255
	* combine.c (simplify_comparison): Require integral mode when
	permuting SUBREG with AND.

2003-02-27  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (STARTFILE_PREFIX_SPEC): Remove.

2003-02-27  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.md: Add TI constant splitter.

2003-02-26  Jan Hubicka  <jh@suse.cz>

	* expr.c (emit_group_store):  Fix crash when converting single
	register into complex register.

2003-02-26  Michael Matz  <matz@suse.de>

	* ra-colorize.c (merge_moves): Fix list handling.

2003-02-26  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (compute_frame_size): Don't assume PREFERRED_STACK_BOUNDARY
	is 8 * STACK_BOUNDARY.
	* pa.h (PREFERRED_STACK_BOUNDARY): Change to 128 on 64-bit port.

2003-02-26  Alan Modra  <amodra@bigpond.net.au>

	PR target/9681
	* tlink.c (scan_linker_output): Drop leading '.' from symbol names.

2003-02-25  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (function_arg): Pass variable sized
	structures correctly on the stack.

2003-02-25  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR target/9732
	* config/rs6000/rs6000.c (first_reg_to_save): Handle
	PIC_OFFSET_TABLE_REGNUM for -fPIC too.
	(rs6000_emit_prologue): Likewise.
	(rs6000_emit_epilogue): Likewise.
	* config/rs6000/rs6000.h (CONDITIONAL_REGISTER_USAGE): Make
	PIC_OFFSET_TABLE_REGNUM a fixed register for -fPIC.

2003-02-25  Richard Henderson  <rth@redhat.com>

	* real.c (real_to_integer2): Force overflow result only for
	unsigned overflow.

2003-02-25  Jan Hubicka  <jh@suse.cz>

	PR target/8343
	* m68k.md (umulsidi, mulsidi expanders): Use register operand.

2003-02-24  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* config/c4x/c4x.h (ASM_FILE_START): Added support for the c33
	processor.

2003-02-24  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/iris6.h (TARGET_OS_CPP_BUILTINS): Define __c99 for
	ISO C99 and C++.

	* fixinc/inclhack.def (irix___restrict): Don't change __restrict
	for C++ on IRIX 6.5.1[89].
	* fixinc/tests/base/internal/sgimacros.h: New file.

	* fixinc/inclhack.def (irix_wcsftime): Use XPG5 variant for C99.
	* fixinc/tests/base/internal/wchar_core.h: New file.

	* fixinc/inclhack.def (irix_socklen_t): Fix broken IRIX 6.5.1[78]
	socklen_t definition.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/sys/socket.h: New file.
	Fixes PR libgcj/9652.

2003-02-24  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/alpha/osf.h (TARGET_OS_CPP_BUILTINS): Rename
	__EXTERN_PREFIX to __PRAGMA_EXTERN_PREFIX.
	* doc/extend.texi (Tru64 Pragmas): Reflect this.

	* fixinc/inclhack.def (alpha___extern_prefix): Indicate #pragma
	extern_prefix support for Tru64 UNIX V5 <sys/stat.h>.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/sys/stat.h [ALPHA___EXTERN_PREFIX_CHECK]: New
	testcase.
	Fixes PR c/5059, c/6126, other/9671.

2003-02-24  Alan Modra  <amodra@bigpond.net.au>

	PR 9297, PR 9722
	* calls.c (store_one_arg): Revert 1999-02-16 change.  Revert
	2000-12-17 change.  Pass EXPAND_STACK_PARM to expand_expr.
	* expr.h (enum expand_modifier): Define EXPAND_STACK_PARM.
	(enum block_op_methods): Reorder for better store_expr optimization.
	* expr.c (store_expr): Test bit 1 of "want_value" for call param
	stores, test bit 0 for original want_value meaning.  Pass
	BLOCK_OP_CALL_PARM to emit_block_move when bit 1 set.  Adjust
	recursive calls, and calls to expand_param.
	(expand_expr): Handle EXPAND_STACK_PARM modifier.  When cse
	expected, set target to 0 rather than to subtarget.  Formatting.

2003-02-23  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/invoke.texi (ggc-min-expand, ggc-min-heapsize): Document
	new default behavior.
	* ggc-common.c: Include sys/resource.h.
	(ggc_rlimit_bound): New function.
	(ggc_min_expand_heuristic, ggc_min_heapsize_heuristic): Update
	defaults to account for rlimits.

2003-02-22  Jan Hubicka  <jh@suse.cz>

	* config/linux.h (TARGET_HAS_F_SETLKW): Define.
	* config/alpha/linux.h (TARGET_HAS_F_SETLKW): Likewise

2003-02-22  Hans-Peter Nilsson  <hp@axis.com>

	* regmove.c (optimize_reg_copy_1): Do not replace a hard register
	in an asm.

2003-02-22  Jan Hubicka  <jh@suse.cz>

	* i386.c (builtin_description): Add __builtin_ia32_paddq and
	__builtin_ia32_psubq. Fix __builtin_ia32_paddq128
	 and __builtin_ia32_psubq128.
	* i386.h (IX86_BUILTIN_PADDQ, IX86_BUILTIN_PSUBQ): New.
	* i386.md (addv*, mmx_ior*, mmx_xoe*, mmx_and*): Add missing '%'.
	(mmx_adddi3, mmx_subdi3): New.
	* mmintrin.h (_mm_add_si64, _mm_sub_si64): New.
	* xmmintrin.h (_mm_movepi64_pi64): New.
	(_mm_add_epi64, _mm_sub_epi64): fix.
	(_mm_mul_pu16): Rename to...
	(_mm_mul_su32): ... this one.

	* i386.c (def_builtin):  Special case 64bit builtins.
	(MASK_SSE164, MASK_SSE264): New constants.
	(builtin_description): Add 64bit builtins.
	(ix86_init_mmx_sse_builtins): Likewise.
	* i386.h (enum ix86_builtins): Likewise.
	* i386.md (cvtss2siq, cvttss2siq, cvtsd2siq, cvttsd2siq, cvtsi2sdq,
	sse2_movq2dq_rex64, sse2_movsq2q_rex64): New.
	(sse2_movq2dq, sse2_movsq2q): Disable for 64bit.
	* mmintrin.h (_mm_cvtsi64x_si64, _mm_set_pi64x, _mm_cvtsi64_si64x): New.
	* xmmintrin.h (_mm_cvtss_si64x, _mm_cvttss_si64x, _mm_cvtsi64x_ss,
	_mm_set_epi64x, _mm_set1_epi64x, _mm_cvtsd_si64x, _mm_cvttsd_si64x,
	_mm_cvtsi64x_sd, _mm_cvtsi64x_si128, _mm_cvtsi128_si64x): New.

	* builtins.c (expand_builtin_expect):  Do not predict
	flag_guess_branch_prob is not set.
	* c-semantics.c (expand_stmt): Likewise.
	* predict.c (predict_insn): Likewise.
	* stmt.c (expand_continue_loop): Likewise.
	* toplev.c (rest_of_compilation): Do not call
	note_prediction_to_br_prob and note_prediction_to_br_prob
	when not optimizing.

	* basic-block.h (tidy_fallthru_edges): Kill.
	* cfgrtl.c (tidy_fallthru_edges): Kill.
	* cfgbuild.c (find_basic_blocks): Do not call tidy_fallthru_edges.
	* cfgcleanup.c (delete_unreachable_blocks): Likewise.

2003-02-22  Steven Bosscher  <s.bosscher@student.tudelft.nl>

	PR other/3782
	* toplev.c (process_options): If flag_detailed_statistics is set,
	then set time_report as well.

	PR c/8828
	* jump.c (never_reached_warning): Don't fall through BARRRIER
	insns.  Update comments to reflect what the function really does.

2003-02-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/invoke.texi (ggc-min-expand, ggc-min-heapsize): Update
	documentation.
	* ggc-common.c: Include params.h
	(ggc_min_expand_heuristic, ggc_min_heapsize_heuristic,
	init_ggc_heuristics): New functions.
	* ggc.h (ggc_min_expand_heuristic, ggc_min_heapsize_heuristic,
	init_ggc_heuristics): Prototype.
	* toplev.c (print_version):  Output GGC heuristics.
	(parse_options_and_default_flags): Call init_ggc_heuristics.

2003-02-21  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (commit_edge_insertions):  Call
	find_many_sub_basic_block only when some code has been emitted.
	(commit_edge_insertions_watch_calls): Bring into sync with
	commit_edge_insertions

2003-02-21  Zack Weinberg  <zack@codesourcery.com>

	* cpphash.h (struct lexer_state): Add directive_wants_padding.
	* cpplib.c (_cpp_handle_directive): Set directive_wants_padding
	for directives of type INCL.
	(glue_header_name, parse_include): Use get_token_no_padding.
	* cppmacro.c (replace_args): If directive_wants_padding,
	provide padding tokens.

2003-02-21  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (commit_one_edge_insertion): Only mark BB for splitting.
	(commit_edge_insertions): Call find_many_sub_basic_blocks

	* reg-stack.c (convert_regs): Cleax aux for blocks.

2003-02-21  Glen Nakamura  <glen@imodulo.com>

	PR optimization/8613
	* builtins.c (expand_builtin): Emit postincrements before expanding
	builtin functions.

2003-02-21  Toon Moene  <toon@moene.indiv.nluug.nl>

	PR fortran/9038
	* c-opts.c (sanitize_cpp_opts): Add Fortran front end
	options to be ignored.
	(c_common_decode_option): Ignore them when preprocessing.

2003-02-21  Ben Elliston  <bje@redhat.com>

	PR other/5634
	* doc/install.texi (Configuration): Explain using $HOME instead of
	the ~ metacharacter when referring to home directories.

2003-02-20  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_reload_in_hi): Ensure that the scratch register does
	not overlap the final result register.

2003-02-20  Josef Zlomek  <zlomekj@suse.cz>

	* combine.c (distribute_notes): Kill REG_EXEC_COUNT.
	* rtl.c (reg_note_name): Likewise.
	* rtl.h (enum reg_note): Likewise.
	* doc/invoke.texi: Likewise.
	* doc/rtl.texi: Likewise.

2003-01-30  Richard Henderson  <rth@redhat.com>

	* tree-inline.c (walk_tree): Streamline duplicate hash table lookup.

2003-02-19  Daniel Jacobowitz  <drow@mvista.com>

	* expr.c (expand_expr): Use gen_int_mode for the argument
	to gen_rtx_MULT.

2003-02-19  Jan Hubicka  <jh@suse.cz>

	* i386.md (cosxf2):  Fix conditional.

2003-02-18  Matt Austern <austern@apple.com>
	* toplev.c, langhooks.c, langhooks-def.h: Move
	write_global_declarations from toplev.c to langhooks.c.

2003-02-18  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (general_operand_src): Always check
	MODE.
	(general_operand_dst): Likewise.

2003-02-18  Richard Henderson  <rth@redhat.com>

	* c-common.c (handle_used_attribute): Accept static data too.

2003-02-18  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.md (floatdidf2, floatdisf2): Add %, before second
	instruction in output template.
	(bsp_value): Change output template from string to C code, add %,
	before actual instruction.
	(flushrs): Mark as not predicable.

2003-02-18  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*zero_extendhisi2_h8300): Fix the
	insn length.
	(extendqisi2): Likewise.
	(*extendhisi2_h8300): Likewise.

2003-02-18  Matt Austern <austern@apple.com>

	* langhooks.h, langhooks-def.h: introduce new langhook,
	final_write_globals, with write_global_declarations as default.
	* toplev.c: Move invocation of wrapup_global_declarations from
	compile_file to new function, write_global_declarations.  Change
	compile_file to use final_write_globals hook.  Change
	wrapup_global_declarations so writing to DECL_DEFER_OUTPUT is
	conditional.

2003-02-18  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md: Correct and enhance comment.

2003-02-16  Kai Henningsen  <kaih@khms.westfalen.de>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Specific): Fix link for m68k-att-sysv.
	(Binaries): Ditto for Sinix/Reliant Unix.

2003-02-16  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* config/i386/i386-protos.h (function_arg_pass_by_reference): Declare.
	* config/i386/i386.h (FUNCTION_ARG_PASS_BY_REFERENCE): Use it.
	* config/i386/i386.c (function_arg_pass_by_reference): New.
	(ix86_va_arg): Support arguments passed by reference.

2003-02-16 Arend Bayer <arend.bayer@web.de>
	   Richard Henderson  <rth@redhat.com>

	PR c/8068
	* fold-const.c (extract_muldiv_1): Rename from extract_muldiv;
	rearrange mult arguments for less recursion.
	(extract_muldiv): New.  Prevent runaway recursion.

2003-02-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygwin.h (TARGET_SUBTARGET_DEFAULT): Set
	MASK_ALIGN_DOUBLE.

2003-02-15  Adam Nemet  <anemet@lnxw.com>

	PR opt/2391
	* combine.c: Fix spelling in comment.
	(cached_nonzero_bits): New function.
	(cached_num_sign_bit_copies): New function.
	(nonzero_bits_with_known): New macro.
	(num_sign_bit_copies_with_known): New macro.
	(nonzero_bits1): Rename from nonzero_bits.  Add three new
	arguments.  Change calls from nonzero_bits to
	nonzero_bits_with_known.
	(num_sign_bit_copies1): Rename from num_sign_bit_copies.  Add
	three new arguments.  Change calls from num_sign_bit_copies to
	num_sign_bit_copies_with_known.
	(nonzero_bits): New macro.
	(num_sign_bit_copies): New macro.
	(update_table_tick): Don't traverse identical subexpression more
	than once.
	(get_last_value_validate): Likewise.

2003-02-15  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR optimization/7702
	* reload1.c (reload_cse_simplify_set): Honor
	CANNOT_CHANGE_MODE_CLASS.

2003-02-15  Jan Hubicka  <jh@suse.cz>

	PR optimization/9258, PR fortran/7681
	* global.c (struct allocno): Add no_stack_reg.
	(global_conflicts): Set it.
	(find_reg): Use it.

2003-02-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (mn10300_wide_const_load_uses_clr): New
	function.
	* config/mn10300/mn10300-protos.h: Declare it.
	* config/mn10300/mn10300.md (movdi, movdf): Use it to compute
	attribute cc of instructions that may use clr.

2003-02-13  John David Anglin  <dave.anglin@nrc-crnc.gc.ca>

	* inclhack.def (hpux_long_double): Tighten select and add bypass
	regexp.
	* fixincl.x: Rebuilt.

2003-01-30  Richard Henderson  <rth@redhat.com>

	* ggc-page.c (G.context_depth_allocations): New.
	(G.context_depth_collections): New.
	(alloc_page): Set G.context_depth_allocations.
	(ggc_collect): Set G.context_depth_collections.
	(ggc_push_context): Limit to HOST_BITS_PER_LONG contexts.
	(ggc_pop_context): Early exit for no allocations or collections.

2003-01-25  Segher Boessenkool  <segher@koffie.nl>

	* bitmap.h (BITMAP_WORD): New typedef: fundamental storage
	type for bitmaps.  Use unsigned long.
	(nBITMAP_WORD_BITS): New macro.
	(BITMAP_WORD_BITS): New macro.
	(rest of file): Use it.
	* bitmap.c: Use it.

2003-02-13  Josef Zlomek  <zlomekj@suse.cz>

	* cfgcleanup.c (outgoing_edges_match): When there is single outgoing
	edge and block ends with a jump insn it must be simple jump.

2003-02-13  Robert Lipe <robertlipe@usa.net>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Specific): Update three SCO-related URLs.

2003-02-12  Ranjit Mathew  <rmathew@hotmail.com>

	* doc/tm.texi (MODIFY_JNI_METHOD_CALL): Document.
	* config/i386/cygwin.h (MODIFY_JNI_METHOD_CALL): New macro.

2003-02-11  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Specific): Update AVR- and Darwin-related URLs.

2003-02-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/9100
	Backport patch from mainline:

	2003-01-12  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9264
	* c-lex.c (c_lex): Set the token value to error_mark_node for
	invalid numeric constants.

2003-02-11  Jan Hubicka  <jh@suse.cz>

	* i386.md (ahi?v*3): Set third operand type to TImode.
	* i386.c (ix86_expand_binop_builtin): Extend operand when needed.

	* i386.c (contains_128bit_aligned_vector_p): New function
	(ix86_function_arg_boundary): Properly align vector modes.

2003-02-11  Bob Wilson  <bob.wilson@acm.org>

	Backport following patch:

	2003-02-11  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.md (set_frame_ptr): Change rtl to set reg a7.
	* config/xtensa/xtensa.c (xtensa_reorg): Search for UNSPECV_SET_FP
	as a SET pattern.

2003-02-11  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg): Fix conversion from vector into
	integer mode.

	* rtl.def (VEC_MERGE, VEC_SELECT, VEC_CONCAT, VEC_DUPLICATE):
	Change code so they are arithmetic expressions now.
	* simplify-rtx.c (simplify_unary_operation, simplify_binary_operation,
	simplify_ternary_operation): Deal with VEC_* expressions.

2003-02-11  Richard Henderson  <rth@redhat.com>

	2003-01-15  Richard Henderson  <rth@redhat.com>
	* config/alpha/alpha.c (find_lo_sum_using_gp): Rename from find_lo_sum;
	also check that GP is being used.
	(alpha_find_lo_sum_using_gp): New.
	(alpha_does_function_need_gp): Use get_attr_usegp.
	* config/alpha/alpha-protos.h: Update.
	* config/alpha/alpha.md (attr usegp): New.  Annotate patterns
	as needed.

2003-02-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* inclhack.def (hpux_long_double, hpux10_ctype_declarations1,
	hpux10_ctype_declarations2, hpux_ctype_macros): New hacks.
	* fixincl.x: Rebuilt.
	* tests/base/stdlib.h: Update.
	* tests/base/ctype.h: New file.

2003-02-11  Janis Johnson  <janis187@us.ibm.com>

	* config/rs6000/ppc64-fp.c: New file.
	* config/rs6000/t-linux64 (LIB2FUNCS_EXTRA): Add ppc64-fp.c.

2003-02-11  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR optimization/9651
	* rtlanal.c (may_trap_p): Handle FIX.

2003-02-11  Jan Hubicka  <jh@suse.cz>

	* predict.c (choose_function_section): Choose sections correctly.

2003-02-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* reload1.c (first_label_num): New.
	(reload): Index offsets_known_at and offsets_at using difference of
	label number and first label number.  Don't use offset pointers.
	(set_label_offsets, set_initial_label_offsets): Likewise.

2003-02-10  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Christian Ehrhardt  <ehrhardt@mathematik.uni-ulm.de>

	PR c/7741
	* c-decl.c (duplicate_decls): Discard the initializer of the
	new decl when the types are conflicting.

2003-02-09  Wolfgang Bangerth  <bangerth@ticam.utexas.edu>

	* doc/install.texi: Squeeze and streamline section on
	testing and regression checking.

2003-02-07  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/t-netbsd (USER_H): Revert previous change.

2003-02-07  Richard Henderson  <rth@redhat.com>

	PR 9226
	* gcse.c (local_cprop_find_used_regs): New.
	(local_cprop_pass): Use it.

2003-02-07  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse2_nandv2di3):  Fix.

	* i386.md (movdi_rex64_1): Fix mmx<->int move opcode.

2003-02-07  Andrey Petrov <petrov@netbsd.org>

	* optabs.c (expand_float): Search wider integer modes first.

2003-02-06  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* config.gcc (hppa*-*-linux*): Set MASK_NO_SPACE_REGS in
	target_cpu_default.
	* pa.c (attr_length_call): Add 8 to call length (long indirect PA 1.X)
	if not MASK_NO_SPACE_REGS.
	(output_call): Adjust return pointer, don't load new space register
	into %sr0, and use %sr4 for call if TARGET_NO_SPACE_REGS is true.
	(pa_asm_output_mi_thunk): Don't load new space register into %sr0 if
	TARGET_NO_SPACE_REGS is true.
	* pa.md (return_external_pic): Add TARGET_NO_SPACE_REGS to insn
	conditions.
	(epilogue): Always use return_internal if TARGET_NO_SPACE_REGS is true.
	(interspace_jump): Add new pattern for when TARGET_NO_SPACE_REGS is
	true.  Use bve when TARGET_64BIT is true.

2003-02-06  Eric Botcazou <ebotcazou@libertysurf.fr>
	    Richard Henderson <rth@redhat.com>

	PR c/9530
	* config/i386/i386.h (FUNCTION_OK_FOR_SIBCALL): Forbid sibcalls
	from functions that return a float to functions that don't.

2003-02-04  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c (find_reloads): Do not use the mode specified in the insn
	pattern as reload mode for address operands.  Do not generate optional
	reloads for operands where a mandatory reload was already pushed.

2003-02-04  Jan Hubicka  <jh@suse.cz>

	* i386.md (movti_rex64):  Fix constraint.

2003-02-04  Rodney Brown  <rbrown64@csc.com.au>

	* config/i386/i386.c (x86_function_profiler): Fix typo in format.

2003-01-23  Mike Stump  <mrs@apple.com>

	* regclass.c (init_reg_autoinc): New function.
	(regclass): Move initialization of forbidden_inc_dec_class from
	here...
	(init_regs): to here.  Avoids reinitialization for each function,
	saving compilation time.

2003-02-04  Phil Edwards  <pme@gcc.gnu.org>

	* doc/install.texi (*-*-linux-gnu):  Mention glibc requirements
	for recent libstdc++.  Remove formatting cruft.

2003-02-04  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/gcc.texi, doc/gccint.texi, doc/gcov.texi,
	doc/include/fdl.texi, doc/invoke.texi: Update to GFDL 1.2.
	* doc/install.texi: Update copyright dates.  Update to GFDL 1.2.

2003-02-03  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (order_regs_for_local_alloc): Order the
	coprocessor registers before floating-point registers.
	* config/xtensa/xtensa.h (REG_ALLOC_ORDER): Adjust register numbers
	to account for a previously removed register.
	(SPEC_REG_FIRST, SPEC_REG_LAST, SPEC_REG_NUM, COUNT_REGISTER_REGNUM):
	Delete unused macros.

2003-02-03  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_store_builtin):  Always force op1 to register.
	(mov*_internal): Fix predicates; require one of operands to not be memory.
	(SSE?MMX move expanders):  Fix predicates; force one of operands to register.
	(SSE/MMX push patterns): Reorganize; fix x86-64 code generation.
	(movups/movupd/movdqu patterns): Force one of operands to not be memory.

2003-02-03  Jan Hubicka  <jh@suse.cz>

	* regclass.c (cannot_change_mode_set_regs): Correct argument order.

2003-02-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips/_tilib.c: Don't include tsystem.h.  Don't define
	LIBGCC2_WORDS_BIG_ENDIAN.

2003-02-02  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* doc/install.texi (hppa*-hp-hpux11*): Update installation notes.

2003-02-02  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa-protos.h (attr_length_millicode_call): Remove second argument.
	(attr_length_indirect_call, attr_length_indirect_call,
	attr_length_save_restore_dltp): New prototypes.
	* pa.c (attr_length_millicode_call): Remove second argument.  Check
	INSN_ADDRESSES_SET_P in distance calculation.
	(output_millicode_call): Check INSN_ADDRESSES_SET_P before using
	INSN_ADDRESSES.
	(attr_length_call): Check INSN_ADDRESSES_SET_P in distance calculation.
	(output_call): Check INSN_ADDRESSES_SET_P before using INSN_ADDRESSES.
	Call attr_length_call directly.
	(attr_length_indirect_call, output_indirect_call,
	attr_length_save_restore_dltp): New functions.
	* pa.md (attr_length_millicode_call): Drop second argument from all
	patterns.
	(return_internal_pic): Delete.
	(return_external_pic): Remove use of PIC register and pic operand and
	flag checks.
	(epilogue): Use return_internal for both normal and pic code.
	(call, call_value): Emit new 32-bit pic patterns for symref and
	indirect calls.  Remove uses for arg pointer and pic register.
	(call_symref_pic, call_symref_pic_post_reload, call_reg_pic,
	call_reg_pic_post_reload, call_val_symref_pic,
	call_val_symref_pic_post_reload, call_val_reg_pic,
	call_val_reg_pic_post_reload): New pre and post reload insn patterns.
	Implement define_split and define_peephole2 patterns for pre reload
	patterns.
	(call_symref_64bit, call_internal_reg_64bit, call_value_symref_64bit,
	call_value_internal_reg_64bit): Shorten names.
	(all call patterns): Explicitly indicate registers used and clobbered.
	Use attr_length_indirect_call and attr_length_save_restore_dltp for
	attribute length calculation.  Move code generation for indirect calls
	to output_indirect_call.
	(sibcall, sibcall_value): Don't restore PIC register.
	(exception_receiver, builtin_setjmp_receiver): Add blockage after PIC
	register retore.

2003-02-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Testing): Simplify and compress instructions
	concerning Dejagnu.

2003-02-01  Daniel Jacobowitz  <drow@mvista.com>

	* dwarf2out.c (gen_type_die): Check for typedefs before calling
	for TYPE_MAIN_VARIANT.

2003-02-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c: Revert 2003-01-31 change.

2003-02-01  Jan Hubicka  <jh@suse.cz>

	PR c/9506
	* i386.c (override_options): Use DEFAULT_PCC_STRUCT_RETURN.

2003-01-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (pa_output_function_prologue, pa_output_function_epilogue): Move
	updating of total_code_bytes from prologue to epilogue.

2003-01-31  Ulrich Weigand  <uweigand@de.ibm.com>

	* regclass.c (record_reg_classes): Fix incorrect argument
	to EXTRA_ADDRESS_CONSTRAINT macro.

2003-01-31  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c (find_reloads): Do not use the mode specified in the insn
	pattern as reload mode for address operands.  Do not generate optional
	reloads for operands where a mandatory reload was already pushed.
	Generate optional reloads only in the final pass though find_reloads.
	(have_replacement_p): New function.

2003-01-31  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Testing): Remove a reference to our obsolete
	/testresults web pages and strip redundant information concerning
	test results.
	(Binaries): Refer to Microsoft Windows instead of listing all
	possible variants.

2003-02-01  Jan Hubicka  <jh@suse.cz>

	* loop.c (emit_prefetch_instructions):  Do conversion at right place in
	RTL chain.

	* combine.c (simplify_set): Reverse order of ragumetns to
	REG_CANNOT_CHANGE_MODE_P
	* df.c (df_def_record_1): Likewise.
	* recog.c (register_operand): Likewise.
	* simplify-rtx.c (simplify_subreg): Likewise.
	* hard-reg-set.h (REG_CANNOT_CHANGE_MODE_P): Update use of
	CANNOT_CHANGE_MODE_CLASS.
	* regclass.c (cannot_change_mode_set_regs, invalid_mode_change_p):
	Likewise.
	* reload.c (push_reload): Likewise.
	* alpha.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* ia64.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* mips.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* mips-protos.h (mips_cannot_change_mode_class): Update prototype.
	* mips.c (mips_cannot_change_mode_class): Update.
	* pa64-regs.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* rs6000.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* s390.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* sh.h (CANNOT_CHANGE_MODE_CLASS): Update definition.
	* sh-protos.h (sh_cannot_change_mode_class): Update prototype.
	* sh.c (sh_cannot_change_mode_class): Update.
	* i386.h (CANNOT_CHANGE_MODE_CLASS): New.
	* tm.texi (CANNOT_CHANGE_MODE_CLASS): Update documentation.

2003-01-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa32-regs.h (REGNO_REG_CLASS, REG_CLASS_FROM_LETTER): Delete
	duplicated code.

2003-01-30  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_compute_initial_elimination_offset): If optimizing for
	size, the link register is always saved if any other register is
	saved.

2003-01-30  Jerry Quinn  <jlquinn@optonline.net>

	* gcc/doc/invoke.texi (Optimization Options): Group together
	optional and experimental flags.  Move trapv and bounds-check
	out of this section.  Group floating point flags together.
	(Code Gen Options): Move trapv and bounds-check to here.

2003-01-30  Jerry Quinn  <jlquinn@optonline.net>

	* gcc/doc/invoke.texi (Optimization Options): List -O levels
	for each optimization flag.

2003-01-30  Ralf Corsepius  <corsepiu@faw.uni-ulm.de>

	PR target/9316
	* config/rs6000/rtems.h: Add CPP_OS_DEFAULT_SPEC.
	* config/rs6000/sysv4.h: Add CPP_OS_RTEMS_SPEC.
	* config/rs6000/t-rtems: New file. multilib variants to match OS.
	* config.gcc (powerpc-*-rtems*): Use rs6000/t-rtems instead of
	rs6000/t-ppcgas so we get the desired multilibs.

2003-01-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/fp-bit.h (__make_dp): Declare if TMODES.

2003-01-29	Steve Ellcey <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_rwreloc_section_type_flags): New.
	* config/ia64/hpux.h (TARGET_SECTION_TYPE_FLAGS): New.

2003-01-29	Steve Ellcey <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_rwreloc_select_rtx_section): Rename
	from ia64_aix_select_rtx_section.
	(ia64_rwreloc_select_section): Simlarly; use default*_1 function
	instead of saving and restoring flag_pic.
	(ia64_rwreloc_unique_section): Similarly.
	* config/ia64/aix.h (TARGET_ASM_SELECT_SECTION,
	TARGET_ASM_UNIQUE_SECTION, TARGET_ASM_SELECT_RTX_SECTION): Update.
	* config/ia64/hpux.h (TARGET_ASM_SELECT_SECTION,
	TARGET_ASM_UNIQUE_SECTION, TARGET_ASM_SELECT_RTX_SECTION): New.

2003-01-29  Joel Sherrill  <joel@OARcorp.com>

	PR bootstrap/9296
	* gthr-rtems.h: Define __GTHREAD_MUTEX_INIT.  Apparently no code
	depended on it being defined until now.

2003-01-29  Joel Sherrill  <joel@OARcorp.com>

	PR target/9295
	* config/mips/rtems.h: Predefine __USE_INIT_FINI__ so generic
	RTEMS code knows which C++ initialization style the toolset
	configuration is using.

2003-01-29  Joel Sherrill  <joel@OARcorp.com>

	PR bootstrap/9293
	* config/m68k/t-crtstuff: Replace spaces with tabs, add
	 $(MULTILIB_CFLAGS) as compiler option and multilib crtbegin/end.o.

2003-01-29  Joel Sherrill  <joel@OARcorp.com>

	PR bootstrap/9292
	* config.gcc (hppa1.1-rtems):  Did not include t-rtems nor enable
	RTEMS threads.
	* config/pa/rtems.h (LIB_SPEC): Use -N when linking.

2003-01-25  Andrew Haley  <aph@redhat.com>

	* tree-inline.c (walk_tree): Add CHAR_TYPE.

2003-01-28  Christian Cornelssen  <ccorn@cs.tu-berlin.de>

	* doc/install.texi: Add documentation for installation into
	tooldirs and with DESTDIR.

2003-01-28  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.md (tablejump+2): Don't sign extend an address
	register.
	* config/m68k/apollo68.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/coff.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/linux.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/m68kelf.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/mot3300.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/netbsd-elf.h (ASM_RETURN_CASE_JUMP): Likewise.
	* config/m68k/pbb.h (ASM_RETURN_CASE_JUMP): Likewise.

2003-01-28  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (movti_string): Remove clobber.
	* config/rs6000/rs6000.c (rs6000_emit_move, TImode): Explicitly
	generate PARALLEL with clobber for TARGET_POWER.

2003-01-28  Richard Henderson  <rth@redhat.com>

	* ifcvt.c (noce_process_if_block): Re-add check vs X being changed
	in no-else-block case.  Add commentary.

2003-01-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.h (UNITS_PER_HWFPVALUE): Renamed from...
	(UNITS_PER_FPVALUE): Defined as the width of a long double, or
	zero if no hardware floating point.
	(LONG_DUBLE_TYPE_SIZE): Set to 128 on N32 and N64.
	(MAX_FIXED_MODE_SIZE): Define to LONG_DOUBLE_TYPE_SIZE.
	(LIBGCC2_LONG_DOUBLE_TYPE_SIZE): Define.
	(BIGGEST_ALIGNMENT): Same as LONG_DOUBLE_TYPE_SIZE.
	(FUNCTION_VALUE_REGNO_P): Set for FP_RETURN+2 on N32 and N64.
	* config/mips/iris6.h (MIPS_TFMODE_FORMAT): Define.
	* config/mips/mips.c (override_options): Use it.
	(mips_arg_info): Pass TFmode values in even FP registers on N32
	and N64.
	(mips_setup_incoming_varargs): Use UNITS_PER_HWFPVALUE.
	(mips_va_start): Adjust alignment of ARG_POINTER_REGNUM.
	(mips_va_arg): Use UNITS_PER_HWFPVALUE.  Impose additional
	even-register-like alignment to 128-bit arguments.
	(save_restore_insns): Use UNITS_PER_HWFPVALUE.
	(mips_function_value): Likewise.  Return TFmode in $f0 and $f2
	on N32 or N64.
	* config/mips/_tilib.c (__negti2, __ashlti3, __lshrti3): New.
	* config/mips/t-iris6 (LIB2FUNCS_EXTRA): Add _tilib.c.
	(TPBIT): Set to tp-bit.c.
	(tp-bit.c): Create out of fp-bit.c.

2003-01-27  Gabriel Dos_Reis  <gdosreis@sophia.inria.fr>

	* c-parse.in: Remove '%expect 32' directive when in objc mode.

2003-01-27  Josef Zlomek  <zlomekj@suse.cz>

	* gcse.c (constprop_register): Check NEXT_INSN (insn) != NULL.

2003-01-27  Richard Earnshaw  <rearnsha@arm.com>

	PR optimization/9090
	* function.c (purge_addressof_1): After pushing an addressed register
	onto the stack, simplify the result.

2003-01-27  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* doc/extend.texi: Fix typo.

2003-01-27  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* doc/cppopts.texi: Fix typo.
	* doc/objc.texi: Likewise.
	* doc/passes.texi: Likewise.

2003-01-27  Alexandre Oliva  <aoliva@redhat.com>

	* real.c (ibm_extended_format): Add 53 to minimum exponent.
	(encode_ibm_extended): Adjust.

2003-01-26  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/gccint.texi: Update the copyright.

2003-01-26  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/cpp.texi: Fix typos.
	* doc/extend.texi: Likewise.
	* doc/gty.texi: Likewise.
	* doc/install.texi: Likewise.
	* doc/passes.texi: Likewise.
	* doc/rtl.texi: Likewise.

2003-01-26  Christian Cornelssen  <ccorn@cs.tu-berlin.de>

